
# No usa ORACLE PROC

use_oracle = 0

# Primero definimos cual es el sistema operativo sobre el cual estamos
# trabajando

osname := $(shell uname -a|cut -d' ' -f1|tr -d "-" )

ifeq ($(osname),PW32)
EXE = .exe
.SUFFIXES: .cpp .dll .rc .res
else
.SUFFIXES: .cpp .so .rc .res
EXE =
endif

# Encuentra el directorio donde se encuentran los fuentes de desarrollo
# de mitosys: Que es el $MITOSYS_DIR del usuario mitosys.

use_gtk20 = 0
ifeq ($(osname),PW32)
#MITOSYS_DIR := /mnt_D/usr/mitosys
use_gtk20 = 1
AWK = awk
else
osvers := $(shell uname -a|cut -d' ' -f3)
#MITOSYS_DIR := $(shell awk -F: '$$1=="mitosys" {print $$6}' /etc/passwd)
#export MITOSYS_DIR
AWK = awk
endif

SOEXT = so
ifeq ($(osname),PW32)
SOEXT = dll
endif
export SOEXT

# Encontramos cual es el comando TAR

TAR = tar
GREP = grep
ifeq ($(osname),SunOS)
GREP := /usr/xpg4/bin/grep
endif
ITAR = -R
ifeq ($(osname),SunOS)
ITAR := -I
endif

# COFF object format?
COFF = 0
ifeq ($(osname),SCO_SV)
COFF = 1
endif

# Multithread environment?
MT = 0
ifeq ($(osname),SCO_SV)
MT = 1
endif

use_pic = 1
debug = 0
ifeq ($(osname),SCO_SV)
LDEXPORT = -Wl,-Bexport
endif

ifeq ($(osname),UnixWare)
LDEXPORT = -Wl,-Bexport
endif

ifeq ($(osname),Linux)
LDEXPORT = -export-dynamic
endif

ifeq ($(osname),SCO_SV)
NO_EXCEPTIONS = -fno-exceptions
endif

ifeq ($(osname),Linux)
NO_EXCEPTIONS = -fno-exceptions
endif
# Contiene la lista de los objetos que se deben excluir del tar

EXCLUDES =
#ifeq ($(osname),Linux)
EXCLUDES += --exclude='*.o'
EXCLUDES += --exclude=*.a
EXCLUDES += --exclude=*.(SOEXT)
EXCLUDES += --exclude=*.4ge
EXCLUDES += --exclude=*.frm
#EXCLUDES += -X $(MITOSYS_DIR)/Excludes.tar
#endif

#NO_IMPLICIT_TEMPLATES = -DACE_HAS_GNU_REPO

# Usamos las macros de las librerias de ACE.

#include $(ACE_ROOT)/include/makeinclude/platform_macros.GNU
include $(ACE_ROOT)/include/makeinclude/wrapper_macros.GNU
ifeq ($(use_oracle),1)
include $(MITOSYS_DIR)/hpux-9.2.x.mk
endif

ifndef SOLINK
SOLINK = $(DLD)
endif

LIBACE = ACE

subsetting = 0

shared_curses = 1
shared_mfglgo = 1

ifeq ($(osname),SCO_SV)
shared_curses = 0
shared_mfglgo = 0
endif

ifeq ($(osname),UnixWare)
shared_curses = 0
shared_mfglgo = 0
endif

ifeq ($(osname),OpenUNIX)
shared_curses = 0
shared_mfglgo = 0
endif

ifeq ($(osname),PW32)
shared_curses = 0
shared_mfglgo = 0
endif

ifeq ($(osname),Linux)
#LIBACE := ACE5.1
#LIBACE := ACE4.6.46
endif

ifeq ($(osname),OSF1)
LIBACE := ACE
endif

ifeq ($(osname),SCO_SV)
#LIBACE = ACE4.6.43
endif

LIBGTHREADS = gthreads3.8
# LIBGTHREADS = gthreads3.9

BINDIR_static=$(MITOSYS_DIR)/bin
export BINDIR_static
BINDIR_coff=$(MITOSYS_DIR)/bin
export BINDIR_coff
BINDIR_so=$(MITOSYS_DIR)/bin
export BINDIR_so
BINDIR_INFORMIX=$(MITOSYS_DIR)/bin
export BINDIR_INFORMIX
BINDIR_ODBC=$(MITOSYS_DIR)/ODBC/bin
export BINDIR_ODBC
MLIBDIR_static=$(MITOSYS_DIR)/lib
export MLIBDIR_static
MLIBDIR_mtstatic=$(MITOSYS_DIR)/mtlib
export MLIBDIR_mtstatic
MLIBDIR_so=$(MITOSYS_DIR)/lib
export MLIBDIR_so
MLIBDIR_mtso=$(MITOSYS_DIR)/mtlib
export MLIBDIR_mtso
MLIBDIR_coff=$(MITOSYS_DIR)/coff
export MLIBDIR_coff
MLIBDIR_INFORMIX=$(MITOSYS_DIR)/INFORMIX
export MLIBDIR_INFORMIX
MLIBDIR_ODBC=$(MITOSYS_DIR)/ODBC
export MLIBDIR_ODBC
MLIBDIR=$(MLIBDIR_$(MODEL)) 
SHARED_DIR_static=$(MITOSYS_DIR)/shareds$(VER)
export SHARED_DIR_static
SHARED_DIR_mtstatic=$(MITOSYS_DIR)/mtshareds$(VER)
export SHARED_DIR_mtstatic
SHARED_DIR_so=$(MITOSYS_DIR)/shareds$(VER)
export SHARED_DIR_so
SHARED_DIR_mtso=$(MITOSYS_DIR)/mtshareds$(VER)
export SHARED_DIR_mtso
SHARED_DIR_coff=$(MITOSYS_DIR)/coff
export SHARED_DIR_coff
SHARED_DIR_INFORMIX=$(MITOSYS_DIR)/INFORMIX
export SHARED_DIR_INFORMIX
SHARED_DIR_ODBC=$(MITOSYS_DIR)/ODBC
export SHARED_DIR_ODBC
SHARED_DIR=$(SHARED_DIR_$(MODEL)) 

MODEL=so

ifneq ($(osname),PW32)
FLAGS += -DUNIX
endif

ifeq ($(osname),OSF1)
FLAGS += -DOSF1
CFLAGS += -DOSF1
endif

ifeq ($(osname),HPUX)
FLAGS += +DD64
CFLAGS += +DD64
endif

ifeq ($(osname),SCO_SV)
FLAGS += -Wall
endif

ifneq ($(osname),OSF1)
CFLAGS += -D$(osname)
endif

ifeq ($(osname),UnixWare)
CFLAGS += -m486
endif
ifeq ($(osname),PW32)
CFLAGS += -DWIN32
CFLAGS += -fnative-struct
endif
CFLAGS-INFORMIX = $(CFLAGS) $(PIC) -DNOMACROS -I $(INFORMIXDIR)/incl
CCFLAGS-INFORMIX =  $(CPPFLAGS) $(CFLAGS) $(PIC) -DNOMACROS -I $(INFORMIXDIR)/incl
CFLAGS-ODBC = $(CFLAGS) $(PIC) -DODBC -DNOMACROS 
CCFLAGS-ODBC = $(CPPFLAGS) $(CCFLAGS) $(PIC) -DODBC -DNOMACROS 
CFLAGS-coff = -mcoff -m386
CCFLAGS-coff = $(CPPFLAGS) -mcoff -m386
CFLAGS-static = 
CFLAGS-static += $(CPPFLAGS) $(CFLAGS) 
ifneq ($(osname),SunOS)
CFLAGS-static += $(PIC)
endif
# $(CFLAGS-ODBC)
CCFLAGS-static = $(CPPFLAGS) $(CCFLAGS) $(PIC)
# $(CCFLAGS-ODBC)
CFLAGS-so = 
CFLAGS-so += $(CFLAGS) 
ifneq ($(osname),SunOS)
CFLAGS-so += $(PIC)
endif
CCFLAGS-so = $(CPPFLAGS) $(CCFLAGS) $(PIC)
# $(CCFLAGS-ODBC)
CFLAGS-mtso =
CFLAGS-mtso += $(CFLAGS)
ifneq ($(osname),SunOS)
CFLAGS-mtso += $(PIC)
endif
# $(CFLAGS-ODBC)
CCFLAGS-mtso = $(CCFLAGS) $(PIC)
# $(CCFLAGS-ODBC)

DBDRIVER-coff = ODBC
DBDRIVER-static = ODBC
DBDRIVER-so = ODBC
DBDRIVER-INFORMIX = INFORMIX
DBDRIVER-ODBC = ODBC
DBDRIVER = $(DBDRIVER-$(MODEL))

OODB_DIR = $(MITOSYS_DIR)/OODB
MSVC_DIR = $(MITOSYS_DIR)/msvc

DIR-coff = coff
DIR-INFORMIX = INFORMIX
DIR-ODBC = ODBC
DIR-static = static
DIR-so = so
DIR-mtso = mtso
DIR-mtstatic = mtstatic
NODEBDIR = $(DIR-$(VERSION)$(MODEL))
ifeq ($(debug),1)
DIR = $(DIR-$(VERSION)$(MODEL))/debug
else
DIR = $(NODEBDIR)
endif
# DIR = $(DIR-$(MODEL))

ifndef MODELS
ifeq ($(osname),OSF1)
MODELS = so static
endif
endif

MVCMD = 
$(DIR)/%.o:	%.cpp
	test -d $(@D) || mkdir $(@D)
	$(CXX) $(COMPILE.cc) -o $@ $<

%_dict.cpp:	%.h
#	export GCCXML_USER_FLAGS="`optfilter $(COMPILE.cc)`"; lcgdict $<
	lcgdict $< --reflex "`optfilter $(COMPILE.cc)`"

$(DIR)/%.o:	%.class
	gcj -c -o $@ $<

$(DIR)/%.o:	%.c
	test -d $(@D) || mkdir $(@D)
	$(CC) $(COMPILE.c) -o $@ $<

$(DIR)/%.o: %.pc
	$(PROC) $(PROCFLAGS) iname=$< oname=$(addsuffix .c,$(basename $< .pc))
	make MODEL="$(MODEL)" DIR="$(DIR)" use_oracle=1 $@
	@rm $(addsuffix .c,$(basename $< .pc))

%.class:	%.java
	gcj -C $<

%.h:	%.class
	gcjh $*

install-models:
	for model in `echo $$MODELS`; do \
	   libdir=`eval "echo '$$'MLIBDIR_$$model"` ; \
	   libdir=`eval "echo $$libdir"` ; \
	   if [ "$${debug:-0}" -eq "1" ]; \
	   then \
	      test -d $$libdir || mkdir $$libdir ; \
	      libdir=$$libdir/debug ; \
	   fi ; \
	   test -d $$libdir || mkdir $$libdir ; \
	   make MODEL=$$model create.dir ; \
	   case $$model in \
	   so) \
	       mv $$libdir/$$GOAL.$$SOEXT ./ ; \
	       make MODEL=$$model $$GOAL.$$SOEXT ; \
	       mv $$GOAL.$$SOEXT $$libdir ; \
	       if [ "$(osname)" = PW32 ]; then \
	       test -r $$GOAL.$$SOEXT.a && mv $$GOAL.$$SOEXT.a $$libdir ; \
	       fi ;; \
	   mtso) \
	       mv $$libdir/$$GOAL-mt.$$SOEXT ./ ; \
	       make MODEL=$$model $$GOAL-mt.$$SOEXT ; \
	       mv $$GOAL-mt.$$SOEXT $$libdir ;; \
	    ODBC|INFORMIX) \
	       mv $$libdir/$$GOAL.a ./ ; \
	       make MODEL=$$model $$GOAL.a ; \
	       mv $$GOAL.a $$libdir ; \
	       mv $$libdir/$$GOAL.$$SOEXT ./ ; \
	       make MODEL=$$model $$GOAL.$$SOEXT ; \
	       mv $$GOAL.$$SOEXT $$libdir ;; \
	    *) \
	       mv $$libdir/$$GOAL.a ./ ; \
	       make MODEL=$$model $$GOAL.a ; \
	       mv $$GOAL.a $$libdir ;; \
	   esac ; \
	done

shared-models:
	for model in `echo $$MODELS`; do \
	   shared_dir=`eval "echo '$$'SHARED_DIR_$$model"` ; \
	   shared_dir=`eval "echo $$shared_dir"` ; \
	   test -d $$shared_dir || mkdir $$shared_dir ; \
	   echo $(SHAREDS)|$(AWK) '{for (i=1; i<=NF; i++) print $$i}' | while read shared ; do \
	     mv $$shared_dir/$$shared ./ ; \
	     make MODEL=$$model $$shared ; \
	     mv $$shared $$shared_dir ; \
           done \
	done

build-binaries:
	for model in $(MODELS); do \
	   test -d $$model || mkdir $$model; \
	   bindir=`eval "echo '$$'BINDIR_$$model"` ; \
	   bindir=`eval "echo $$bindir"` ; \
	   if [ "$${debug:-0}" -eq "1" ]; \
	   then \
	      test -d $$bindir || mkdir $$bindir ; \
	      bindir=$$bindir/debug ; \
	   fi ; \
	   test -d $$bindir || mkdir $$bindir ; \
	   for binary in `echo $(BINARIES)`; do \
	     mv $$bindir/$$binary ./ ; \
	     make debug="$$debug" MODEL=$$model $$binary ; \
	     mv $$binary $$bindir ; \
	done ; \
	done

########################################################################
# Build the library from the up-to-date objs

create.dir:
	test -d $(NODEBDIR) || mkdir $(NODEBDIR)
	test -d $(DIR) || mkdir $(DIR)
