#ifndef __MGRAMMAR_ANTLRTOKDEFLEXER_H__
#define __MGRAMMAR_ANTLRTOKDEFLEXER_H__
#include "MLANG/SmartPtr.h"
#include "MLANG/String.h"
#include "MParser/BitSet.h"
#include "MParser/Token.h"
#include "MIO/InputStream.h"
#include "MParser/InputBuffer.h"
#include "MParser/LexerSharedInputState.h"
#include "MGrammar/ANTLRTokdefParserTokenTypes.h"
#include "MParser/CharScanner.h"

class ANTLRTokdefLexer;
typedef class ANTLRTokdefLexer *ANTLRTokdefLexer_ptr;

class ANTLRTokdefLexer : public MParser_CharScanner,
                         public ANTLRTokdefParserTokenTypes
{
public:
   typedef MParser_CharScanner super;
public:
   ANTLRTokdefLexer(const MIO_InputStream_var& in);
public:
   ANTLRTokdefLexer(const MIO_Reader_var& in);
public:
   ANTLRTokdefLexer(const MParser_InputBuffer_var& ib);
public:
   ANTLRTokdefLexer(const MParser_LexerSharedInputState_var& state);
public:
   virtual ~ANTLRTokdefLexer();
public:
   static bool is_nil (ANTLRTokdefLexer_ptr lexer)
   { return lexer == 0; }

   static ANTLRTokdefLexer_ptr _nil()
   { return 0; }

   static ANTLRTokdefLexer_ptr _duplicate(ANTLRTokdefLexer_ptr lexer)
   { return ::MLANG_acquire(lexer); }
public:
   MParser_Token_var nextToken();
public:
   void mWS(bool createToken);
public:
   void mSL_COMMENT(bool createToken);
public:
   void mML_COMMENT(bool createToken);
public:
   void mLPAREN(bool createToken);
public:
   void mRPAREN(bool createToken);
public:
   void mASSIGN(bool createToken);
public:
   void mSTRING(bool createToken);
protected:
   void mESC(bool createToken);
protected:
   void mDIGIT(bool createToken);
protected:
   void mXDIGIT(bool createToken);
public:
   void mID(bool createToken);
public:
   void mINT(bool createToken);
private:
   static longArray mk_tokenSet_0();
public:
   static MParser_BitSet _tokenSet_0;
private:
   static longArray mk_tokenSet_1();
public:
   static MParser_BitSet _tokenSet_1;
private:
   static longArray mk_tokenSet_2();
public:
   static MParser_BitSet _tokenSet_2;
private:
   static longArray mk_tokenSet_3();
public:
   static MParser_BitSet _tokenSet_3;
};

typedef MLANG_SmartPtr<ANTLRTokdefLexer> ANTLRTokdefLexer_var;

#endif /* __MGRAMMAR_ANTLRTOKDEFLEXER_H__ */
