#ifndef __MGRAMMAR_ANTLRTOKDEFPARSER_H__
#define __MGRAMMAR_ANTLRTOKDEFPARSER_H__
#include "MLANG/SmartPtr.h"
#include "MLANG/String.h"
#include "MParser/BitSet.h"
#include "MParser/TokenStream.h"
#include "MParser/TokenBuffer.h"
#include "MParser/ParserSharedInputState.h"
#include "MParser/RecognitionException.h"
#include "MParser/LLkParser.h"
#include "MGrammar/ImportVocabTokenManager.h"
#include "MGrammar/ANTLRTokdefParserTokenTypes.h"
#include "MGrammar/Tool.h"

class ANTLRTokdefParser;
typedef class ANTLRTokdefParser *ANTLRTokdefParser_ptr;

/** Simple lexer/parser for reading token definition files
  in support of the import/export vocab option for grammars.
 */
class ANTLRTokdefParser : public MParser_LLkParser,
                          public ANTLRTokdefParserTokenTypes
{
public:
   typedef MParser_LLkParser super;
   // This chunk of error reporting code provided by Brian Smith

private:
   MGrammar_Tool_ptr antlrTool_;

    /** In order to make it so existing subclasses don't break, we won't require
     * that the antlr.Tool instance be passed as a constructor element. Instead,
     * the antlr.Tool instance should register itself via;@link #initTool(antlr.Tool)}
     * @throws IllegalStateException if a tool has already been registered
     * @since 2.7.2
     */
public:
   void setTool(MGrammar_Tool_ptr tool);
    /** @since 2.7.2 */
protected:
   MGrammar_Tool_ptr getTool() const
   {
      return antlrTool_;
   }

    /** Delegates the error message to the tool if any was registered via
     * ;@link #initTool(antlr.Tool)}
     *  @since 2.7.2
     */
public:
   void reportError(const MLANG_String& s);
    /** Delegates the error message to the tool if any was registered via
     * ;@link #initTool(antlr.Tool)}
     *  @since 2.7.2
     */
public:
   void reportError(MParser_RecognitionException& e);
    /** Delegates the warning message to the tool if any was registered via
     * ;@link #initTool(antlr.Tool)}
     *  @since 2.7.2
     */
public:
   void reportWarning(const MLANG_String& s);
public:
   ANTLRTokdefParser(const MParser_TokenBuffer_var& tokenBuf, int k = 2);
public:
   ANTLRTokdefParser(const MParser_TokenStream_var& lexer, int k = 2);
public:
   ANTLRTokdefParser(const MParser_ParserSharedInputState_var& state);
public:
   virtual ~ANTLRTokdefParser();
public:
   static bool is_nil (ANTLRTokdefParser_ptr parser)
   { return parser == 0; }

   static ANTLRTokdefParser_ptr _nil()
   { return 0; }

   static ANTLRTokdefParser_ptr _duplicate(ANTLRTokdefParser_ptr parser)
   { return ::MLANG_acquire(parser); }
public:
   void file (
      MGrammar_ImportVocabTokenManager_ptr tm
    );
public:
   void line (
      MGrammar_ImportVocabTokenManager_ptr tm
    );
public:
   static const char *_tokenNames[];
public:
   static longArray mk_tokenSet_0();
public:
   static MParser_BitSet _tokenSet_0;
public:
   static longArray mk_tokenSet_1();
public:
   static MParser_BitSet _tokenSet_1;
};

typedef MLANG_SmartPtr<ANTLRTokdefParser> ANTLRTokdefParser_var;

#endif /* __MGRAMMAR_ANTLRTOKDEFPARSER_H__ */
