#include "MGrammar/Grammar.h"
#include "MGrammar/CodeGenerator.h"
#include "MGrammar/ActionElement.h"

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/ActionElement.java#1 $
 */

MGrammar_ActionElement::MGrammar_ActionElement (
   MGrammar_Grammar_ptr g,
   const MParser_Token_var& t
) : MGrammar_AlternativeElement(g),
    actionText_(t->getText()),
    isSemPred_(false)

{
   line_ = t->getLine();
   column_ = t->getColumn();
}

void MGrammar_ActionElement::generate()

{
   grammar_->generator_->gen(this);
}

MGrammar_Lookahead MGrammar_ActionElement::look(int k)

{
   return grammar_->theLLkAnalyzer_->look(k, this);
}

MLANG_String MGrammar_ActionElement::toString() const

{
  return " " + actionText_ + (isSemPred_?"?":"");
}

MGrammar_ActionElement::~MGrammar_ActionElement ()

{
}
