#ifndef __MGRAMMAR_ACTIONELEMENT_H__
#define __MGRAMMAR_ACTIONELEMENT_H__
#include "MLANG/SmartPtr.h"
#include "MLANG/String.h"
#include "MParser/Token.h"
#include "MGrammar/Lookahead.h"
#include "MGrammar/AlternativeElement.h"

class MGrammar_ActionElement;
typedef class MGrammar_ActionElement *MGrammar_ActionElement_ptr;

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/ActionElement.java#1 $
 */

class MGrammar_ActionElement : public MGrammar_AlternativeElement
{
protected:
    MLANG_String actionText_;
    bool isSemPred_;
public:
    MGrammar_ActionElement (
       MGrammar_Grammar_ptr g,
       const MParser_Token_var& t
     );

    virtual ~MGrammar_ActionElement();

public:

   static bool is_nil (MGrammar_ActionElement_ptr a)
   { return a == 0; }

   static MGrammar_ActionElement_ptr _nil()
   { return 0; }

   static MGrammar_ActionElement_ptr _duplicate(MGrammar_ActionElement_ptr element)
   { return ::MLANG_acquire(element); }

public:

    const MLANG_String& actionText() const
    { return actionText_; }

    MGrammar_ActionElement& actionText(const MLANG_String& value) 
    { actionText_ = value; return *this; }

    bool isSemPred() const
    { return isSemPred_; }

    MGrammar_ActionElement& isSemPred(bool value)
    { isSemPred_ = value; return *this; }

public:

    void generate();

    MGrammar_Lookahead look(int k);

    MLANG_String toString() const;
};

typedef MLANG_SmartPtr<MGrammar_ActionElement> MGrammar_ActionElement_var;

#endif /* __MGRAMMAR_ACTIONELEMENT_H__ */
