#ifndef __MGRAMMAR_ALTERNATIVEELEMENT_H__
#define __MGRAMMAR_ALTERNATIVEELEMENT_H__
#include "MLANG/SmartPtr.h"
#include "MLANG/String.h"
#include "MGrammar/GrammarElement.h"

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/AlternativeElement.java#1 $
 */

class MGrammar_AlternativeElement;
typedef class MGrammar_AlternativeElement *MGrammar_AlternativeElement_ptr;
typedef MLANG_SmartPtr<MGrammar_AlternativeElement> MGrammar_AlternativeElement_var;

class MGrammar_AlternativeElement : public MGrammar_GrammarElement

{
public:

    MGrammar_AlternativeElement_var next_;
    int autoGenType_;

    MLANG_String enclosingRuleName_;

public:

    MGrammar_AlternativeElement (
      MGrammar_Grammar_ptr g
    );

    MGrammar_AlternativeElement (
       MGrammar_Grammar_ptr g, 
       const MParser_Token_var& start,
       int autoGenType = AUTO_GEN_NONE
     );

   virtual ~MGrammar_AlternativeElement();

public:

   static bool is_nil (MGrammar_AlternativeElement_ptr a)
   { return a == 0; }

   static MGrammar_AlternativeElement_ptr _nil()
   { return 0; }

   static MGrammar_AlternativeElement_ptr _duplicate(MGrammar_AlternativeElement_ptr e)
   { return ::MLANG_acquire(e); }

public:

    int getAutoGenType() const
    {
        return autoGenType_;
    }

    void setAutoGenType(int a) 
    {
        autoGenType_ = a;
    }

    const MLANG_String& enclosingRuleName() const
    { return enclosingRuleName_; }

    MGrammar_AlternativeElement& enclosingRuleName(const MLANG_String& value)
    { enclosingRuleName_ = value; return *this; }

    virtual MLANG_String getLabel() 
    {
        return "";
    }

    virtual void setLabel(const MLANG_String& )
    {
    }
};

#endif /* __MGRAMMAR_ALTERNATIVEELEMENT_H__ */
