#include "MGrammar/Grammar.h"
#include "MGrammar/BlockEndElement.h"

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/BlockEndElement.java#1 $
 */

/**All alternative blocks are "terminated" by BlockEndElements unless
 * they are rule blocks (in which case they use RuleEndElement).
 */
MGrammar_BlockEndElement::MGrammar_BlockEndElement(MGrammar_Grammar_ptr g)
  : MGrammar_AlternativeElement (g)
{
   lock_.resize(g->maxk_ + 1, false);
   for (size_t i=0; i<lock_.size(); i++)
       lock_[i] = false;
}

MGrammar_Lookahead MGrammar_BlockEndElement::look(int k) 

{
   return grammar_->theLLkAnalyzer_->look(k, this);
}

MLANG_String MGrammar_BlockEndElement::toString() const

{
   //return " [BlkEnd]";
   return "";
}

MGrammar_BlockEndElement::~MGrammar_BlockEndElement()

{
}
