#ifndef __MPARSER_BLOCKENEDLEMENT_H__
#define __MPARSER_BLOCKENEDLEMENT_H__
#include "ace/Vector_T.h"
#include "MLANG/SmartPtr.h"
#include "MGrammar/Lookahead.h"
#include "MGrammar/AlternativeElement.h"
#include "MGrammar/AlternativeBlock.h"

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/BlockEndElement.java#1 $
 */

class MGrammar_BlockEndElement;
typedef class MGrammar_BlockEndElement *MGrammar_BlockEndElement_ptr;

/**All alternative blocks are "terminated" by BlockEndElements unless
 * they are rule blocks (in which case they use RuleEndElement).
 */
class MGrammar_BlockEndElement : public MGrammar_AlternativeElement
{
public:
    ACE_Vector<bool> lock_;	// for analysis; used to avoid infinite loops
    MGrammar_AlternativeBlock_var block_;// ending blocks know what block they terminate

public:

    MGrammar_BlockEndElement(MGrammar_Grammar_ptr g);

    virtual ~MGrammar_BlockEndElement();

public:
   static bool is_nil (MGrammar_BlockEndElement_ptr element)
   { return element == 0; }

   static MGrammar_BlockEndElement_ptr _nil()
   { return 0; }

   static MGrammar_BlockEndElement_ptr _duplicate(MGrammar_BlockEndElement_ptr element)
   { return ::MLANG_acquire(element); }
public:

    MGrammar_Lookahead look(int k);

    MLANG_String toString() const;
};

typedef MLANG_SmartPtr<MGrammar_BlockEndElement> MGrammar_BlockEndElement_var;

#endif /* __MPARSER_BLOCKENEDLEMENT_H__ */
