#ifndef __MPARSER_BLOCKWITHIMPLEDEXITPATH_H__
#define __MPARSER_BLOCKWITHIMPLEDEXITPATH_H__
#include "MLANG/Vector_T.h"
#include "MLANG/SmartPtr.h"
#include "MGrammar/Lookahead.h"
#include "MParser/Token.h"
#include "MGrammar/AlternativeBlock.h"

class MGrammar_BlockWithImpliedExitPath;
typedef class MGrammar_BlockWithImpliedExitPath *MGrammar_BlockWithImpliedExitPath_ptr;

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/BlockWithImpliedExitPath.java#1 $
 */

class MGrammar_BlockWithImpliedExitPath : public MGrammar_AlternativeBlock

{
public:
    int exitLookaheadDepth_;	// lookahead needed to handle optional path
    /** lookahead to bypass block; set
     * by deterministic().  1..k of Lookahead
     */
    MLANG_Vector<MGrammar_Lookahead> exitCache_;

public:

    MGrammar_BlockWithImpliedExitPath(MGrammar_Grammar_ptr g);

    MGrammar_BlockWithImpliedExitPath (
       MGrammar_Grammar_ptr g,
       const MParser_Token_var& start
     );
    virtual ~MGrammar_BlockWithImpliedExitPath();
public:
    int exitLookaheadDepth() const
    { return exitLookaheadDepth_; }

    const MLANG_Vector<MGrammar_Lookahead>& exitCache() const
    { return exitCache_; }
};

typedef MLANG_SmartPtr<MGrammar_BlockWithImpliedExitPath> MGrammar_BlockWithImpliedExitPath_var;

#endif /* __MPARSER_BLOCKWITHIMPLEDEXITPATH_H__ */
