#include "MGrammar/ANTLRLexer.h"
#include "MGrammar/CodeGenerator.h"
#include "MGrammar/CharLiteralElement.h"

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/CharLiteralElement.java#1 $
 */

MGrammar_CharLiteralElement::MGrammar_CharLiteralElement (
   MGrammar_LexerGrammar_ptr g,
   const MParser_Token_var& t,
   bool inverted,
   int autoGenType
) : MGrammar_GrammarAtom(g, t, AUTO_GEN_NONE)

{
   tokenType_ = ANTLRLexer::tokenTypeForCharLiteral(t->getText());
   g->charVocabulary_.add(tokenType_);
   line_ = t->getLine();
   no_ = inverted;
   autoGenType_ = autoGenType;
}

void MGrammar_CharLiteralElement::generate()

{
   grammar_->generator_->gen(this);
}

MGrammar_Lookahead MGrammar_CharLiteralElement::look(int k)

{
   return grammar_->theLLkAnalyzer_->look(k, this);
}

MGrammar_CharLiteralElement::~MGrammar_CharLiteralElement ()

{
}
