#ifndef __MGRAMMAR_CHARLITERALELEMENT_H__
#define __MGRAMMAR_CHARLITERALELEMENT_H__
#include "MLANG/SmartPtr.h"
#include "MParser/Token.h"
#include "MGrammar/Lookahead.h"
#include "MGrammar/GrammarAtom.h"

class MGrammar_CharLiteralElement;
typedef class MGrammar_CharLiteralElement *MGrammar_CharLiteralElement_ptr;
typedef MLANG_SmartPtr<MGrammar_CharLiteralElement> MGrammar_CharLiteralElement_var;


#include "MGrammar/LexerGrammar.h"

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/CharLiteralElement.java#1 $
 */

class MGrammar_CharLiteralElement : public MGrammar_GrammarAtom

{
public:
    MGrammar_CharLiteralElement (
      MGrammar_LexerGrammar_ptr g,
      const MParser_Token_var& t,
      bool inverted,
      int autoGenType
    );

    virtual ~MGrammar_CharLiteralElement ();

public:

   static bool is_nil (MGrammar_CharLiteralElement_ptr elem)
   { return elem == 0; }

   static MGrammar_CharLiteralElement_ptr _nil()
   { return 0; }
   
   static MGrammar_CharLiteralElement_ptr _duplicate(MGrammar_CharLiteralElement_ptr elem)
   { return MLANG_acquire (elem); }

public:

    void generate();

    MGrammar_Lookahead look(int k);
};

#endif /* __MGRAMMAR_CHARLITERALELEMENT_H__ */
