#ifndef __MGRAMMAR_CHARRANGEELEMENT_H__
#define __MGRAMMAR_CHARRANGEELEMENT_H__
#include "MLANG/SmartPtr.h"
#include "MLANG/String.h"
#include "MParser/Token.h"
#include "MGrammar/Lookahead.h"

class MGrammar_CharRangeElement;
typedef class MGrammar_CharRangeElement *MGrammar_CharRangeElement_ptr;
typedef MLANG_SmartPtr<MGrammar_CharRangeElement> MGrammar_CharRangeElement_var;

#include "MGrammar/AlternativeElement.h"

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/CharRangeElement.java#1 $
 */

class MGrammar_CharRangeElement : public MGrammar_AlternativeElement

{
public:
    MLANG_String label_;
    char begin_;
    char end_;
    MLANG_String beginText_;
    MLANG_String endText_;

public:

    MGrammar_CharRangeElement (
       MGrammar_LexerGrammar_ptr g,
       const MParser_Token_var& t1,
       const MParser_Token_var& t2, 
       int autoGenType
    );

    virtual ~MGrammar_CharRangeElement ();

public:

   static bool is_nil (MGrammar_CharRangeElement_ptr element)
   { return element == 0; }

   static MGrammar_CharRangeElement_ptr _nil()
   { return 0; }

   static MGrammar_CharRangeElement_ptr _duplicate(MGrammar_CharRangeElement_ptr element)
   { return ::MLANG_acquire(element); }

public:

    const MLANG_String& beginText() const
    { return beginText_; }

    const MLANG_String& endText() const
    { return endText_; }

public:

    void generate();

    const MLANG_String& getLabel() const
    {
       return label_;
    }

    MGrammar_Lookahead look(int k); 

    void setLabel(const MLANG_String& label);

    MLANG_String toString() const;
};


#endif /* __MGRAMMAR_CHARRANGEELEMENT_H__ */
