// $ANTLR 2.7.4: "action.g" -> "ActionLexer.java"$

#include "MLANG/String.h"
#include "MLANG/Vector_T.h"
#include "MLANG/StringBuffer.h"
#include "MIO/InputStream.h"
#include "MIO/Reader.h"
#include "MIO/StringReader.h"
#include "MParser/TokenStreamException.h"
#include "MParser/TokenStreamIOException.h"
#include "MParser/TokenStreamRecognitionException.h"
#include "MParser/CharStreamException.h"
#include "MParser/CharStreamIOException.h"
#include "MParser/Exception.h"
#include "MParser/CharScanner.h"
#include "MParser/InputBuffer.h"
#include "MParser/ByteBuffer.h"
#include "MParser/CharBuffer.h"
#include "MParser/Token.h"
#include "MParser/CommonToken.h"
#include "MParser/RecognitionException.h"
#include "MParser/NoViableAltForCharException.h"
#include "MParser/MismatchedCharException.h"
#include "MParser/TokenStream.h"
#include "MParser/LexerSharedInputState.h"
#include "MParser/SemanticException.h"
#include "MGrammar/CppActionLexer.h"

/** Perform the following translations:

    AST related translations

##				-> currentRule_AST
#(x,y,z)		-> codeGenerator.getASTCreateString(vector-of(x,y,z))
#[x]			-> codeGenerator.getASTCreateString(x)
#x				-> codeGenerator.mapTreeId(x)

Inside context of #(...), you can ref (x,y,z), [x], and x as shortcuts.

    Text related translations

$append(x)	  -> text_.append(x)
$setText(x)	  -> text_.setLength(_begin); text_.append(x)
$getText		  -> MLANG_String(text_.getBuffer(),_begin,text_.length()-_begin)
$setToken(x)  -> _token = x
$setType(x)	  -> _ttype = x
   $FOLLOW(r)    -> FOLLOW set name for rule r (optional arg)
   $FIRST(r)     -> FIRST set name for rule r (optional arg)
 */
MGrammar_CppActionLexer::MGrammar_CppActionLexer (
   const MLANG_String& s,
   const MGrammar_RuleBlock_var& currentRule,
   MGrammar_CodeGenerator_ptr generator,
   MGrammar_ActionTransInfo_ptr transInfo
) : super(new MParser_CharBuffer(new MIO_StringReader(s))),
    currentRule_(currentRule),
    generator_(generator),
    lineOffset_(0),
    antlrTool_(0),
    transInfo_(transInfo)

{
   caseSensitiveLiterals_ = true;
   setCaseSensitive(true);
}

void MGrammar_CppActionLexer::setLineOffset(int lineOffset)
{
	setLine(lineOffset);
}

void MGrammar_CppActionLexer::setTool(MGrammar_Tool_ptr tool)
{
	antlrTool_ = tool;
}

void MGrammar_CppActionLexer::reportError(MParser_RecognitionException& e)
{
	antlrTool_->error("Syntax error in action: "+e.toString(),getFilename(),getLine(),getColumn());
}

void MGrammar_CppActionLexer::reportError(const MLANG_String& s)
{
	antlrTool_->error(s,getFilename(),getLine(),getColumn());
}

void MGrammar_CppActionLexer::reportWarning(const MLANG_String& s)
{
	if ( getFilename().length()==0 )
		antlrTool_->warning(s);
	else
		antlrTool_->warning(s,getFilename(),getLine(),getColumn());
}

MGrammar_CppActionLexer::MGrammar_CppActionLexer(const MIO_InputStream_var& in)
   : super(new MParser_ByteBuffer(in))

{
   caseSensitiveLiterals_ = true;
   setCaseSensitive(true);
}

MGrammar_CppActionLexer::MGrammar_CppActionLexer(const MIO_Reader_var& in)
   : super(new MParser_CharBuffer(in))

{
   caseSensitiveLiterals_ = true;
   setCaseSensitive(true);
}

MGrammar_CppActionLexer::MGrammar_CppActionLexer(const MParser_InputBuffer_var& ib)
   : super(new MParser_LexerSharedInputState(ib))

{
   caseSensitiveLiterals_ = true;
   setCaseSensitive(true);
}

MGrammar_CppActionLexer::MGrammar_CppActionLexer(const MParser_LexerSharedInputState_var& state)
   : super(state)

{
   caseSensitiveLiterals_ = true;
   setCaseSensitive(true);
}

MParser_Token_var MGrammar_CppActionLexer::nextToken()

{
   MParser_Token_var theRetToken;
   LABEL(tryAgain)
   for (;;)

{
	MParser_Token_var _token;
	int _ttype = MParser_Token::INVALID_TYPE;
	resetText();
	try {   // for char stream error handling
		try {   // for lexical error handling
			if (((LA(1) >= char(0x0003) && LA(1) <= int(0x00ff))))

{
				mACTION(true);
				theRetToken=returnToken_;
			}
			else {
				if (LA(1)==EOF_CHAR)

{uponEOF(); returnToken_ = makeToken(MParser_Token::EOF_TYPE);}
			else {throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());}
			}
			
			if ( MParser_Token::is_nil(returnToken_) ) CONTINUE(tryAgain); // found SKIP token
			_ttype = returnToken_->getType();
			returnToken_->setType(_ttype);
			return returnToken_;
		}
		catch (MParser_RecognitionException& e)

{
			throw MParser_TokenStreamRecognitionException(e);
		}
	}
	catch (MParser_CharStreamException& cse)

{
		if ( ACE_dynamic_cast(MParser_CharStreamIOException*,&cse))

{
			throw MParser_TokenStreamIOException(((MParser_CharStreamIOException&)cse).io);
		}
		else {
			throw MParser_TokenStreamException(cse.getMessage());
		}
	}
   }
}

void MGrammar_CppActionLexer::mACTION(bool _createToken)

{
	int _ttype; MParser_Token_var _token; int _begin=text_.length();
	_ttype = ACTION;
	int _saveIndex;
	
	{
	int _cnt3=0;
	LABEL(_loop3)
	do {
		switch ( LA(1))

{
		case '#':
		{
			mAST_ITEM(false);
			break;
		}
		case '$':
		{
			mTEXT_ITEM(false);
			break;
		}
		default:
			if ((_tokenSet_0.member(LA(1))))

{
				mSTUFF(false);
			}
		else {
			if ( _cnt3>=1 )

{ BREAK(_loop3); } else {throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());}
		}
		}
		_cnt3++;
	} while (true);
	}
	if ( _createToken && MParser_Token::is_nil(_token) && _ttype!=MParser_Token::SKIP )

{
		_token = makeToken(_ttype);
		_token->setText(MLANG_String(text_.getBuffer() + _begin, text_.length()-_begin));
	}
	returnToken_ = _token;
}

/** stuff in between #(...) and #id items
 * Allow the escaping of the # for C preprocessor stuff.
 */
void MGrammar_CppActionLexer::mSTUFF(bool _createToken)

{
	int _ttype; MParser_Token_var _token; int _begin=text_.length();
	_ttype = STUFF;
	int _saveIndex;
	
	switch ( LA(1))

{
	case '"':
	{
		mSTRING(false);
		break;
	}
	case '\'':
	{
		mCHAR(false);
		break;
	}
	case '\n':
	{
		match('\n');
		newline();
		break;
	}
	default:
		if ((LA(1)=='/') && (LA(2)=='*'||LA(2)=='/'))

{
			mCOMMENT(false);
		}
		else if ((LA(1)=='\r') && (LA(2)=='\n') && (true))

{
			match("\r\n");
			newline();
		}
		else if ((LA(1)=='\\') && (LA(2)=='#') && (true))

{
			match('\\');
			match('#');
			text_.setLength(_begin); text_.append("#");
		}
		else if ((LA(1)=='/') && (_tokenSet_1.member(LA(2))))

{
			match('/');
			{
			match(_tokenSet_1);
			}
		}
		else if ((LA(1)=='\r') && (true) && (true))

{
			match('\r');
			newline();
		}
		else if ((_tokenSet_2.member(LA(1))) && (true) && (true))

{
			{
			match(_tokenSet_2);
			}
		}
	else {
		throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
	}
	}
	if ( _createToken && MParser_Token::is_nil(_token) && _ttype!=MParser_Token::SKIP )

{
		_token = makeToken(_ttype);
		_token->setText(MLANG_String(text_.getBuffer() + _begin, text_.length()-_begin));
	}
	returnToken_ = _token;
}

void MGrammar_CppActionLexer::mAST_ITEM(bool _createToken)

{
	int _ttype; MParser_Token_var _token; int _begin=text_.length();
	_ttype = AST_ITEM;
	int _saveIndex;
	MParser_Token_var t;
	MParser_Token_var id;
	MParser_Token_var ctor;
	
	if ((LA(1)=='#') && (LA(2)=='('))

{
		_saveIndex=text_.length();
		match('#');
		text_.setLength(_saveIndex);
		mTREE(true);
		t=returnToken_;
	}
	else if ((LA(1)=='#') && (_tokenSet_3.member(LA(2))))

{
		_saveIndex=text_.length();
		match('#');
		text_.setLength(_saveIndex);
		{
		switch ( LA(1))

{
		case '\t':  case '\n':  case '\r':  case ' ':
		{
			mWS(false);
			break;
		}
		case ':':  case 'A':  case 'B':  case 'C':
		case 'D':  case 'E':  case 'F':  case 'G':
		case 'H':  case 'I':  case 'J':  case 'K':
		case 'L':  case 'M':  case 'N':  case 'O':
		case 'P':  case 'Q':  case 'R':  case 'S':
		case 'T':  case 'U':  case 'V':  case 'W':
		case 'X':  case 'Y':  case 'Z':  case '_':
		case 'a':  case 'b':  case 'c':  case 'd':
		case 'e':  case 'f':  case 'g':  case 'h':
		case 'i':  case 'j':  case 'k':  case 'l':
		case 'm':  case 'n':  case 'o':  case 'p':
		case 'q':  case 'r':  case 's':  case 't':
		case 'u':  case 'v':  case 'w':  case 'x':
		case 'y':  case 'z':
		{
			break;
		}
		default:
		{
			throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
		}
		}
		}
		mID(true);
		id=returnToken_;
		
		MLANG_String idt = id->getText();
		MLANG_String mapped = generator_->mapTreeId(id->getText(), transInfo_);
		
		// verify that it's not a preprocessor macro...
		if( mapped.length()!=0 && ! idt.equals( mapped ) )
		{
			text_.setLength(_begin); text_.append(mapped);
		}
		else
		{
			if(idt.equals("if") ||
			idt.equals("define") ||
			idt.equals("ifdef") ||
			idt.equals("ifndef") ||
			idt.equals("else") ||
			idt.equals("elif") ||
			idt.equals("endif") ||
			idt.equals("warning") ||
			idt.equals("error") ||
			idt.equals("ident") ||
			idt.equals("pragma") ||
			idt.equals("include"))
			{
				text_.setLength(_begin); text_.append("#"+idt);
			}
		}
				
		{
		if ((_tokenSet_4.member(LA(1))) && (true) && (true))

{
			mWS(false);
		}
		else {
		}
		
		}
		{
		if ((LA(1)=='=') && (true) && (true))

{
			mVAR_ASSIGN(false);
		}
		else {
		}
		
		}
	}
	else if ((LA(1)=='#') && (LA(2)=='['))

{
		_saveIndex=text_.length();
		match('#');
		text_.setLength(_saveIndex);
		mAST_CONSTRUCTOR(true);
		ctor=returnToken_;
	}
	else if ((LA(1)=='#') && (LA(2)=='#'))

{
		match("##");
		
		if( currentRule_)
		{
			MLANG_String r = currentRule_->getRuleName()+"_AST";
			text_.setLength(_begin); text_.append(r);
	
			if ( transInfo_ )

			{
				transInfo_->refRuleRoot_=r;	// we ref root of tree
			}
		}
		else
		{
			reportWarning("\"##\" not valid in this context");
			text_.setLength(_begin); text_.append("##");
		}
				
		{
		if ((_tokenSet_4.member(LA(1))) && (true) && (true))

		{
			mWS(false);
		}
		else {
		}
		
		}
		{
		if ((LA(1)=='=') && (true) && (true))

{
			mVAR_ASSIGN(false);
		}
		else {
		}
		
		}
	}
	else {
		throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
	}
	
	if ( _createToken && MParser_Token::is_nil(_token) && _ttype!=MParser_Token::SKIP )

{
		_token = makeToken(_ttype);
		_token->setText(MLANG_String(text_.getBuffer() + _begin, text_.length()-_begin));
	}
	returnToken_ = _token;
}

void MGrammar_CppActionLexer::mTEXT_ITEM(bool _createToken)

{
	int _ttype; MParser_Token_var _token; int _begin=text_.length();
	_ttype = TEXT_ITEM;
	int _saveIndex;
	MParser_Token_var a1;
	MParser_Token_var a2;
	MParser_Token_var a3;
	MParser_Token_var a4;
	MParser_Token_var a5;
	MParser_Token_var a6;
	
	if ((LA(1)=='$') && (LA(2)=='F') && (LA(3)=='O'))

{
		match("$FOLLOW");
		{
		if ((_tokenSet_5.member(LA(1))) && (_tokenSet_6.member(LA(2))) && ((LA(3) >= char(0x0003) && LA(3) <= int(0x00ff))))

{
			{
			switch ( LA(1))

{
			case '\t':  case '\n':  case '\r':  case ' ':
			{
				mWS(false);
				break;
			}
			case '(':
			{
				break;
			}
			default:
			{
				throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
			}
			}
			}
			match('(');
			mTEXT_ARG(true);
			a5=returnToken_;
			match(')');
		}
		else {
		}
		
		}
		
		MLANG_String rule = currentRule_->getRuleName();
		if ( a5 )

		{
			rule = a5->getText();
		}
		MLANG_String setName = generator_->getFOLLOWBitSet(rule, 1);
		// System.out.println("FOLLOW("+rule+")="+setName);
		if ( setName.length()==0 )

		{
			reportError("$FOLLOW("+rule+")"+
					": unknown rule or bad lookahead computation");
		}
		else {
			text_.setLength(_begin); text_.append(setName);
		}
				
	}
	else if ((LA(1)=='$') && (LA(2)=='F') && (LA(3)=='I'))

	{
		match("$FIRST");
		{
		if ((_tokenSet_5.member(LA(1))) && (_tokenSet_6.member(LA(2))) && ((LA(3) >= char(0x0003) && LA(3) <= int(0x00ff))))

{
			{
			switch ( LA(1))

{
			case '\t':  case '\n':  case '\r':  case ' ':
			{
				mWS(false);
				break;
			}
			case '(':
			{
				break;
			}
			default:
			{
				throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
			}
			}
			}
			match('(');
			mTEXT_ARG(true);
			a6=returnToken_;
			match(')');
		}
		else {
		}
		
		}
		
		MLANG_String rule = currentRule_->getRuleName();
		if ( a6 )

		{
			rule = a6->getText();
		}
		MLANG_String setName = generator_->getFIRSTBitSet(rule, 1);
		// System.out.println("FIRST("+rule+")="+setName);
		if ( setName.length()==0 )

		{
			reportError("$FIRST("+rule+")"+
						": unknown rule or bad lookahead computation");
		}
		else {
			text_.setLength(_begin); text_.append(setName);
		}
				
	}
	else if ((LA(1)=='$') && (LA(2)=='a'))

{
		match("$append");
		{
		switch ( LA(1))

{
		case '\t':  case '\n':  case '\r':  case ' ':
		{
			mWS(false);
			break;
		}
		case '(':
		{
			break;
		}
		default:
		{
			throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
		}
		}
		}
		match('(');
		mTEXT_ARG(true);
		a1=returnToken_;
		match(')');
		
		MLANG_String t = "text += "+a1->getText();
		text_.setLength(_begin); text_.append(t);
				
	}
	else if ((LA(1)=='$') && (LA(2)=='s'))

{
		match("$set");
		{
		if ((LA(1)=='T') && (LA(2)=='e'))

{
			match("Text");
			{
			switch ( LA(1))

{
			case '\t':  case '\n':  case '\r':  case ' ':
			{
				mWS(false);
				break;
			}
			case '(':
			{
				break;
			}
			default:
			{
				throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
			}
			}
			}
			match('(');
			mTEXT_ARG(true);
			a2=returnToken_;
			match(')');
			
			MLANG_String t;
			t = "{ text_.erase(_begin); text += "+a2->getText()+"; }";
			text_.setLength(_begin); text_.append(t);
						
		}
		else if ((LA(1)=='T') && (LA(2)=='o'))

{
			match("Token");
			{
			switch ( LA(1))

{
			case '\t':  case '\n':  case '\r':  case ' ':
			{
				mWS(false);
				break;
			}
			case '(':
			{
				break;
			}
			default:
			{
				throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
			}
			}
			}
			match('(');
			mTEXT_ARG(true);
			a3=returnToken_;
			match(')');
			
			MLANG_String t="_token = "+a3->getText();
			text_.setLength(_begin); text_.append(t);
						
		}
		else if ((LA(1)=='T') && (LA(2)=='y'))

{
			match("Type");
			{
			switch ( LA(1))

{
			case '\t':  case '\n':  case '\r':  case ' ':
			{
				mWS(false);
				break;
			}
			case '(':
			{
				break;
			}
			default:
			{
				throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
			}
			}
			}
			match('(');
			mTEXT_ARG(true);
			a4=returnToken_;
			match(')');
			
			MLANG_String t="_ttype = "+a4->getText();
			text_.setLength(_begin); text_.append(t);
						
		}
		else {
			throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
		}
		
		}
	}
	else if ((LA(1)=='$') && (LA(2)=='g'))

{
		match("$getText");
		
		text_.setLength(_begin); text_.append("text_.substr(_begin,text_.length()-_begin)");
				
	}
	else {
		throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
	}
	
	if ( _createToken && MParser_Token::is_nil(_token) && _ttype!=MParser_Token::SKIP )

{
		_token = makeToken(_ttype);
		_token->setText(MLANG_String(text_.getBuffer() + _begin, text_.length()-_begin));
	}
	returnToken_ = _token;
}

void MGrammar_CppActionLexer::mCOMMENT(bool _createToken)

{
	int _ttype; MParser_Token_var _token; int _begin=text_.length();
	_ttype = COMMENT;
	int _saveIndex;
	
	if ((LA(1)=='/') && (LA(2)=='/'))

	{
		mSL_COMMENT(false);
	}
	else if ((LA(1)=='/') && (LA(2)=='*'))

{
		mML_COMMENT(false);
	}
	else {
		throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
	}
	
	if ( _createToken && MParser_Token::is_nil(_token) && _ttype!=MParser_Token::SKIP )

	{
		_token = makeToken(_ttype);
		_token->setText(MLANG_String(text_.getBuffer() + _begin, text_.length()-_begin));
	}
	returnToken_ = _token;
}

void MGrammar_CppActionLexer::mSTRING(bool _createToken)

{
	int _ttype; MParser_Token_var _token; int _begin=text_.length();
	_ttype = STRING;
	int _saveIndex;
	
	match('"');
	{
	LABEL(_loop100)
	do {
		if ((LA(1)=='\\'))

		{
			mESC(false);
		}
		else if ((_tokenSet_7.member(LA(1))))

		{
			matchNot('"');
		}
		else {
			BREAK(_loop100);
		}
		
	} while (true);
	}
	match('"');
	if ( _createToken && MParser_Token::is_nil(_token) && _ttype!=MParser_Token::SKIP )

{
		_token = makeToken(_ttype);
		_token->setText(MLANG_String(text_.getBuffer() + _begin, text_.length()-_begin));
	}
	returnToken_ = _token;
}

void MGrammar_CppActionLexer::mCHAR(bool _createToken)

{
	int _ttype; MParser_Token_var _token; int _begin=text_.length();
	_ttype = CHAR;
	int _saveIndex;
	
	match('\'');
	{
	if ((LA(1)=='\\'))

	{
		mESC(false);
	}
	else if ((_tokenSet_8.member(LA(1))))

	{
		matchNot('\'');
	}
	else {
		throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
	}
	
	}
	match('\'');
	if ( _createToken && MParser_Token::is_nil(_token) && _ttype!=MParser_Token::SKIP )

	{
		_token = makeToken(_ttype);
		_token->setText(MLANG_String(text_.getBuffer() + _begin, text_.length()-_begin));
	}
	returnToken_ = _token;
}

void MGrammar_CppActionLexer::mTREE(bool _createToken)

{
	int _ttype; MParser_Token_var _token; int _begin=text_.length();
	_ttype = TREE;
	int _saveIndex;
	MParser_Token_var t;
	MParser_Token_var t2;
	
	MLANG_StringBuffer buf = MLANG_StringBuffer();
	int n=0;
	MLANG_Vector<MLANG_String> terms;
	
	
	_saveIndex=text_.length();
	match('(');
	text_.setLength(_saveIndex);
	{
	switch ( LA(1))

	{
	case '\t':  case '\n':  case '\r':  case ' ':
	{
		_saveIndex=text_.length();
		mWS(false);
		text_.setLength(_saveIndex);
		break;
	}
	case '"':  case '#':  case '(':  case ':':
	case 'A':  case 'B':  case 'C':  case 'D':
	case 'E':  case 'F':  case 'G':  case 'H':
	case 'I':  case 'J':  case 'K':  case 'L':
	case 'M':  case 'N':  case 'O':  case 'P':
	case 'Q':  case 'R':  case 'S':  case 'T':
	case 'U':  case 'V':  case 'W':  case 'X':
	case 'Y':  case 'Z':  case '[':  case '_':
	case 'a':  case 'b':  case 'c':  case 'd':
	case 'e':  case 'f':  case 'g':  case 'h':
	case 'i':  case 'j':  case 'k':  case 'l':
	case 'm':  case 'n':  case 'o':  case 'p':
	case 'q':  case 'r':  case 's':  case 't':
	case 'u':  case 'v':  case 'w':  case 'x':
	case 'y':  case 'z':
	{
		break;
	}
	default:
	{
		throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
	}
	}
	}
	_saveIndex=text_.length();
	mTREE_ELEMENT(true);
	text_.setLength(_saveIndex);
	t=returnToken_;
	
	terms.appendElement(
		generator_->processStringForASTConstructor(t->getText())
										         );
			
	{
	switch ( LA(1))

	{
	case '\t':  case '\n':  case '\r':  case ' ':
	{
		_saveIndex=text_.length();
		mWS(false);
		text_.setLength(_saveIndex);
		break;
	}
	case ')':  case ',':
	{
		break;
	}
	default:
	{
		throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
	}
	}
	}
	{
	LABEL(_loop29)
	do {
		if ((LA(1)==','))

{
			_saveIndex=text_.length();
			match(',');
			text_.setLength(_saveIndex);
			{
			switch ( LA(1))

{
			case '\t':  case '\n':  case '\r':  case ' ':
			{
				_saveIndex=text_.length();
				mWS(false);
				text_.setLength(_saveIndex);
				break;
			}
			case '"':  case '#':  case '(':  case ':':
			case 'A':  case 'B':  case 'C':  case 'D':
			case 'E':  case 'F':  case 'G':  case 'H':
			case 'I':  case 'J':  case 'K':  case 'L':
			case 'M':  case 'N':  case 'O':  case 'P':
			case 'Q':  case 'R':  case 'S':  case 'T':
			case 'U':  case 'V':  case 'W':  case 'X':
			case 'Y':  case 'Z':  case '[':  case '_':
			case 'a':  case 'b':  case 'c':  case 'd':
			case 'e':  case 'f':  case 'g':  case 'h':
			case 'i':  case 'j':  case 'k':  case 'l':
			case 'm':  case 'n':  case 'o':  case 'p':
			case 'q':  case 'r':  case 's':  case 't':
			case 'u':  case 'v':  case 'w':  case 'x':
			case 'y':  case 'z':
			{
				break;
			}
			default:
			{
				throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
			}
			}
			}
			_saveIndex=text_.length();
			mTREE_ELEMENT(true);
			text_.setLength(_saveIndex);
			t2=returnToken_;
			
			terms.appendElement(
				generator_->processStringForASTConstructor(t2->getText())
													  );
						
			{
			switch ( LA(1))

{
			case '\t':  case '\n':  case '\r':  case ' ':
			{
				_saveIndex=text_.length();
				mWS(false);
				text_.setLength(_saveIndex);
				break;
			}
			case ')':  case ',':
			{
				break;
			}
			default:
			{
				throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
			}
			}
			}
		}
		else {
			BREAK(_loop29);
		}
		
	} while (true);
	}
	text_.setLength(_begin); text_.append(generator_->getASTCreateString(terms));
	_saveIndex=text_.length();
	match(')');
	text_.setLength(_saveIndex);
	if ( _createToken && MParser_Token::is_nil(_token) && _ttype!=MParser_Token::SKIP )

{
		_token = makeToken(_ttype);
		_token->setText(MLANG_String(text_.getBuffer() + _begin, text_.length()-_begin));
	}
	returnToken_ = _token;
}

void MGrammar_CppActionLexer::mWS(bool _createToken)

{
	int _ttype; MParser_Token_var _token; int _begin=text_.length();
	_ttype = WS;
	int _saveIndex;
	
	{
	int _cnt120=0;
	LABEL(_loop120)
	do {
		if ((LA(1)=='\r') && (LA(2)=='\n') && (true))

{
			match('\r');
			match('\n');
			newline();
		}
		else if ((LA(1)==' ') && (true) && (true))

{
			match(' ');
		}
		else if ((LA(1)=='\t') && (true) && (true))

{
			match('\t');
		}
		else if ((LA(1)=='\r') && (true) && (true))

{
			match('\r');
			newline();
		}
		else if ((LA(1)=='\n') && (true) && (true))

{
			match('\n');
			newline();
		}
		else {
			if ( _cnt120>=1 )

{ BREAK(_loop120); } else {throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());}
		}
		
		_cnt120++;
	} while (true);
	}
	if ( _createToken && MParser_Token::is_nil(_token) && _ttype!=MParser_Token::SKIP )

{
		_token = makeToken(_ttype);
		_token->setText(MLANG_String(text_.getBuffer() + _begin, text_.length()-_begin));
	}
	returnToken_ = _token;
}

void MGrammar_CppActionLexer::mID(bool _createToken)

{
	int _ttype; MParser_Token_var _token; int _begin=text_.length();
	_ttype = ID;
	int _saveIndex;
	
	{
	switch ( LA(1))

{
	case 'a':  case 'b':  case 'c':  case 'd':
	case 'e':  case 'f':  case 'g':  case 'h':
	case 'i':  case 'j':  case 'k':  case 'l':
	case 'm':  case 'n':  case 'o':  case 'p':
	case 'q':  case 'r':  case 's':  case 't':
	case 'u':  case 'v':  case 'w':  case 'x':
	case 'y':  case 'z':
	{
		matchRange('a','z');
		break;
	}
	case 'A':  case 'B':  case 'C':  case 'D':
	case 'E':  case 'F':  case 'G':  case 'H':
	case 'I':  case 'J':  case 'K':  case 'L':
	case 'M':  case 'N':  case 'O':  case 'P':
	case 'Q':  case 'R':  case 'S':  case 'T':
	case 'U':  case 'V':  case 'W':  case 'X':
	case 'Y':  case 'Z':
	{
		matchRange('A','Z');
		break;
	}
	case '_':
	{
		match('_');
		break;
	}
	case ':':
	{
		match("::");
		break;
	}
	default:
	{
		throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
	}
	}
	}
	{
	LABEL(_loop86)
	do {
		if ((_tokenSet_9.member(LA(1))) && (true) && (true))

{
			{
			switch ( LA(1))

{
			case 'a':  case 'b':  case 'c':  case 'd':
			case 'e':  case 'f':  case 'g':  case 'h':
			case 'i':  case 'j':  case 'k':  case 'l':
			case 'm':  case 'n':  case 'o':  case 'p':
			case 'q':  case 'r':  case 's':  case 't':
			case 'u':  case 'v':  case 'w':  case 'x':
			case 'y':  case 'z':
			{
				matchRange('a','z');
				break;
			}
			case 'A':  case 'B':  case 'C':  case 'D':
			case 'E':  case 'F':  case 'G':  case 'H':
			case 'I':  case 'J':  case 'K':  case 'L':
			case 'M':  case 'N':  case 'O':  case 'P':
			case 'Q':  case 'R':  case 'S':  case 'T':
			case 'U':  case 'V':  case 'W':  case 'X':
			case 'Y':  case 'Z':
			{
				matchRange('A','Z');
				break;
			}
			case '0':  case '1':  case '2':  case '3':
			case '4':  case '5':  case '6':  case '7':
			case '8':  case '9':
			{
				matchRange('0','9');
				break;
			}
			case '_':
			{
				match('_');
				break;
			}
			case ':':
			{
				match("::");
				break;
			}
			default:
			{
				throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
			}
			}
			}
		}
		else {
			BREAK(_loop86);
		}
		
	} while (true);
	}
	if ( _createToken && MParser_Token::is_nil(_token) && _ttype!=MParser_Token::SKIP )

{
		_token = makeToken(_ttype);
		_token->setText(MLANG_String(text_.getBuffer() + _begin, text_.length()-_begin));
	}
	returnToken_ = _token;
}

void MGrammar_CppActionLexer::mVAR_ASSIGN(bool _createToken)

{
	int _ttype; MParser_Token_var _token; int _begin=text_.length();
	_ttype = VAR_ASSIGN;
	int _saveIndex;
	
	match('=');
	
	// inform the code generator that an assignment was done to
	// AST root for the rule if invoker set refRuleRoot.
	if ( LA(1)!='=' && transInfo_!=0 && transInfo_->refRuleRoot_.length()!=0 )

	{
		transInfo_->assignToRoot_=true;
	}
			
	if ( _createToken && MParser_Token::is_nil(_token) && _ttype!=MParser_Token::SKIP )

	{
		_token = makeToken(_ttype);
		_token->setText(MLANG_String(text_.getBuffer() + _begin, text_.length()-_begin));
	}
	returnToken_ = _token;
}

void MGrammar_CppActionLexer::mAST_CONSTRUCTOR(bool _createToken)

{
	int _ttype; MParser_Token_var _token; int _begin=text_.length();
	_ttype = AST_CONSTRUCTOR;
	int _saveIndex;
	MParser_Token_var x;
	MParser_Token_var y;
	
	_saveIndex=text_.length();
	match('[');
	text_.setLength(_saveIndex);
	{
	switch ( LA(1))

	{
	case '\t':  case '\n':  case '\r':  case ' ':
	{
		_saveIndex=text_.length();
		mWS(false);
		text_.setLength(_saveIndex);
		break;
	}
	case '"':  case '#':  case '(':  case '0':
	case '1':  case '2':  case '3':  case '4':
	case '5':  case '6':  case '7':  case '8':
	case '9':  case ':':  case 'A':  case 'B':
	case 'C':  case 'D':  case 'E':  case 'F':
	case 'G':  case 'H':  case 'I':  case 'J':
	case 'K':  case 'L':  case 'M':  case 'N':
	case 'O':  case 'P':  case 'Q':  case 'R':
	case 'S':  case 'T':  case 'U':  case 'V':
	case 'W':  case 'X':  case 'Y':  case 'Z':
	case '[':  case '_':  case 'a':  case 'b':
	case 'c':  case 'd':  case 'e':  case 'f':
	case 'g':  case 'h':  case 'i':  case 'j':
	case 'k':  case 'l':  case 'm':  case 'n':
	case 'o':  case 'p':  case 'q':  case 'r':
	case 's':  case 't':  case 'u':  case 'v':
	case 'w':  case 'x':  case 'y':  case 'z':
	{
		break;
	}
	default:
	{
		throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
	}
	}
	}
	_saveIndex=text_.length();
	mAST_CTOR_ELEMENT(true);
	text_.setLength(_saveIndex);
	x=returnToken_;
	{
	switch ( LA(1))

	{
	case '\t':  case '\n':  case '\r':  case ' ':
	{
		_saveIndex=text_.length();
		mWS(false);
		text_.setLength(_saveIndex);
		break;
	}
	case ',':  case ']':
	{
		break;
	}
	default:
	{
		throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
	}
	}
	}
	{
	switch ( LA(1))

{
	case ',':
	{
		_saveIndex=text_.length();
		match(',');
		text_.setLength(_saveIndex);
		{
		switch ( LA(1))

		{
		case '\t':  case '\n':  case '\r':  case ' ':
		{
			_saveIndex=text_.length();
			mWS(false);
			text_.setLength(_saveIndex);
			break;
		}
		case '"':  case '#':  case '(':  case '0':
		case '1':  case '2':  case '3':  case '4':
		case '5':  case '6':  case '7':  case '8':
		case '9':  case ':':  case 'A':  case 'B':
		case 'C':  case 'D':  case 'E':  case 'F':
		case 'G':  case 'H':  case 'I':  case 'J':
		case 'K':  case 'L':  case 'M':  case 'N':
		case 'O':  case 'P':  case 'Q':  case 'R':
		case 'S':  case 'T':  case 'U':  case 'V':
		case 'W':  case 'X':  case 'Y':  case 'Z':
		case '[':  case '_':  case 'a':  case 'b':
		case 'c':  case 'd':  case 'e':  case 'f':
		case 'g':  case 'h':  case 'i':  case 'j':
		case 'k':  case 'l':  case 'm':  case 'n':
		case 'o':  case 'p':  case 'q':  case 'r':
		case 's':  case 't':  case 'u':  case 'v':
		case 'w':  case 'x':  case 'y':  case 'z':
		{
			break;
		}
		default:
		{
			throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
		}
		}
		}
		_saveIndex=text_.length();
		mAST_CTOR_ELEMENT(true);
		text_.setLength(_saveIndex);
		y=returnToken_;
		{
		switch ( LA(1))

{
		case '\t':  case '\n':  case '\r':  case ' ':
		{
			_saveIndex=text_.length();
			mWS(false);
			text_.setLength(_saveIndex);
			break;
		}
		case ']':
		{
			break;
		}
		default:
		{
			throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
		}
		}
		}
		break;
	}
	case ']':
	{
		break;
	}
	default:
	{
		throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
	}
	}
	}
	_saveIndex=text_.length();
	match(']');
	text_.setLength(_saveIndex);
	
	//			System.out.println("AST_CONSTRUCTOR: "+((x==null)?"null":x.getText())+
	//									 ", "+((y==null)?"null":y.getText()));
	MLANG_String ys = generator_->processStringForASTConstructor(x->getText());
	
	// the second does not need processing coz it's a string
	// (eg second param of astFactory.create(x,y)
	if ( y )
		ys += ","+y->getText();
	
	text_.setLength(_begin); text_.append( generator_->getASTCreateString(0,ys) );
			
	if ( _createToken && MParser_Token::is_nil(_token) && _ttype!=MParser_Token::SKIP )

	{
		_token = makeToken(_ttype);
		_token->setText(MLANG_String(text_.getBuffer() + _begin, text_.length()-_begin));
	}
	returnToken_ = _token;
}

void MGrammar_CppActionLexer::mTEXT_ARG(bool _createToken)

{
	int _ttype; MParser_Token_var _token; int _begin=text_.length();
	_ttype = TEXT_ARG;
	int _saveIndex;
	
	{
	switch ( LA(1))

	{
	case '\t':  case '\n':  case '\r':  case ' ':
	{
		mWS(false);
		break;
	}
	case '"':  case '$':  case '\'':  case '+':
	case '0':  case '1':  case '2':  case '3':
	case '4':  case '5':  case '6':  case '7':
	case '8':  case '9':  case ':':  case 'A':
	case 'B':  case 'C':  case 'D':  case 'E':
	case 'F':  case 'G':  case 'H':  case 'I':
	case 'J':  case 'K':  case 'L':  case 'M':
	case 'N':  case 'O':  case 'P':  case 'Q':
	case 'R':  case 'S':  case 'T':  case 'U':
	case 'V':  case 'W':  case 'X':  case 'Y':
	case 'Z':  case '_':  case 'a':  case 'b':
	case 'c':  case 'd':  case 'e':  case 'f':
	case 'g':  case 'h':  case 'i':  case 'j':
	case 'k':  case 'l':  case 'm':  case 'n':
	case 'o':  case 'p':  case 'q':  case 'r':
	case 's':  case 't':  case 'u':  case 'v':
	case 'w':  case 'x':  case 'y':  case 'z':
	{
		break;
	}
	default:
	{
		throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
	}
	}
	}
	{
	int _cnt60=0;
	LABEL(_loop60)
	do {
		if ((_tokenSet_10.member(LA(1))) && ((LA(2) >= char(0x0003) && LA(2) <= int(0x00ff))) && (true))

{
			mTEXT_ARG_ELEMENT(false);
			{
			if ((_tokenSet_4.member(LA(1))) && (_tokenSet_11.member(LA(2))) && (true))

{
				mWS(false);
			}
			else if ((_tokenSet_11.member(LA(1))) && (true) && (true))

{
			}
			else {
				throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
			}
			
			}
		}
		else {
			if ( _cnt60>=1 )

{ BREAK(_loop60); } else {throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());}
		}
		
		_cnt60++;
	} while (true);
	}
	if ( _createToken && MParser_Token::is_nil(_token) && _ttype!=MParser_Token::SKIP )

{
		_token = makeToken(_ttype);
		_token->setText(MLANG_String(text_.getBuffer() + _begin, text_.length()-_begin));
	}
	returnToken_ = _token;
}

void MGrammar_CppActionLexer::mTREE_ELEMENT(bool _createToken)

{
	int _ttype; MParser_Token_var _token; int _begin=text_.length();
	_ttype = TREE_ELEMENT;
	int _saveIndex;
	MParser_Token_var id;
	bool was_mapped;
	
	switch ( LA(1))

{
	case '(':
	{
		mTREE(false);
		break;
	}
	case '[':
	{
		mAST_CONSTRUCTOR(false);
		break;
	}
	case ':':  case 'A':  case 'B':  case 'C':
	case 'D':  case 'E':  case 'F':  case 'G':
	case 'H':  case 'I':  case 'J':  case 'K':
	case 'L':  case 'M':  case 'N':  case 'O':
	case 'P':  case 'Q':  case 'R':  case 'S':
	case 'T':  case 'U':  case 'V':  case 'W':
	case 'X':  case 'Y':  case 'Z':  case '_':
	case 'a':  case 'b':  case 'c':  case 'd':
	case 'e':  case 'f':  case 'g':  case 'h':
	case 'i':  case 'j':  case 'k':  case 'l':
	case 'm':  case 'n':  case 'o':  case 'p':
	case 'q':  case 'r':  case 's':  case 't':
	case 'u':  case 'v':  case 'w':  case 'x':
	case 'y':  case 'z':
	{
		mID_ELEMENT(false);
		break;
	}
	case '"':
	{
		mSTRING(false);
		break;
	}
	default:
		if ((LA(1)=='#') && (LA(2)=='('))

{
			_saveIndex=text_.length();
			match('#');
			text_.setLength(_saveIndex);
			mTREE(false);
		}
		else if ((LA(1)=='#') && (LA(2)=='['))

{
			_saveIndex=text_.length();
			match('#');
			text_.setLength(_saveIndex);
			mAST_CONSTRUCTOR(false);
		}
		else if ((LA(1)=='#') && (_tokenSet_12.member(LA(2))))

{
			_saveIndex=text_.length();
			match('#');
			text_.setLength(_saveIndex);
			was_mapped=mID_ELEMENT(true);
			id=returnToken_;
			// RK: I have a queer feeling that this maptreeid is redundant..
			if ( ! was_mapped )
			{
				MLANG_String t = generator_->mapTreeId(id->getText(), 0);
			//				System.out.println("mapped: "+id->getText()+" -> "+t);
				if ( t.length()!=0 )

				{
					text_.setLength(_begin); text_.append(t);
				}
			}
					
		}
		else if ((LA(1)=='#') && (LA(2)=='#'))

		{
			match("##");
			
			if( currentRule_)
			{
				MLANG_String t = currentRule_->getRuleName()+"_AST";
				text_.setLength(_begin); text_.append(t);
			}
			else
			{
				reportError("\"##\" not valid in this context");
				text_.setLength(_begin); text_.append("##");
			}
					
		}
	else {
		throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
	}
	}
	if ( _createToken && MParser_Token::is_nil(_token) && _ttype!=MParser_Token::SKIP )

{
		_token = makeToken(_ttype);
		_token->setText(MLANG_String(text_.getBuffer() + _begin, text_.length()-_begin));
	}
	returnToken_ = _token;
}

/** An ID_ELEMENT can be a func call, array ref, simple var,
 *  or AST label ref.
 */
bool  MGrammar_CppActionLexer::mID_ELEMENT(bool _createToken)

{
	bool mapped=false;
	int _ttype; MParser_Token_var _token; int _begin=text_.length();
	_ttype = ID_ELEMENT;
	int _saveIndex;
	MParser_Token_var id;
	
	mID(true);
	id=returnToken_;
	{
	if ((_tokenSet_4.member(LA(1))) && (_tokenSet_13.member(LA(2))) && (true))

{
		_saveIndex=text_.length();
		mWS(false);
		text_.setLength(_saveIndex);
	}
	else if ((_tokenSet_13.member(LA(1))) && (true) && (true))

{
	}
	else {
		throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
	}
	
	}
	{
	switch ( LA(1))

{
	case '(':  case '<':
	{
		{
		switch ( LA(1))

{
		case '<':
		{
			match('<');
			{
			LABEL(_loop43)
			do {
				if ((_tokenSet_14.member(LA(1))))

{
					matchNot('>');
				}
				else {
					BREAK(_loop43);
				}
				
			} while (true);
			}
			match('>');
			break;
		}
		case '(':
		{
			break;
		}
		default:
		{
			throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
		}
		}
		}
		match('(');
		{
		if ((_tokenSet_4.member(LA(1))) && (_tokenSet_15.member(LA(2))) && ((LA(3) >= char(0x0003) && LA(3) <= int(0x00ff))))

{
			_saveIndex=text_.length();
			mWS(false);
			text_.setLength(_saveIndex);
		}
		else if ((_tokenSet_15.member(LA(1))) && ((LA(2) >= char(0x0003) && LA(2) <= int(0x00ff))) && (true))

{
		}
		else {
			throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
		}
		
		}
		{
		switch ( LA(1))

{
		case '"':  case '#':  case '\'':  case '(':
		case '0':  case '1':  case '2':  case '3':
		case '4':  case '5':  case '6':  case '7':
		case '8':  case '9':  case ':':  case 'A':
		case 'B':  case 'C':  case 'D':  case 'E':
		case 'F':  case 'G':  case 'H':  case 'I':
		case 'J':  case 'K':  case 'L':  case 'M':
		case 'N':  case 'O':  case 'P':  case 'Q':
		case 'R':  case 'S':  case 'T':  case 'U':
		case 'V':  case 'W':  case 'X':  case 'Y':
		case 'Z':  case '[':  case '_':  case 'a':
		case 'b':  case 'c':  case 'd':  case 'e':
		case 'f':  case 'g':  case 'h':  case 'i':
		case 'j':  case 'k':  case 'l':  case 'm':
		case 'n':  case 'o':  case 'p':  case 'q':
		case 'r':  case 's':  case 't':  case 'u':
		case 'v':  case 'w':  case 'x':  case 'y':
		case 'z':
		{
			mARG(false);
			{
			LABEL(_loop48)
			do {
				if ((LA(1)==','))

{
					match(',');
					{
					switch ( LA(1))

{
					case '\t':  case '\n':  case '\r':  case ' ':
					{
						_saveIndex=text_.length();
						mWS(false);
						text_.setLength(_saveIndex);
						break;
					}
					case '"':  case '#':  case '\'':  case '(':
					case '0':  case '1':  case '2':  case '3':
					case '4':  case '5':  case '6':  case '7':
					case '8':  case '9':  case ':':  case 'A':
					case 'B':  case 'C':  case 'D':  case 'E':
					case 'F':  case 'G':  case 'H':  case 'I':
					case 'J':  case 'K':  case 'L':  case 'M':
					case 'N':  case 'O':  case 'P':  case 'Q':
					case 'R':  case 'S':  case 'T':  case 'U':
					case 'V':  case 'W':  case 'X':  case 'Y':
					case 'Z':  case '[':  case '_':  case 'a':
					case 'b':  case 'c':  case 'd':  case 'e':
					case 'f':  case 'g':  case 'h':  case 'i':
					case 'j':  case 'k':  case 'l':  case 'm':
					case 'n':  case 'o':  case 'p':  case 'q':
					case 'r':  case 's':  case 't':  case 'u':
					case 'v':  case 'w':  case 'x':  case 'y':
					case 'z':
					{
						break;
					}
					default:
					{
						throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
					}
					}
					}
					mARG(false);
				}
				else {
					BREAK(_loop48);
				}
				
			} while (true);
			}
			break;
		}
		case '\t':  case '\n':  case '\r':  case ' ':
		case ')':
		{
			break;
		}
		default:
		{
			throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
		}
		}
		}
		{
		switch ( LA(1))

{
		case '\t':  case '\n':  case '\r':  case ' ':
		{
			_saveIndex=text_.length();
			mWS(false);
			text_.setLength(_saveIndex);
			break;
		}
		case ')':
		{
			break;
		}
		default:
		{
			throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
		}
		}
		}
		match(')');
		break;
	}
	case '[':
	{
		{
		int _cnt53=0;
		LABEL(_loop53)
		do {
			if ((LA(1)=='['))

{
				match('[');
				{
				switch ( LA(1))

{
				case '\t':  case '\n':  case '\r':  case ' ':
				{
					_saveIndex=text_.length();
					mWS(false);
					text_.setLength(_saveIndex);
					break;
				}
				case '"':  case '#':  case '\'':  case '(':
				case '0':  case '1':  case '2':  case '3':
				case '4':  case '5':  case '6':  case '7':
				case '8':  case '9':  case ':':  case 'A':
				case 'B':  case 'C':  case 'D':  case 'E':
				case 'F':  case 'G':  case 'H':  case 'I':
				case 'J':  case 'K':  case 'L':  case 'M':
				case 'N':  case 'O':  case 'P':  case 'Q':
				case 'R':  case 'S':  case 'T':  case 'U':
				case 'V':  case 'W':  case 'X':  case 'Y':
				case 'Z':  case '[':  case '_':  case 'a':
				case 'b':  case 'c':  case 'd':  case 'e':
				case 'f':  case 'g':  case 'h':  case 'i':
				case 'j':  case 'k':  case 'l':  case 'm':
				case 'n':  case 'o':  case 'p':  case 'q':
				case 'r':  case 's':  case 't':  case 'u':
				case 'v':  case 'w':  case 'x':  case 'y':
				case 'z':
				{
					break;
				}
				default:
				{
					throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
				}
				}
				}
				mARG(false);
				{
				switch ( LA(1))

{
				case '\t':  case '\n':  case '\r':  case ' ':
				{
					_saveIndex=text_.length();
					mWS(false);
					text_.setLength(_saveIndex);
					break;
				}
				case ']':
				{
					break;
				}
				default:
				{
					throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
				}
				}
				}
				match(']');
			}
			else {
				if ( _cnt53>=1 )

{ BREAK(_loop53); } else {throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());}
			}
			
			_cnt53++;
		} while (true);
		}
		break;
	}
	case '.':
	{
		match('.');
		mID_ELEMENT(false);
		break;
	}
	case ':':
	{
		match("::");
		mID_ELEMENT(false);
		break;
	}
	default:
		if ((LA(1)=='-') && (LA(2)=='>') && (_tokenSet_12.member(LA(3))))

{
			match("->");
			mID_ELEMENT(false);
		}
		else if ((_tokenSet_16.member(LA(1))) && (true) && (true))

		{
			
			mapped = true;
			MLANG_String t = generator_->mapTreeId(id->getText(), transInfo_);
			//				System.out.println("mapped: "+id->getText()+" -> "+t);
			if ( t.length()!=0 )

			{
				text_.setLength(_begin); text_.append(t);
			}
						
			{
			if (((_tokenSet_17.member(LA(1))) && (_tokenSet_16.member(LA(2))) && (true))&&(transInfo_!=0 && transInfo_->refRuleRoot_.length()!=0))

			{
				{
				switch ( LA(1))

{
				case '\t':  case '\n':  case '\r':  case ' ':
				{
					mWS(false);
					break;
				}
				case '=':
				{
					break;
				}
				default:
				{
					throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
				}
				}
				}
				mVAR_ASSIGN(false);
			}
			else if ((_tokenSet_18.member(LA(1))) && (true) && (true))

{
			}
			else {
				throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
			}
			
			}
		}
	else {
		throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
	}
	}
	}
	if ( _createToken && MParser_Token::is_nil(_token) && _ttype!=MParser_Token::SKIP )

{
		_token = makeToken(_ttype);
		_token->setText(MLANG_String(text_.getBuffer() + _begin, text_.length()-_begin));
	}
	returnToken_ = _token;
	return mapped;
}

/** The arguments of a #[...] constructor are text, token type,
 *  or a tree.
 */
void MGrammar_CppActionLexer::mAST_CTOR_ELEMENT(bool _createToken)

{
	int _ttype; MParser_Token_var _token; int _begin=text_.length();
	_ttype = AST_CTOR_ELEMENT;
	int _saveIndex;
	
	if ((LA(1)=='"') && ((LA(2) >= char(0x0003) && LA(2) <= int(0x00ff))) && ((LA(3) >= char(0x0003) && LA(3) <= int(0x00ff))))

{
		mSTRING(false);
	}
	else if ((_tokenSet_19.member(LA(1))) && ((LA(2) >= char(0x0003) && LA(2) <= int(0x00ff))) && (true))

{
		mTREE_ELEMENT(false);
	}
	else if (((LA(1) >= '0' && LA(1) <= '9')))

{
		mINT(false);
	}
	else {
		throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
	}
	
	if ( _createToken && MParser_Token::is_nil(_token) && _ttype!=MParser_Token::SKIP )

{
		_token = makeToken(_ttype);
		_token->setText(MLANG_String(text_.getBuffer() + _begin, text_.length()-_begin));
	}
	returnToken_ = _token;
}

void MGrammar_CppActionLexer::mINT(bool _createToken)

{
	int _ttype; MParser_Token_var _token; int _begin=text_.length();
	_ttype = INT;
	int _saveIndex;
	
	{
	int _cnt111=0;
	LABEL(_loop111)
	do {
		if (((LA(1) >= '0' && LA(1) <= '9')))

{
			mDIGIT(false);
		}
		else {
			if ( _cnt111>=1 )

{ BREAK(_loop111); } else {throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());}
		}
		
		_cnt111++;
	} while (true);
	}
	if ( _createToken && MParser_Token::is_nil(_token) && _ttype!=MParser_Token::SKIP )

{
		_token = makeToken(_ttype);
		_token->setText(MLANG_String(text_.getBuffer() + _begin, text_.length()-_begin));
	}
	returnToken_ = _token;
}

void MGrammar_CppActionLexer::mARG(bool _createToken)

{
	int _ttype; MParser_Token_var _token; int _begin=text_.length();
	_ttype = ARG;
	int _saveIndex;
	
	{
	switch ( LA(1))

{
	case '\'':
	{
		mCHAR(false);
		break;
	}
	case '0':  case '1':  case '2':  case '3':
	case '4':  case '5':  case '6':  case '7':
	case '8':  case '9':
	{
		mINT_OR_FLOAT(false);
		break;
	}
	default:
		if ((_tokenSet_19.member(LA(1))) && ((LA(2) >= char(0x0003) && LA(2) <= int(0x00ff))) && ((LA(3) >= char(0x0003) && LA(3) <= int(0x00ff))))

{
			mTREE_ELEMENT(false);
		}
		else if ((LA(1)=='"') && ((LA(2) >= char(0x0003) && LA(2) <= int(0x00ff))) && ((LA(3) >= char(0x0003) && LA(3) <= int(0x00ff))))

{
			mSTRING(false);
		}
	else {
		throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
	}
	}
	}
	{
	LABEL(_loop81)
	do {
		if ((_tokenSet_20.member(LA(1))) && (_tokenSet_21.member(LA(2))) && ((LA(3) >= char(0x0003) && LA(3) <= int(0x00ff))))

{
			{
			switch ( LA(1))

{
			case '\t':  case '\n':  case '\r':  case ' ':
			{
				mWS(false);
				break;
			}
			case '*':  case '+':  case '-':  case '/':
			{
				break;
			}
			default:
			{
				throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
			}
			}
			}
			{
			switch ( LA(1))

{
			case '+':
			{
				match('+');
				break;
			}
			case '-':
			{
				match('-');
				break;
			}
			case '*':
			{
				match('*');
				break;
			}
			case '/':
			{
				match('/');
				break;
			}
			default:
			{
				throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
			}
			}
			}
			{
			switch ( LA(1))

{
			case '\t':  case '\n':  case '\r':  case ' ':
			{
				mWS(false);
				break;
			}
			case '"':  case '#':  case '\'':  case '(':
			case '0':  case '1':  case '2':  case '3':
			case '4':  case '5':  case '6':  case '7':
			case '8':  case '9':  case ':':  case 'A':
			case 'B':  case 'C':  case 'D':  case 'E':
			case 'F':  case 'G':  case 'H':  case 'I':
			case 'J':  case 'K':  case 'L':  case 'M':
			case 'N':  case 'O':  case 'P':  case 'Q':
			case 'R':  case 'S':  case 'T':  case 'U':
			case 'V':  case 'W':  case 'X':  case 'Y':
			case 'Z':  case '[':  case '_':  case 'a':
			case 'b':  case 'c':  case 'd':  case 'e':
			case 'f':  case 'g':  case 'h':  case 'i':
			case 'j':  case 'k':  case 'l':  case 'm':
			case 'n':  case 'o':  case 'p':  case 'q':
			case 'r':  case 's':  case 't':  case 'u':
			case 'v':  case 'w':  case 'x':  case 'y':
			case 'z':
			{
				break;
			}
			default:
			{
				throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
			}
			}
			}
			mARG(false);
		}
		else {
			BREAK(_loop81);
		}
		
	} while (true);
	}
	if ( _createToken && MParser_Token::is_nil(_token) && _ttype!=MParser_Token::SKIP )

{
		_token = makeToken(_ttype);
		_token->setText(MLANG_String(text_.getBuffer() + _begin, text_.length()-_begin));
	}
	returnToken_ = _token;
}

void MGrammar_CppActionLexer::mTEXT_ARG_ELEMENT(bool _createToken)

{
	int _ttype; MParser_Token_var _token; int _begin=text_.length();
	_ttype = TEXT_ARG_ELEMENT;
	int _saveIndex;
	
	switch ( LA(1))

{
	case ':':  case 'A':  case 'B':  case 'C':
	case 'D':  case 'E':  case 'F':  case 'G':
	case 'H':  case 'I':  case 'J':  case 'K':
	case 'L':  case 'M':  case 'N':  case 'O':
	case 'P':  case 'Q':  case 'R':  case 'S':
	case 'T':  case 'U':  case 'V':  case 'W':
	case 'X':  case 'Y':  case 'Z':  case '_':
	case 'a':  case 'b':  case 'c':  case 'd':
	case 'e':  case 'f':  case 'g':  case 'h':
	case 'i':  case 'j':  case 'k':  case 'l':
	case 'm':  case 'n':  case 'o':  case 'p':
	case 'q':  case 'r':  case 's':  case 't':
	case 'u':  case 'v':  case 'w':  case 'x':
	case 'y':  case 'z':
	{
		mTEXT_ARG_ID_ELEMENT(false);
		break;
	}
	case '"':
	{
		mSTRING(false);
		break;
	}
	case '\'':
	{
		mCHAR(false);
		break;
	}
	case '0':  case '1':  case '2':  case '3':
	case '4':  case '5':  case '6':  case '7':
	case '8':  case '9':
	{
		mINT_OR_FLOAT(false);
		break;
	}
	case '$':
	{
		mTEXT_ITEM(false);
		break;
	}
	case '+':
	{
		match('+');
		break;
	}
	default:
	{
		throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
	}
	}
	if ( _createToken && MParser_Token::is_nil(_token) && _ttype!=MParser_Token::SKIP )

{
		_token = makeToken(_ttype);
		_token->setText(MLANG_String(text_.getBuffer() + _begin, text_.length()-_begin));
	}
	returnToken_ = _token;
}

void MGrammar_CppActionLexer::mTEXT_ARG_ID_ELEMENT(bool _createToken)

{
	int _ttype; MParser_Token_var _token; int _begin=text_.length();
	_ttype = TEXT_ARG_ID_ELEMENT;
	int _saveIndex;
	MParser_Token_var id;
	
	mID(true);
	id=returnToken_;
	{
	if ((_tokenSet_4.member(LA(1))) && (_tokenSet_22.member(LA(2))) && (true))

{
		_saveIndex=text_.length();
		mWS(false);
		text_.setLength(_saveIndex);
	}
	else if ((_tokenSet_22.member(LA(1))) && (true) && (true))

{
	}
	else {
		throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
	}
	
	}
	{
	switch ( LA(1))

{
	case '(':
	{
		match('(');
		{
		if ((_tokenSet_4.member(LA(1))) && (_tokenSet_23.member(LA(2))) && ((LA(3) >= char(0x0003) && LA(3) <= int(0x00ff))))

{
			_saveIndex=text_.length();
			mWS(false);
			text_.setLength(_saveIndex);
		}
		else if ((_tokenSet_23.member(LA(1))) && ((LA(2) >= char(0x0003) && LA(2) <= int(0x00ff))) && (true))

{
		}
		else {
			throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
		}
		
		}
		{
		LABEL(_loop69)
		do {
			if ((_tokenSet_24.member(LA(1))) && ((LA(2) >= char(0x0003) && LA(2) <= int(0x00ff))) && ((LA(3) >= char(0x0003) && LA(3) <= int(0x00ff))))

{
				mTEXT_ARG(false);
				{
				LABEL(_loop68)
				do {
					if ((LA(1)==','))

{
						match(',');
						mTEXT_ARG(false);
					}
					else {
						BREAK(_loop68);
					}
					
				} while (true);
				}
			}
			else {
				BREAK(_loop69);
			}
			
		} while (true);
		}
		{
		switch ( LA(1))

{
		case '\t':  case '\n':  case '\r':  case ' ':
		{
			_saveIndex=text_.length();
			mWS(false);
			text_.setLength(_saveIndex);
			break;
		}
		case ')':
		{
			break;
		}
		default:
		{
			throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
		}
		}
		}
		match(')');
		break;
	}
	case '[':
	{
		{
		int _cnt74=0;
		LABEL(_loop74)
		do {
			if ((LA(1)=='['))

{
				match('[');
				{
				if ((_tokenSet_4.member(LA(1))) && (_tokenSet_24.member(LA(2))) && ((LA(3) >= char(0x0003) && LA(3) <= int(0x00ff))))

{
					_saveIndex=text_.length();
					mWS(false);
					text_.setLength(_saveIndex);
				}
				else if ((_tokenSet_24.member(LA(1))) && ((LA(2) >= char(0x0003) && LA(2) <= int(0x00ff))) && ((LA(3) >= char(0x0003) && LA(3) <= int(0x00ff))))

{
				}
				else {
					throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
				}
				
				}
				mTEXT_ARG(false);
				{
				switch ( LA(1))

{
				case '\t':  case '\n':  case '\r':  case ' ':
				{
					_saveIndex=text_.length();
					mWS(false);
					text_.setLength(_saveIndex);
					break;
				}
				case ']':
				{
					break;
				}
				default:
				{
					throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
				}
				}
				}
				match(']');
			}
			else {
				if ( _cnt74>=1 )

{ BREAK(_loop74); } else {throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());}
			}
			
			_cnt74++;
		} while (true);
		}
		break;
	}
	case '.':
	{
		match('.');
		mTEXT_ARG_ID_ELEMENT(false);
		break;
	}
	case '-':
	{
		match("->");
		mTEXT_ARG_ID_ELEMENT(false);
		break;
	}
	default:
		if ((LA(1)==':') && (LA(2)==':') && (_tokenSet_12.member(LA(3))))

{
			match("::");
			mTEXT_ARG_ID_ELEMENT(false);
		}
		else if ((_tokenSet_11.member(LA(1))) && (true) && (true))

{
		}
	else {
		throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
	}
	}
	}
	if ( _createToken && MParser_Token::is_nil(_token) && _ttype!=MParser_Token::SKIP )

{
		_token = makeToken(_ttype);
		_token->setText(MLANG_String(text_.getBuffer() + _begin, text_.length()-_begin));
	}
	returnToken_ = _token;
}

void MGrammar_CppActionLexer::mINT_OR_FLOAT(bool _createToken)

{
	int _ttype; MParser_Token_var _token; int _begin=text_.length();
	_ttype = INT_OR_FLOAT;
	int _saveIndex;
	
	{
	int _cnt114=0;
	LABEL(_loop114)
	do {
		if (((LA(1) >= '0' && LA(1) <= '9')) && (_tokenSet_25.member(LA(2))) && (true))

{
			mDIGIT(false);
		}
		else {
			if ( _cnt114>=1 )

{ BREAK(_loop114); } else {throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());}
		}
		
		_cnt114++;
	} while (true);
	}
	{
	if ((LA(1)=='L') && (_tokenSet_26.member(LA(2))) && (true))

{
		match('L');
	}
	else if ((LA(1)=='l') && (_tokenSet_26.member(LA(2))) && (true))

{
		match('l');
	}
	else if ((LA(1)=='.'))

{
		match('.');
		{
		LABEL(_loop117)
		do {
			if (((LA(1) >= '0' && LA(1) <= '9')) && (_tokenSet_26.member(LA(2))) && (true))

{
				mDIGIT(false);
			}
			else {
				BREAK(_loop117);
			}
			
		} while (true);
		}
	}
	else if ((_tokenSet_26.member(LA(1))) && (true) && (true))

{
	}
	else {
		throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
	}
	
	}
	if ( _createToken && MParser_Token::is_nil(_token) && _ttype!=MParser_Token::SKIP )

{
		_token = makeToken(_ttype);
		_token->setText(MLANG_String(text_.getBuffer() + _begin, text_.length()-_begin));
	}
	returnToken_ = _token;
}

void MGrammar_CppActionLexer::mSL_COMMENT(bool _createToken)

{
	int _ttype; MParser_Token_var _token; int _begin=text_.length();
	_ttype = SL_COMMENT;
	int _saveIndex;
	
	match("//");
	{
	LABEL(_loop91)
	do {
		// nongreedy exit test
		if ((LA(1)=='\n'||LA(1)=='\r') && (true) && (true)) BREAK(_loop91);
		if (((LA(1) >= char(0x0003) && LA(1) <= int(0x00ff))) && ((LA(2) >= char(0x0003) && LA(2) <= int(0x00ff))) && (true))

{
			matchNot(EOF_CHAR);
		}
		else {
			BREAK(_loop91);
		}
		
	} while (true);
	}
	{
	if ((LA(1)=='\r') && (LA(2)=='\n') && (true))

{
		match("\r\n");
	}
	else if ((LA(1)=='\n'))

{
		match('\n');
	}
	else if ((LA(1)=='\r') && (true) && (true))

{
		match('\r');
	}
	else {
		throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
	}
	
	}
	newline();
	if ( _createToken && MParser_Token::is_nil(_token) && _ttype!=MParser_Token::SKIP )

{
		_token = makeToken(_ttype);
		_token->setText(MLANG_String(text_.getBuffer() + _begin, text_.length()-_begin));
	}
	returnToken_ = _token;
}

void MGrammar_CppActionLexer::mML_COMMENT(bool _createToken)

{
	int _ttype; MParser_Token_var _token; int _begin=text_.length();
	_ttype = ML_COMMENT;
	int _saveIndex;
	
	match("/*");
	{
	LABEL(_loop95)
	do {
		// nongreedy exit test
		if ((LA(1)=='*') && (LA(2)=='/') && (true)) BREAK(_loop95);
		if ((LA(1)=='\r') && (LA(2)=='\n') && ((LA(3) >= char(0x0003) && LA(3) <= int(0x00ff))))

{
			match('\r');
			match('\n');
			newline();
		}
		else if ((LA(1)=='\r') && ((LA(2) >= char(0x0003) && LA(2) <= int(0x00ff))) && ((LA(3) >= char(0x0003) && LA(3) <= int(0x00ff))))

{
			match('\r');
			newline();
		}
		else if ((LA(1)=='\n') && ((LA(2) >= char(0x0003) && LA(2) <= int(0x00ff))) && ((LA(3) >= char(0x0003) && LA(3) <= int(0x00ff))))

{
			match('\n');
			newline();
		}
		else if (((LA(1) >= char(0x0003) && LA(1) <= int(0x00ff))) && ((LA(2) >= char(0x0003) && LA(2) <= int(0x00ff))) && ((LA(3) >= char(0x0003) && LA(3) <= int(0x00ff))))

{
			matchNot(EOF_CHAR);
		}
		else {
			BREAK(_loop95);
		}
		
	} while (true);
	}
	match("*/");
	if ( _createToken && MParser_Token::is_nil(_token) && _ttype!=MParser_Token::SKIP )

{
		_token = makeToken(_ttype);
		_token->setText(MLANG_String(text_.getBuffer() + _begin, text_.length()-_begin));
	}
	returnToken_ = _token;
}

void MGrammar_CppActionLexer::mESC(bool _createToken)

{
	int _ttype; MParser_Token_var _token; int _begin=text_.length();
	_ttype = ESC;
	int _saveIndex;
	
	match('\\');
	{
	switch ( LA(1))

{
	case 'n':
	{
		match('n');
		break;
	}
	case 'r':
	{
		match('r');
		break;
	}
	case 't':
	{
		match('t');
		break;
	}
	case 'v':
	{
		match('v');
		break;
	}
	case 'b':
	{
		match('b');
		break;
	}
	case 'f':
	{
		match('f');
		break;
	}
	case '"':
	{
		match('"');
		break;
	}
	case '\'':
	{
		match('\'');
		break;
	}
	case '\\':
	{
		match('\\');
		break;
	}
	case '0':  case '1':  case '2':  case '3':
	{
		{
		matchRange('0','3');
		}
		{
		if (((LA(1) >= '0' && LA(1) <= '9')) && ((LA(2) >= char(0x0003) && LA(2) <= int(0x00ff))) && (true))

{
			mDIGIT(false);
			{
			if (((LA(1) >= '0' && LA(1) <= '9')) && ((LA(2) >= char(0x0003) && LA(2) <= int(0x00ff))) && (true))

{
				mDIGIT(false);
			}
			else if (((LA(1) >= char(0x0003) && LA(1) <= int(0x00ff))) && (true) && (true))

{
			}
			else {
				throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
			}
			
			}
		}
		else if (((LA(1) >= char(0x0003) && LA(1) <= int(0x00ff))) && (true) && (true))

{
		}
		else {
			throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
		}
		
		}
		break;
	}
	case '4':  case '5':  case '6':  case '7':
	{
		{
		matchRange('4','7');
		}
		{
		if (((LA(1) >= '0' && LA(1) <= '9')) && ((LA(2) >= char(0x0003) && LA(2) <= int(0x00ff))) && (true))

{
			mDIGIT(false);
		}
		else if (((LA(1) >= char(0x0003) && LA(1) <= int(0x00ff))) && (true) && (true))

{
		}
		else {
			throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
		}
		
		}
		break;
	}
	default:
	{
		throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
	}
	}
	}
	if ( _createToken && MParser_Token::is_nil(_token) && _ttype!=MParser_Token::SKIP )

{
		_token = makeToken(_ttype);
		_token->setText(MLANG_String(text_.getBuffer() + _begin, text_.length()-_begin));
	}
	returnToken_ = _token;
}

void MGrammar_CppActionLexer::mDIGIT(bool _createToken)

{
	int _ttype; MParser_Token_var _token; int _begin=text_.length();
	_ttype = DIGIT;
	int _saveIndex;
	
	matchRange('0','9');
	if ( _createToken && MParser_Token::is_nil(_token) && _ttype!=MParser_Token::SKIP )

	{
		_token = makeToken(_ttype);
		_token->setText(MLANG_String(text_.getBuffer() + _begin, text_.length()-_begin));
	}
	returnToken_ = _token;
}


longArray MGrammar_CppActionLexer::mk_tokenSet_0()

{
	static ACE_UINT64 data[8];
	data[0]=-103079215112L;
	for (int i = 1; i<=3; i++)
        { data[i]=-1L; }
	return longArray(data, sizeof(data)/sizeof(data[0]));
}
MParser_BitSet MGrammar_CppActionLexer::_tokenSet_0(MGrammar_CppActionLexer::mk_tokenSet_0());
longArray MGrammar_CppActionLexer::mk_tokenSet_1()

{
	static ACE_UINT64 data[8];
	data[0]=-145135534866440L;
	for (int i = 1; i<=3; i++)
        { data[i]=-1L; }
	return longArray(data, sizeof(data)/sizeof(data[0]));
}
MParser_BitSet MGrammar_CppActionLexer::_tokenSet_1(MGrammar_CppActionLexer::mk_tokenSet_1());
longArray MGrammar_CppActionLexer::mk_tokenSet_2()

{
	static ACE_UINT64 data[8];
	data[0]=-141407503262728L;
	for (int i = 1; i<=3; i++)
        { data[i]=-1L; }
	return longArray(data, sizeof(data)/sizeof(data[0]));
}
MParser_BitSet MGrammar_CppActionLexer::_tokenSet_2(MGrammar_CppActionLexer::mk_tokenSet_2());
longArray MGrammar_CppActionLexer::mk_tokenSet_3()

{
	static ACE_UINT64 data[] = { 288230380446688768L, 576460745995190270L, 0L, 0L, 0L};
	return longArray(data, sizeof(data)/sizeof(data[0]));
}
MParser_BitSet MGrammar_CppActionLexer::_tokenSet_3(MGrammar_CppActionLexer::mk_tokenSet_3());
longArray MGrammar_CppActionLexer::mk_tokenSet_4()

{
	static ACE_UINT64 data[] = { 4294977024L, 0L, 0L, 0L, 0L};
	return longArray(data, sizeof(data)/sizeof(data[0]));
}
MParser_BitSet MGrammar_CppActionLexer::_tokenSet_4(MGrammar_CppActionLexer::mk_tokenSet_4());
longArray MGrammar_CppActionLexer::mk_tokenSet_5()

{
	static ACE_UINT64 data[] = { 1103806604800L, 0L, 0L, 0L, 0L};
	return longArray(data, sizeof(data)/sizeof(data[0]));
}
MParser_BitSet MGrammar_CppActionLexer::_tokenSet_5(MGrammar_CppActionLexer::mk_tokenSet_5());
longArray MGrammar_CppActionLexer::mk_tokenSet_6()

{
	static ACE_UINT64 data[] = { 576189812881499648L, 576460745995190270L, 0L, 0L, 0L};
	return longArray(data, sizeof(data)/sizeof(data[0]));
}
MParser_BitSet MGrammar_CppActionLexer::_tokenSet_6(MGrammar_CppActionLexer::mk_tokenSet_6());
longArray MGrammar_CppActionLexer::mk_tokenSet_7()

{
	static ACE_UINT64 data[8];
	data[0]=-17179869192L;
	data[1]=-268435457L;
	for (int i = 2; i<=3; i++)

{ data[i]=-1L; }
	return longArray(data, sizeof(data)/sizeof(data[0]));
}
MParser_BitSet MGrammar_CppActionLexer::_tokenSet_7(MGrammar_CppActionLexer::mk_tokenSet_7());
longArray MGrammar_CppActionLexer::mk_tokenSet_8()

{
	static ACE_UINT64 data[8];
	data[0]=-549755813896L;
	data[1]=-268435457L;
	for (int i = 2; i<=3; i++)

{ data[i]=-1L; }
	return longArray(data, sizeof(data)/sizeof(data[0]));
}
MParser_BitSet MGrammar_CppActionLexer::_tokenSet_8(MGrammar_CppActionLexer::mk_tokenSet_8());
longArray MGrammar_CppActionLexer::mk_tokenSet_9()

{
	static ACE_UINT64 data[] = { 576179277326712832L, 576460745995190270L, 0L, 0L, 0L};
	return longArray(data, sizeof(data)/sizeof(data[0]));
}
MParser_BitSet MGrammar_CppActionLexer::_tokenSet_9(MGrammar_CppActionLexer::mk_tokenSet_9());
longArray MGrammar_CppActionLexer::mk_tokenSet_10()

{
	static ACE_UINT64 data[] = { 576188709074894848L, 576460745995190270L, 0L, 0L, 0L};
	return longArray(data, sizeof(data)/sizeof(data[0]));
}
MParser_BitSet MGrammar_CppActionLexer::_tokenSet_10(MGrammar_CppActionLexer::mk_tokenSet_10());
longArray MGrammar_CppActionLexer::mk_tokenSet_11()

{
	static ACE_UINT64 data[] = { 576208504579171840L, 576460746532061182L, 0L, 0L, 0L};
	return longArray(data, sizeof(data)/sizeof(data[0]));
}
MParser_BitSet MGrammar_CppActionLexer::_tokenSet_11(MGrammar_CppActionLexer::mk_tokenSet_11());
longArray MGrammar_CppActionLexer::mk_tokenSet_12()

{
	static ACE_UINT64 data[] = { 288230376151711744L, 576460745995190270L, 0L, 0L, 0L};
	return longArray(data, sizeof(data)/sizeof(data[0]));
}
MParser_BitSet MGrammar_CppActionLexer::_tokenSet_12(MGrammar_CppActionLexer::mk_tokenSet_12());
longArray MGrammar_CppActionLexer::mk_tokenSet_13()

{
	static ACE_UINT64 data[] = { 3747275269732312576L, 671088640L, 0L, 0L, 0L};
	return longArray(data, sizeof(data)/sizeof(data[0]));
}
MParser_BitSet MGrammar_CppActionLexer::_tokenSet_13(MGrammar_CppActionLexer::mk_tokenSet_13());
longArray MGrammar_CppActionLexer::mk_tokenSet_14()

{
	static ACE_UINT64 data[8];
	data[0]=-4611686018427387912L;
	for (int i = 1; i<=3; i++)

{ data[i]=-1L; }
	return longArray(data, sizeof(data)/sizeof(data[0]));
}
MParser_BitSet MGrammar_CppActionLexer::_tokenSet_14(MGrammar_CppActionLexer::mk_tokenSet_14());
longArray MGrammar_CppActionLexer::mk_tokenSet_15()

{
	static ACE_UINT64 data[] = { 576183181451994624L, 576460746129407998L, 0L, 0L, 0L};
	return longArray(data, sizeof(data)/sizeof(data[0]));
}
MParser_BitSet MGrammar_CppActionLexer::_tokenSet_15(MGrammar_CppActionLexer::mk_tokenSet_15());
longArray MGrammar_CppActionLexer::mk_tokenSet_16()

{
	static ACE_UINT64 data[] = { 2306051920717948416L, 536870912L, 0L, 0L, 0L};
	return longArray(data, sizeof(data)/sizeof(data[0]));
}
MParser_BitSet MGrammar_CppActionLexer::_tokenSet_16(MGrammar_CppActionLexer::mk_tokenSet_16());
longArray MGrammar_CppActionLexer::mk_tokenSet_17()

{
	static ACE_UINT64 data[] = { 2305843013508670976L, 0L, 0L, 0L, 0L};
	return longArray(data, sizeof(data)/sizeof(data[0]));
}
MParser_BitSet MGrammar_CppActionLexer::_tokenSet_17(MGrammar_CppActionLexer::mk_tokenSet_17());
longArray MGrammar_CppActionLexer::mk_tokenSet_18()

{
	static ACE_UINT64 data[] = { 208911504254464L, 536870912L, 0L, 0L, 0L};
	return longArray(data, sizeof(data)/sizeof(data[0]));
}
MParser_BitSet MGrammar_CppActionLexer::_tokenSet_18(MGrammar_CppActionLexer::mk_tokenSet_18());
longArray MGrammar_CppActionLexer::mk_tokenSet_19()

{
	static ACE_UINT64 data[] = { 288231527202947072L, 576460746129407998L, 0L, 0L, 0L};
	return longArray(data, sizeof(data)/sizeof(data[0]));
}
MParser_BitSet MGrammar_CppActionLexer::_tokenSet_19(MGrammar_CppActionLexer::mk_tokenSet_19());
longArray MGrammar_CppActionLexer::mk_tokenSet_20()

{
	static ACE_UINT64 data[] = { 189120294954496L, 0L, 0L, 0L, 0L};
	return longArray(data, sizeof(data)/sizeof(data[0]));
}
MParser_BitSet MGrammar_CppActionLexer::_tokenSet_20(MGrammar_CppActionLexer::mk_tokenSet_20());
longArray MGrammar_CppActionLexer::mk_tokenSet_21()

{
	static ACE_UINT64 data[] = { 576370098428716544L, 576460746129407998L, 0L, 0L, 0L};
	return longArray(data, sizeof(data)/sizeof(data[0]));
}
MParser_BitSet MGrammar_CppActionLexer::_tokenSet_21(MGrammar_CppActionLexer::mk_tokenSet_21());
longArray MGrammar_CppActionLexer::mk_tokenSet_22()

{
	static ACE_UINT64 data[] = { 576315157207066112L, 576460746666278910L, 0L, 0L, 0L};
	return longArray(data, sizeof(data)/sizeof(data[0]));
}
MParser_BitSet MGrammar_CppActionLexer::_tokenSet_22(MGrammar_CppActionLexer::mk_tokenSet_22());
longArray MGrammar_CppActionLexer::mk_tokenSet_23()

{
	static ACE_UINT64 data[] = { 576190912393127424L, 576460745995190270L, 0L, 0L, 0L};
	return longArray(data, sizeof(data)/sizeof(data[0]));
}
MParser_BitSet MGrammar_CppActionLexer::_tokenSet_23(MGrammar_CppActionLexer::mk_tokenSet_23());
longArray MGrammar_CppActionLexer::mk_tokenSet_24()

{
	static ACE_UINT64 data[] = { 576188713369871872L, 576460745995190270L, 0L, 0L, 0L};
	return longArray(data, sizeof(data)/sizeof(data[0]));
}
MParser_BitSet MGrammar_CppActionLexer::_tokenSet_24(MGrammar_CppActionLexer::mk_tokenSet_24());
longArray MGrammar_CppActionLexer::mk_tokenSet_25()

{
	static ACE_UINT64 data[] = { 576459193230304768L, 576460746532061182L, 0L, 0L, 0L};
	return longArray(data, sizeof(data)/sizeof(data[0]));
}
MParser_BitSet MGrammar_CppActionLexer::_tokenSet_25(MGrammar_CppActionLexer::mk_tokenSet_25());
longArray MGrammar_CppActionLexer::mk_tokenSet_26()

{
	static ACE_UINT64 data[] = { 576388824486127104L, 576460746532061182L, 0L, 0L, 0L};
	return longArray(data, sizeof(data)/sizeof(data[0]));
}
MParser_BitSet MGrammar_CppActionLexer::_tokenSet_26(MGrammar_CppActionLexer::mk_tokenSet_26());
