#ifndef __MGRAMMAR_CPPBLOCKFINISHINGINFO_H__
#define __MGRAMMAR_CPPBLOCKFINISHINGINFO_H__
#include "MLANG/String.h"

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/CppBlockFinishingInfo.java#1 $
 */

// C++ code generator by Pete Wells: pete@yamuna.demon.co.uk

class MGrammar_CppBlockFinishingInfo

{
public:
   MLANG_String postscript;		// what to generate to terminate block
   bool generatedSwitch;// did block finish with "default:" of switch?
   bool generatedAnIf;
   int closingBracesOfIFSequence;

   /** When generating an if or switch, end-of-token lookahead sets
    *  will become the else or default clause, don't generate an
    *  error clause in this case.
    */
   bool needAnErrorClause;


public:
   MGrammar_CppBlockFinishingInfo();

   MGrammar_CppBlockFinishingInfo (
      const MLANG_String& ps, 
      bool genS,
      bool generatedAnIf,
      bool n,
      int closing = 0
    );

   MGrammar_CppBlockFinishingInfo (
      const MGrammar_CppBlockFinishingInfo& b
     );

   ~MGrammar_CppBlockFinishingInfo ();

public:

   MGrammar_CppBlockFinishingInfo& operator= (
      const MGrammar_CppBlockFinishingInfo& b
     );

public:
   bool viableAction() const
   {
     return (needAnErrorClause &&
             (generatedAnIf || generatedSwitch)); 
   }
};

#endif /* __MGRAMMAR_CPPBLOCKFINISHINGINFO_H__ */
