#ifndef __MGRAMMAR_EXCEPTIONHANDLER_H__
#define __MGRAMMAR_EXCEPTIONHANDLER_H__
#include "ace/Synch.h"
#include "MLANG/Refcountable.h"
#include "MLANG/SmartPtr.h"
#include "MParser/Token.h"

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/ExceptionHandler.java#1 $
 */

class MGrammar_ExceptionHandler;
typedef class MGrammar_ExceptionHandler *MGrammar_ExceptionHandler_ptr;

class MGrammar_ExceptionHandler : public MLANG_Refcountable<ACE_SYNCH_MUTEX>

{
protected:
    // Type of the ANTLR exception class to catch and the variable decl
    MParser_Token_var exceptionTypeAndName_;
    // The action to be executed when the exception is caught
    MParser_Token_var action_;


public:

    MGrammar_ExceptionHandler (
       const MParser_Token_var& exceptionTypeAndName,
       const MParser_Token_var& action
      );
    virtual ~MGrammar_ExceptionHandler();

public:

   static bool is_nil (MGrammar_ExceptionHandler_ptr eh)
   { return eh == 0; }

   static MGrammar_ExceptionHandler_ptr _nil()
   { return 0; }

   static MGrammar_ExceptionHandler_ptr _duplicate(MGrammar_ExceptionHandler_ptr eh)
   { return MLANG_acquire(eh); }
public:

   const MParser_Token_var& exceptionTypeAndName() const
   { return exceptionTypeAndName_; }

   const MParser_Token_var& action() const
   { return action_; }
};

typedef MLANG_SmartPtr<MGrammar_ExceptionHandler> MGrammar_ExceptionHandler_var;

#endif /* __MGRAMMAR_EXCEPTIONHANDLER_H__ */
