#ifndef __MGRAMMAR_EXCEPTIONSPEC_H__
#define __MGRAMMAR_EXCEPTIONSPEC_H__
#include "MLANG/Refcountable.h"
#include "MLANG/SmartPtr.h"
#include "MLANG/Vector_T.h"
#include "MParser/Token.h"
#include "MGrammar/ExceptionHandler.h"

class MGrammar_ExceptionSpec;
typedef class MGrammar_ExceptionSpec *MGrammar_ExceptionSpec_ptr;

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/ExceptionSpec.java#1 $
 */

class MGrammar_ExceptionSpec : public MLANG_Refcountable<ACE_SYNCH_MUTEX>

{
protected:
    // Non-null if this refers to a labeled rule
    // Use a token instead of a string to get the line information
    MParser_Token_var label_;

    // List of ExceptionHandler (catch phrases)
    MLANG_Vector<MGrammar_ExceptionHandler_var> handlers_;

public:

    MGrammar_ExceptionSpec(const MParser_Token_var& label);

    virtual ~MGrammar_ExceptionSpec();

public:

   static bool is_nil (MGrammar_ExceptionSpec_ptr a)
   { return a == 0; }

   static MGrammar_ExceptionSpec_ptr _nil()
   { return 0; }

   static MGrammar_ExceptionSpec_ptr _duplicate(MGrammar_ExceptionSpec_ptr ex)
   { return MLANG_acquire(ex); }

public:

    const MParser_Token_var& getLabel() const
    { return label_; }

    const MLANG_Vector<MGrammar_ExceptionHandler_var>& handlers() const
    { return handlers_; }

public:
    void addHandler(const MGrammar_ExceptionHandler_var& handler);
};

typedef MLANG_SmartPtr<MGrammar_ExceptionSpec> MGrammar_ExceptionSpec_var;

#endif /* __MGRAMMAR_EXCEPTIONSPEC_H__ */
