#ifndef __MGRAMMAR_GRAMMARATOM_H__
#define __MGRAMMAR_GRAMMARATOM_H__
#include "MLANG/SmartPtr.h"
#include "MLANG/String.h"
#include "MParser/Token.h"
#include "MGrammar/AlternativeElement.h"

class MGrammar_GrammarAtom;
typedef class MGrammar_GrammarAtom *MGrammar_GrammarAtom_ptr;

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/GrammarAtom.java#1 $
 */

/** A GrammarAtom is either a token ref, a character ref, or string.
 * The analysis doesn't care.
 */
class MGrammar_GrammarAtom : public MGrammar_AlternativeElement

{
protected:
    MLANG_String label_;
    MLANG_String atomText_;
    int tokenType_;
    bool no_;
    /** Set to type of AST node to create during parse.  Defaults to what is
     *  set in the TokenSymbol.
     */
    MLANG_String ASTNodeType_;

public:

    MGrammar_GrammarAtom (
      MGrammar_Grammar_ptr g, 
      const MParser_Token_var& t, 
      int autoGenType
    );

    virtual ~MGrammar_GrammarAtom ();

public:
   static bool is_nil (MGrammar_GrammarAtom_ptr a)
   { return a == 0; }

   static MGrammar_GrammarAtom_ptr _nil()
   { return 0; }

   static MGrammar_GrammarAtom_ptr _duplicate(MGrammar_GrammarAtom_ptr atom)
   { return ::MLANG_acquire(atom); }

   static MGrammar_GrammarAtom_ptr _narrow(MGrammar_AlternativeElement_ptr atom)
   { return ::MLANG_acquire(ACE_dynamic_cast(MGrammar_GrammarAtom_ptr, atom)); }

public:

    bool getNo() const
    { return no_; }

    const MLANG_String& getLabel() const
    {
        return label_;
    }

    const MLANG_String& getText() const
    {
        return atomText_;
    }

    int getType() const
    {
        return tokenType_;
    }

    void setLabel(const MLANG_String& label);

    const MLANG_String& getASTNodeType() const;

    void setASTNodeType(const MLANG_String& type);

    void setOption (
       const MParser_Token_var& option,
       const MParser_Token_var& value
     );

    MLANG_String toString() const;
};

typedef MLANG_SmartPtr<MGrammar_GrammarAtom> MGrammar_GrammarAtom_var;

#endif /* __MGRAMMAR_GRAMMARATOM_H__ */
