#ifndef __MGRAMMAR_GRAMMARSYMBOL_H__
#define __MGRAMMAR_GRAMMARSYMBOL_H__
#include "MLANG/Refcountable.h"
#include "MLANG/SmartPtr.h"
#include "MLANG/String.h"

class MGrammar_GrammarSymbol;
typedef class MGrammar_GrammarSymbol *MGrammar_GrammarSymbol_ptr;

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/GrammarSymbol.java#1 $
 */

/**A GrammarSymbol is a generic symbol that can be
 * added to the symbol table for a grammar.
 */
class MGrammar_GrammarSymbol : public MLANG_Refcountable<ACE_SYNCH_MUTEX>

{
protected:
    MLANG_String id_;

public:

    MGrammar_GrammarSymbol(const MLANG_String& s = "");

    virtual ~MGrammar_GrammarSymbol ();

public:

   static bool is_nil (MGrammar_GrammarSymbol_ptr a)
   { return a == 0; }

   static MGrammar_GrammarSymbol_ptr _nil()
   { return 0; }

   static MGrammar_GrammarSymbol_ptr _duplicate(MGrammar_GrammarSymbol_ptr gs)
   { return MLANG_acquire(gs); }

public:

    MLANG_String getId() const
    {
      return id_;
    }

    void setId(const MLANG_String& s)
    {
        id_ = s;
    }
};

typedef MLANG_SmartPtr<MGrammar_GrammarSymbol> MGrammar_GrammarSymbol_var;

#endif /* __MGRAMMAR_GRAMMARSYMBOL_H__ */
