#ifndef __MGRAMMAR_IMPORTVOCABTOKENMANAGER_H__
#define __MGRAMMAR_IMPORTVOCABTOKENMANAGER_H__
#include "MLANG/String.h"
#include "MGrammar/ANTLRTokdefLexer.h"
#include "MGrammar/SimpleTokenManager.h"

class MGrammar_ImportVocabTokenManager;
typedef class MGrammar_ImportVocabTokenManager *MGrammar_ImportVocabTokenManager_ptr;

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/ImportVocabTokenManager.java#1 $
 */

/** Static implementation of the TokenManager, used for importVocab option  */
class MGrammar_ImportVocabTokenManager : public MGrammar_SimpleTokenManager

{
private:
    MLANG_String filename_;
protected:
    MGrammar_Grammar_var grammar_;

    // FIXME: it would be nice if the path to the original grammar file was
    // also searched.
public:
    MGrammar_ImportVocabTokenManager (
       const MGrammar_Grammar_var& grammar,
       const MLANG_String& filename,
       const MLANG_String& name,
       MGrammar_Tool_ptr tool
     );

    MGrammar_ImportVocabTokenManager (
       const MGrammar_ImportVocabTokenManager& tm
     );

    virtual ~MGrammar_ImportVocabTokenManager ();

public:

   static bool is_nil (MGrammar_ImportVocabTokenManager_ptr tm)
   { return tm == 0; }

   static MGrammar_ImportVocabTokenManager_ptr _nil()
   { return 0; }

   static MGrammar_ImportVocabTokenManager_ptr _duplicate(MGrammar_ImportVocabTokenManager_ptr tm)
   { return ::MLANG_acquire(tm); }

public:
    MGrammar_TokenManager_var clone();

    /** define a token. */
    void define(const MGrammar_TokenSymbol_var& ts);

    /** define a token.  Intended for use only when reading the importVocab file. */
    void define(const MLANG_String& s, int ttype);
    /** importVocab token manager is read-only if output would be same as input */
    bool isReadOnly() const
    {
        return readOnly_;
    }

    /** Get the next unused token type. */
    int nextTokenType()
    {
        return MGrammar_SimpleTokenManager::nextTokenType();
    }
};

typedef MLANG_SmartPtr<MGrammar_ImportVocabTokenManager> MGrammar_ImportVocabTokenManager_var;

#endif /* __MGRAMMAR_IMPORTVOCABTOKENMANAGER_H__ */
