#include "MGrammar/Grammar.h"
#include "MGrammar/CodeGenerator.h"
#include "MGrammar/OneOrMoreBlock.h"

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/OneOrMoreBlock.java#1 $
 */

MGrammar_OneOrMoreBlock::MGrammar_OneOrMoreBlock (
   MGrammar_Grammar_ptr g
) : MGrammar_BlockWithImpliedExitPath (g)

{
}

MGrammar_OneOrMoreBlock::MGrammar_OneOrMoreBlock (
   MGrammar_Grammar_ptr g,
   const MParser_Token_var& start
) : MGrammar_BlockWithImpliedExitPath (g, start)

{
}

void MGrammar_OneOrMoreBlock::generate()

{
   grammar_->generator_->gen(this);
}

MGrammar_Lookahead MGrammar_OneOrMoreBlock::look(int k)

{
   return grammar_->theLLkAnalyzer_->look(k, this);
}

MLANG_String MGrammar_OneOrMoreBlock::toString() const

{
   return MGrammar_BlockWithImpliedExitPath::toString() + "+";
}

MGrammar_OneOrMoreBlock::~MGrammar_OneOrMoreBlock ()

{
}
