#ifndef __MGRAMMAR_ONEORMOREBLOCK_H__
#define __MGRAMMAR_ONEORMOREBLOCK_H__
#include "MLANG/SmartPtr.h"
#include "MLANG/String.h"
#include "MGrammar/Lookahead.h"
#include "MParser/Token.h"
#include "MGrammar/BlockWithImpliedExitPath.h"

class MGrammar_OneOrMoreBlock;
typedef class MGrammar_OneOrMoreBlock *MGrammar_OneOrMoreBlock_ptr;

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/OneOrMoreBlock.java#1 $
 */

class MGrammar_OneOrMoreBlock : public MGrammar_BlockWithImpliedExitPath

{
public:

    MGrammar_OneOrMoreBlock(MGrammar_Grammar_ptr g);

    MGrammar_OneOrMoreBlock (
       MGrammar_Grammar_ptr g,
       const MParser_Token_var& start
     );

    virtual ~MGrammar_OneOrMoreBlock();

public:
   static bool is_nil (MGrammar_OneOrMoreBlock_ptr blk)
   { return blk == 0; }

   static MGrammar_OneOrMoreBlock_ptr _nil()
   { return 0; }

   static MGrammar_OneOrMoreBlock_ptr _duplicate(MGrammar_OneOrMoreBlock_ptr blk)
   { return ::MLANG_acquire(blk); }
public:

    void generate();

    MGrammar_Lookahead look(int k);

    MLANG_String toString() const;
};

typedef MLANG_SmartPtr<MGrammar_OneOrMoreBlock> MGrammar_OneOrMoreBlock_var;

#endif /* __MGRAMMAR_ONEORMOREBLOCK_H__ */
