#ifndef __MGRAMMAR_PARSERGRAMMAR_H__
#define __MGRAMMAR_PARSERGRAMMAR_H__
#include "MLANG/String.h"
#include "MParser/BitSet.h"
#include "MParser/Token.h"
#include "MGrammar/Tool.h"

class MGrammar_ParserGrammar;
typedef MGrammar_ParserGrammar *MGrammar_ParserGrammar_ptr;
typedef MLANG_SmartPtr<MGrammar_ParserGrammar> MGrammar_ParserGrammar_var;

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/ParserGrammar.java#1 $
 */

#include "MGrammar/Grammar.h"

/** Parser-specific grammar subclass */
class MGrammar_ParserGrammar : public MGrammar_Grammar

{
public:

    MGrammar_ParserGrammar (
      const MLANG_String& className,
      MGrammar_Tool_ptr tool,
      const MLANG_String& superClass
    );

    virtual ~MGrammar_ParserGrammar ();

public:

   static bool is_nil (MGrammar_ParserGrammar_ptr grammar)
   { return grammar == 0; }

   static MGrammar_ParserGrammar_ptr _nil()
   { return 0; }

   static MGrammar_ParserGrammar_ptr _duplicate(MGrammar_ParserGrammar_ptr grammar)
   { return MLANG_acquire(grammar); }

public:

   bool isParser() const { return true; }

    /** Top-level call to generate the code for this grammar */
    void generate();

protected:

    // Get name of class from which generated parser/lexer inherits
    const MLANG_String getSuperClass() const;

public:

    /**Process command line arguments.
     * -trace			have all rules call traceIn/traceOut
     * -traceParser		have parser rules call traceIn/traceOut
     * -debug			generate debugging output for parser debugger
     */
    void processArguments (ACE_ARGV& args);

    /** Set parser options -- performs action on the following options:
     */
    bool setOption (
       const MLANG_String& key,
       const MParser_Token_var& value
     );
};

#endif /* __MGRAMMAR_PARSERGRAMMAR_H__ */
