#ifndef __MGRAMMAR_PREPROCESSORLEXER_H__
#define __MGRAMMAR_PREPROCESSORLEXER_H__
#include "MIO/InputStream.h"
#include "MIO/Reader.h"
#include "MIO/Reader.h"
#include "MParser/BitSet.h"
#include "MParser/InputBuffer.h"
#include "MParser/LexerSharedInputState.h"
#include "MParser/CharScanner.h"
#include "MParser/Token.h"
#include "MGrammar/PreprocessorTokenTypes.h"

class MGrammar_PreprocessorLexer;
typedef MGrammar_PreprocessorLexer *MGrammar_PreprocessorLexer_ptr;
typedef MLANG_SmartPtr<MGrammar_PreprocessorLexer> MGrammar_PreprocessorLexer_var;

// $ANTLR 2.7.4: "preproc.g" -> "PreprocessorLexer.java"$

class MGrammar_PreprocessorLexer : public MParser_CharScanner,
                                   public MGrammar_PreprocessorTokenTypes
{
public:
   typedef MParser_CharScanner super;
public:
   MGrammar_PreprocessorLexer(const MIO_InputStream_var& in);
public:
   MGrammar_PreprocessorLexer(const MIO_Reader_var& in);
public:
   MGrammar_PreprocessorLexer(const MParser_InputBuffer_var& ib);
public:
   MGrammar_PreprocessorLexer(const MParser_LexerSharedInputState_var& state);
public:
   virtual ~MGrammar_PreprocessorLexer();
protected:
   void init();
public:

   static bool is_nil (MGrammar_PreprocessorLexer_ptr lexer)
   { return lexer == 0; }

   static MGrammar_PreprocessorLexer_ptr _nil()
   { return 0; }

   static MGrammar_PreprocessorLexer_ptr _duplicate(MGrammar_PreprocessorLexer_ptr lexer)
   { return MLANG_acquire(lexer); }

public:
    MParser_Token_var nextToken();
public:
    void mRULE_BLOCK(bool _createToken);
public:
    void mWS(bool _createToken);
protected:
    void mALT(bool _createToken);
public:
    void mSUBRULE_BLOCK(bool _createToken);
protected:
    void mELEMENT(bool _createToken);
public:
    void mCOMMENT(bool _createToken);
public:
    void mACTION(bool _createToken);
public:
    void mSTRING_LITERAL(bool _createToken);
public:
    void mCHAR_LITERAL(bool _createToken);
protected:
    void mNEWLINE(bool _createToken);
public:
    void mBANG(bool _createToken);
public:
    void mSEMI(bool _createToken);
public:
    void mCOMMA(bool _createToken);
public:
    void mRCURLY(bool _createToken);
public:
    void mLPAREN(bool _createToken);
public:
    void mRPAREN(bool _createToken);
	
/** This rule picks off keywords in the lexer that need to be
 *  handled specially.  For example, "header" is the start
 *  of the header action (used to distinguish between options
 *  block and an action).  We do not want "header" to go back
 *  to the parser as a simple keyword...it must pick off
 *  the action afterwards.
 */
public:
    void mID_OR_KEYWORD(bool _createToken);
protected:
    void mID(bool _createToken);
protected:
    void mCURLY_BLOCK_SCARF(bool _createToken);
public:
    void mASSIGN_RHS(bool _createToken);
protected:
    void mSL_COMMENT(bool _createToken);
protected:
    void mML_COMMENT(bool _createToken);
protected:
    void mESC(bool _createToken);
protected:
    void mDIGIT(bool _createToken);
protected:
    void mXDIGIT(bool _createToken);
public:
    void mARG_ACTION(bool _createToken);
private:
    static longArray mk_tokenSet_0();
public:
    static MParser_BitSet _tokenSet_0;
private:
    static longArray mk_tokenSet_1();
public:
    static MParser_BitSet _tokenSet_1;
private:
    static longArray mk_tokenSet_2();
public:
    static MParser_BitSet _tokenSet_2;
private:
    static longArray mk_tokenSet_3();
public:
    static MParser_BitSet _tokenSet_3;
private:
    static longArray mk_tokenSet_4();
public:
    static MParser_BitSet _tokenSet_4;
private:
    static longArray mk_tokenSet_5();
public:
    static MParser_BitSet _tokenSet_5;
private:
    static longArray mk_tokenSet_6();
public:
    static MParser_BitSet _tokenSet_6;
private:
    static longArray mk_tokenSet_7();
public:
    static MParser_BitSet _tokenSet_7;
private:
    static longArray mk_tokenSet_8();
public:
    static MParser_BitSet _tokenSet_8;
private:
    static longArray mk_tokenSet_9();
public:
    static MParser_BitSet _tokenSet_9;
private:
    static longArray mk_tokenSet_10();
public:
    static MParser_BitSet _tokenSet_10;
};

#endif /* __MGRAMMAR_PREPROCESSORLEXER_H__ */
