#ifndef __MGRAMMAR_PREPROCESSOR_H__
#define __MGRAMMAR_PREPROCESSOR_H__
#include "MLANG/String.h"
#include "MLANG/Vector_T.h"
#include "MLANG/SmartPtr.h"
#include "MParser/BitSet.h"
#include "MParser/TokenStream.h"
#include "MParser/TokenBuffer.h"
#include "MParser/ParserSharedInputState.h"
#include "MParser/LLkParser.h"
#include "MParser/RecognitionException.h"
#include "MGrammar/Tool.h"
#include "MGrammar/Preprocessor/Hierarchy.h"
#include "MGrammar/Preprocessor/Grammar.h"
#include "MGrammar/PreprocessorOption.h"
#include "MGrammar/PreprocessorRule.h"
#include "MGrammar/PreprocessorTokenTypes.h"

class MGrammar_Preprocessor;
typedef MGrammar_Preprocessor *MGrammar_Preprocessor_ptr;
typedef MLANG_SmartPtr<MGrammar_Preprocessor> MGrammar_Preprocessor_var;

// $ANTLR 2.7.4: "preproc.g" -> "Preprocessor.java"$

class MGrammar_Preprocessor : public MParser_LLkParser,
                              public MGrammar_PreprocessorTokenTypes
{
public:
   typedef MParser_LLkParser super;
	// This chunk of error reporting code provided by Brian Smith

private:
   MGrammar_Tool_ptr antlrTool_;

    /** In order to make it so existing subclasses don't break, we won't require
     * that the antlr.Tool instance be passed as a constructor element. Instead,
     * the antlr.Tool instance should register itself via {@link #initTool(antlr.Tool)}
     * @throws IllegalStateException if a tool has already been registered
     * @since 2.7.2
     */
public:
    void setTool(MGrammar_Tool_ptr tool);

    /** @since 2.7.2 */
protected:
   MGrammar_Tool_ptr getTool();

    /** Delegates the error message to the tool if any was registered via
     *  {@link #initTool(antlr.Tool)}
     *  @since 2.7.2
     */
public:
    void reportError(const MLANG_String& s);

    /** Delegates the error message to the tool if any was registered via
     *  {@link #initTool(antlr.Tool)}
     *  @since 2.7.2
     */
public:
    void reportError(MParser_RecognitionException& e);

    /** Delegates the warning message to the tool if any was registered via
     *  {@link #initTool(antlr.Tool)}
     *  @since 2.7.2
     */
public:
   void reportWarning(const MLANG_String& s);
protected:
   MGrammar_Preprocessor (const MParser_TokenBuffer_var& tokenBuf, int k);
public:
   MGrammar_Preprocessor(const MParser_TokenBuffer_var& tokenBuf);
protected:
   MGrammar_Preprocessor(const MParser_TokenStream_var& lexer, int k);
public:
   MGrammar_Preprocessor (const MParser_TokenStream_var& lexer);
public:
   MGrammar_Preprocessor(const MParser_ParserSharedInputState_var& state);
public:
   virtual ~MGrammar_Preprocessor();
public:

   static bool is_nil (MGrammar_Preprocessor_ptr parser)
   { return parser == 0; }

   static MGrammar_Preprocessor_ptr _nil()
   { return 0; }

   static MGrammar_Preprocessor_ptr _duplicate(MGrammar_Preprocessor_ptr parser)
   { return MLANG_acquire(parser); }

public:
   void grammarFile (
     const MGrammar_Hierarchy_var& hier,
     const MLANG_String& file
   );
public:
   MGrammar_PreprocessorGrammar::OPTIONS  optionSpec (
      const MGrammar_PreprocessorGrammar_var& gr
    );
public:
   MGrammar_PreprocessorGrammar_var  class_def (
     const MLANG_String& file,
     const MGrammar_Hierarchy_var& hier
    );
public:
   MLANG_String  superClass();
public:
   void rule (
      const MGrammar_PreprocessorGrammar_var& gr
    );
public:
   MLANG_String throwsSpec();
public:
   MLANG_String  exceptionGroup();
public:
   MLANG_String  exceptionSpec();
public:
   MLANG_String  exceptionHandler();
public:
   static const char *_tokenNames[];
private:
   static longArray mk_tokenSet_0();
public:
   static MParser_BitSet _tokenSet_0;
private:
   static longArray mk_tokenSet_1();
public:
   static MParser_BitSet _tokenSet_1;
private:
   static longArray mk_tokenSet_2();
public:
   static MParser_BitSet _tokenSet_2;
private:
   static longArray mk_tokenSet_3();
public:
   static MParser_BitSet _tokenSet_3;
private:
   static longArray mk_tokenSet_4();
public:
   static MParser_BitSet _tokenSet_4;
private:
   static longArray mk_tokenSet_5();
public:
   static MParser_BitSet _tokenSet_5;
private:
   static longArray mk_tokenSet_6();
public:
   static MParser_BitSet _tokenSet_6;
private:
   static longArray mk_tokenSet_7();
public:
   static MParser_BitSet _tokenSet_7;
private:
   static longArray mk_tokenSet_8();
public:
   static MParser_BitSet _tokenSet_8;
};

#endif /* __MGRAMMAR_PREPROCESSOR_H__ */
