#include "MParser/CharBuffer.h"
#include "MParser/ByteBuffer.h"
#include "MParser/CharStreamException.h"
#include "MParser/CharStreamIOException.h"
#include "MParser/NoViableAltForCharException.h"
#include "MParser/TokenStreamIOException.h"
#include "MParser/TokenStreamRecognitionException.h"
#include "MGrammar/PreprocessorLexer.h"

// $ANTLR 2.7.4: "preproc.g" -> "PreprocessorLexer.java"$

void MGrammar_PreprocessorLexer::init()

{
   caseSensitiveLiterals_ = true;
   setCaseSensitive(true);
   literals_.put("public", 18);
   literals_.put("class", 8);
   literals_.put("throws", 23);
   literals_.put("catch", 26);
   literals_.put("private", 17);
   literals_.put("extends", 10);
   literals_.put("protected", 16);
   literals_.put("returns", 21);
   literals_.put("tokens", 4);
   literals_.put("exception", 25);
}

MGrammar_PreprocessorLexer::MGrammar_PreprocessorLexer (
   const MIO_InputStream_var& in
) : super(new MParser_ByteBuffer(in))

{
   this->init();
}
MGrammar_PreprocessorLexer::MGrammar_PreprocessorLexer (
   const MIO_Reader_var& in
) : super(new MParser_CharBuffer(in))

{
   this->init();
}

MGrammar_PreprocessorLexer::MGrammar_PreprocessorLexer (
   const MParser_InputBuffer_var& ib
) : super(ib)

{
   this->init();
}

MGrammar_PreprocessorLexer::MGrammar_PreprocessorLexer (
   const MParser_LexerSharedInputState_var& state
)
   : super(state)
{
   this->init();
}

MParser_Token_var MGrammar_PreprocessorLexer::nextToken()

{
   MParser_Token_var theRetToken;
   LABEL(tryAgain)
   for (;;)
    {
      MParser_Token_var _token;
      int _ttype = MParser_Token::INVALID_TYPE;
      resetText();
      try
       {
         // for char stream error handling
         try
           { 
             // for lexical error handling
             switch ( LA(1))
             {
             case ':':
                    {
                      mRULE_BLOCK(true);
                      theRetToken=returnToken_;
                      break;
                    }
             case '\t':  case '\n':  case '\r':  case ' ':
                    {
                      mWS(true);
                      theRetToken=returnToken_;
                      break;
                    }
             case '/':
                    {
                      mCOMMENT(true);
                      theRetToken=returnToken_;
                      break;
                    }
             case '{':
                    {
                      mACTION(true);
                      theRetToken=returnToken_;
                      break;
                    }
              case '"':
                    {
                      mSTRING_LITERAL(true);
                      theRetToken=returnToken_;
                      break;
                    }
              case '\'':
                    {
                      mCHAR_LITERAL(true);
                      theRetToken=returnToken_;
                      break;
                    }
              case '!':
                    {
                      mBANG(true);
                      theRetToken=returnToken_;
                      break;
                    }
              case ';':
                    {
                      mSEMI(true);
                      theRetToken=returnToken_;
                      break;
                    }
              case ',':
                    {
                      mCOMMA(true);
                      theRetToken=returnToken_;
                      break;
                    }
              case '}':
                    {
                      mRCURLY(true);
                      theRetToken=returnToken_;
                      break;
                    }
              case ')':
                    {
                      mRPAREN(true);
                      theRetToken=returnToken_;
                      break;
                    }
              case 'A':  case 'B':  case 'C':  case 'D':
              case 'E':  case 'F':  case 'G':  case 'H':
              case 'I':  case 'J':  case 'K':  case 'L':
              case 'M':  case 'N':  case 'O':  case 'P':
              case 'Q':  case 'R':  case 'S':  case 'T':
              case 'U':  case 'V':  case 'W':  case 'X':
              case 'Y':  case 'Z':  case '_':  case 'a':
              case 'b':  case 'c':  case 'd':  case 'e':
              case 'f':  case 'g':  case 'h':  case 'i':
              case 'j':  case 'k':  case 'l':  case 'm':
              case 'n':  case 'o':  case 'p':  case 'q':
              case 'r':  case 's':  case 't':  case 'u':
              case 'v':  case 'w':  case 'x':  case 'y':
              case 'z':
                    {
                      mID_OR_KEYWORD(true);
                      theRetToken=returnToken_;
                      break;
                    }
              case '=':
                    {
                      mASSIGN_RHS(true);
                      theRetToken=returnToken_;
                      break;
                    }
              case '[':
                    {
                      mARG_ACTION(true);
                      theRetToken=returnToken_;
                      break;
                    }
              default:
                      if ((LA(1)=='(') && (_tokenSet_0.member(LA(2))))
                       {
                         mSUBRULE_BLOCK(true);
                         theRetToken=returnToken_;
                       }
                      else if ((LA(1)=='(') && (true))
                       {
                         mLPAREN(true);
                         theRetToken=returnToken_;
                       }
                      else
                       {
                         if (LA(1)==EOF_CHAR)
                         {uponEOF(); returnToken_ = makeToken(MParser_Token::EOF_TYPE);}
                         else {throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());}
                        }
              }
             if ( MParser_Token::is_nil(returnToken_)) CONTINUE(tryAgain); // found SKIP token
             _ttype = returnToken_->getType();
             _ttype = testLiteralsTable(_ttype);
             returnToken_->setType(_ttype);
             return returnToken_;
           }
          catch (MParser_RecognitionException& e)
           {
              throw MParser_TokenStreamRecognitionException(e);
           }
        }
       catch (MParser_CharStreamException& cse)
        {
          if ( ACE_dynamic_cast(MParser_CharStreamIOException*, &cse))
           {
             throw MParser_TokenStreamIOException(((MParser_CharStreamIOException&)cse).io);
           }
          else
           {
             throw MParser_TokenStreamException(cse.getMessage().c_str());
           }
        }
   }
}

void MGrammar_PreprocessorLexer::mRULE_BLOCK(bool _createToken)

{
   int _ttype; MParser_Token_var _token; int _begin=text_.length();
   _ttype = RULE_BLOCK;
   int _saveIndex;
                
   match(':');
   {
     if ((_tokenSet_1.member(LA(1))) && (_tokenSet_2.member(LA(2))))
      {
        _saveIndex=text_.length();
        mWS(false);
        text_.setLength(_saveIndex);
      }
     else if ((_tokenSet_2.member(LA(1))) && (true))
      {
      }
     else
      {
        throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
      }
                
   }
   mALT(false);
   {
     switch ( LA(1))
     {
     case '\t':  case '\n':  case '\r':  case ' ':
     {
          _saveIndex=text_.length();
          mWS(false);
          text_.setLength(_saveIndex);
          break;
     }
     case ';':  case '|':
     {
          break;
     }
     default:
     {
          throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
     }
     }
   }
   {
     LABEL(_loop44)
     do {
        if ((LA(1)=='|'))
         {
           match('|');
           {
             if ((_tokenSet_1.member(LA(1))) && (_tokenSet_2.member(LA(2))))
              {
                _saveIndex=text_.length();
                mWS(false);
                text_.setLength(_saveIndex);
              }
             else if ((_tokenSet_2.member(LA(1))) && (true))
              {
              }
             else
              {
                throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
              }
           }
           mALT(false);
           {
             switch ( LA(1))
             {
             case '\t':  case '\n':  case '\r':  case ' ':
                  {
                    _saveIndex=text_.length();
                    mWS(false);
                    text_.setLength(_saveIndex);
                    break;
                  }
             case ';':  case '|':
                  {
                    break;
                  }
             default:
                  {
                    throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
                  }
             }
           }
         }
        else
         {
           BREAK(_loop44);
         }
                        
       }
      while (true);
   }
   match(';');
   if ( _createToken && MParser_Token::is_nil(_token) && _ttype!=MParser_Token::SKIP )
    {
      _token = makeToken(_ttype);
      _token->setText(MLANG_String(text_.getBuffer() + _begin, text_.length()-_begin));
    }
   returnToken_ = _token;
}
        
void MGrammar_PreprocessorLexer::mWS(bool _createToken)

{
   int _ttype; MParser_Token_var _token; int _begin=text_.length();
   _ttype = WS;
   int _saveIndex;
                
   {
      int _cnt86=0;
      LABEL(_loop86)
      do
       {
          if ((LA(1)==' ') && (true))
           {
             match(' ');
           }
          else if ((LA(1)=='\t') && (true))
           {
             match('\t');
           }
          else if ((LA(1)=='\n'||LA(1)=='\r') && (true))
           {
             mNEWLINE(false);
           }
          else
           {
             if ( _cnt86>=1 )
             { BREAK(_loop86); }
             else {throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());}
           }
                        
           _cnt86++;
        }
       while (true);
   }
  _ttype = MParser_Token::SKIP;
  if ( _createToken && MParser_Token::is_nil(_token) && _ttype!=MParser_Token::SKIP )
   {
      _token = makeToken(_ttype);
      _token->setText(MLANG_String(text_.getBuffer() + _begin, text_.length()-_begin));
   }
  returnToken_ = _token;
}
        
void MGrammar_PreprocessorLexer::mALT(bool _createToken)

{
   int _ttype; MParser_Token_var _token; int _begin=text_.length();
   _ttype = ALT;
   int _saveIndex;
                
   {
      LABEL(_loop55)
      do
       {
          if ((_tokenSet_3.member(LA(1))) && ((LA(2) >= int(0x03) && LA(2) <= int(0xff))))
           {
              mELEMENT(false);
           }
          else
           {
              BREAK(_loop55);
           }
                     
       }
      while (true);
   }
   if ( _createToken && MParser_Token::is_nil(_token) && _ttype!=MParser_Token::SKIP )
    {
       _token = makeToken(_ttype);
       _token->setText(MLANG_String(text_.getBuffer() + _begin, text_.length()-_begin));
    }
   returnToken_ = _token;
}
        
void MGrammar_PreprocessorLexer::mSUBRULE_BLOCK(bool _createToken)

{
   int _ttype; MParser_Token_var _token; int _begin=text_.length();
   _ttype = SUBRULE_BLOCK;
   int _saveIndex;
                
   match('(');
   {
      if ((_tokenSet_1.member(LA(1))) && (_tokenSet_0.member(LA(2))))
       {
         mWS(false);
       }
      else if ((_tokenSet_0.member(LA(1))) && (true))
       {
       }
      else
       {
         throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
       }
   }
   mALT(false);
   {
      LABEL(_loop50)
      do
       {
         if ((_tokenSet_4.member(LA(1))) && (_tokenSet_0.member(LA(2))))
          {
            {
               switch ( LA(1))
               {
               case '\t':  case '\n':  case '\r':  case ' ':
                    {
                      mWS(false);
                      break;
                    }
               case '|':
                    {
                      break;
                    }
               default:
                    {
                      throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
                    }
               }
            }
            match('|');
            {
               if ((_tokenSet_1.member(LA(1))) && (_tokenSet_0.member(LA(2))))
                {
                  mWS(false);
                }
               else if ((_tokenSet_0.member(LA(1))) && (true))
                {
                }
               else
                {
                  throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
                }
            }
            mALT(false);
          }
         else
          {
            BREAK(_loop50);
          }
        }
       while (true);
    }
    {
       switch ( LA(1))
       {
                case '\t':  case '\n':  case '\r':  case ' ':
                {
                        mWS(false);
                        break;
        }
                case ')':
                {
                        break;
        }
                default:
                {
                        throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
        }
        }
        }
                match(')');
                {
                if ((LA(1)=='=') && (LA(2)=='>'))
{
                        match("=>");
        }
                else if ((LA(1)=='*') && (true))
{
                        match('*');
        }
                else if ((LA(1)=='+') && (true))
{
                        match('+');
        }
                else if ((LA(1)=='?') && (true))
{
                        match('?');
        }
                else {
        }
                
        }
                if ( _createToken && MParser_Token::is_nil(_token) && _ttype!=MParser_Token::SKIP )
{
                        _token = makeToken(_ttype);
                        _token->setText(MLANG_String(text_.getBuffer() + _begin, text_.length()-_begin));
        }
                returnToken_ = _token;
}
        
void MGrammar_PreprocessorLexer::mELEMENT(bool _createToken)

{
                int _ttype; MParser_Token_var _token; int _begin=text_.length();
                _ttype = ELEMENT;
                int _saveIndex;
                
                switch ( LA(1))
{
                case '/':
                {
                        mCOMMENT(false);
                        break;
        }
                case '{':
                {
                        mACTION(false);
                        break;
        }
                case '"':
                {
                        mSTRING_LITERAL(false);
                        break;
        }
                case '\'':
                {
                        mCHAR_LITERAL(false);
                        break;
        }
                case '(':
                {
                        mSUBRULE_BLOCK(false);
                        break;
        }
                case '\n':  case '\r':
                {
                        mNEWLINE(false);
                        break;
        }
                default:
                        if ((_tokenSet_5.member(LA(1))))
{
                                {
                                match(_tokenSet_5);
                        }
                }
                else {
                        throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
        }
        }
                if ( _createToken && MParser_Token::is_nil(_token) && _ttype!=MParser_Token::SKIP )
{
                        _token = makeToken(_ttype);
                        _token->setText(MLANG_String(text_.getBuffer() + _begin, text_.length()-_begin));
        }
                returnToken_ = _token;
}
        
void MGrammar_PreprocessorLexer::mCOMMENT(bool _createToken)

{
                int _ttype; MParser_Token_var _token; int _begin=text_.length();
                _ttype = COMMENT;
                int _saveIndex;
                
                {
                if ((LA(1)=='/') && (LA(2)=='/'))
{
                        mSL_COMMENT(false);
        }
                else if ((LA(1)=='/') && (LA(2)=='*'))
{
                        mML_COMMENT(false);
        }
                else {
                        throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
        }
                
        }
                _ttype = MParser_Token::SKIP;
                if ( _createToken && MParser_Token::is_nil(_token) && _ttype!=MParser_Token::SKIP )
{
                        _token = makeToken(_ttype);
                        _token->setText(MLANG_String(text_.getBuffer() + _begin, text_.length()-_begin));
        }
                returnToken_ = _token;
}
        
void MGrammar_PreprocessorLexer::mACTION(bool _createToken)

{
                int _ttype; MParser_Token_var _token; int _begin=text_.length();
                _ttype = ACTION;
                int _saveIndex;
                
                match('{');
                {
                LABEL(_loop116)
                do {
                        // nongreedy exit test
                        if ((LA(1)=='}') && (true)) BREAK(_loop116);
                        if ((LA(1)=='\n'||LA(1)=='\r') && ((LA(2) >= int(0x03) && LA(2) <= int(0xff))))
{
                                mNEWLINE(false);
                }
                        else if ((LA(1)=='{') && ((LA(2) >= int(0x03) && LA(2) <= int(0xff))))
{
                                mACTION(false);
                }
                        else if ((LA(1)=='\'') && (_tokenSet_6.member(LA(2))))
{
                                mCHAR_LITERAL(false);
                }
                        else if ((LA(1)=='/') && (LA(2)=='*'||LA(2)=='/'))
{
                                mCOMMENT(false);
                }
                        else if ((LA(1)=='"') && ((LA(2) >= int(0x03) && LA(2) <= int(0xff))))
{
                                mSTRING_LITERAL(false);
                }
                        else if (((LA(1) >= int(0x03) && LA(1) <= int(0xff))) && ((LA(2) >= int(0x03) && LA(2) <= int(0xff))))
{
                                matchNot(EOF_CHAR);
                }
                        else {
                                BREAK(_loop116);
                }
                        
        } while (true);
        }
                match('}');
                if ( _createToken && MParser_Token::is_nil(_token) && _ttype!=MParser_Token::SKIP )
{
                        _token = makeToken(_ttype);
                        _token->setText(MLANG_String(text_.getBuffer() + _begin, text_.length()-_begin));
        }
                returnToken_ = _token;
}
        
void MGrammar_PreprocessorLexer::mSTRING_LITERAL(bool _createToken)

{
                int _ttype; MParser_Token_var _token; int _begin=text_.length();
                _ttype = STRING_LITERAL;
                int _saveIndex;
                
                match('"');
                {
                LABEL(_loop101)
                do {
                        if ((LA(1)=='\\'))
{
                                mESC(false);
                }
                        else if ((_tokenSet_7.member(LA(1))))
{
                                matchNot('"');
                }
                        else {
                                BREAK(_loop101);
                }
                        
        } while (true);
        }
                match('"');
                if ( _createToken && MParser_Token::is_nil(_token) && _ttype!=MParser_Token::SKIP )
{
                        _token = makeToken(_ttype);
                        _token->setText(MLANG_String(text_.getBuffer() + _begin, text_.length()-_begin));
        }
                returnToken_ = _token;
}
        
void MGrammar_PreprocessorLexer::mCHAR_LITERAL(bool _createToken)

{
                int _ttype; MParser_Token_var _token; int _begin=text_.length();
                _ttype = CHAR_LITERAL;
                int _saveIndex;
                
                match('\'');
                {
                if ((LA(1)=='\\'))
{
                        mESC(false);
        }
                else if ((_tokenSet_8.member(LA(1))))
{
                        matchNot('\'');
        }
                else {
                        throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
        }
                
        }
                match('\'');
                if ( _createToken && MParser_Token::is_nil(_token) && _ttype!=MParser_Token::SKIP )
{
                        _token = makeToken(_ttype);
                        _token->setText(MLANG_String(text_.getBuffer() + _begin, text_.length()-_begin));
        }
                returnToken_ = _token;
}
        
void MGrammar_PreprocessorLexer::mNEWLINE(bool _createToken)

{
                int _ttype; MParser_Token_var _token; int _begin=text_.length();
                _ttype = NEWLINE;
                int _saveIndex;
                
                {
                if ((LA(1)=='\r') && (LA(2)=='\n'))
{
                        match('\r');
                        match('\n');
                        newline();
        }
                else if ((LA(1)=='\r') && (true))
{
                        match('\r');
                        newline();
        }
                else if ((LA(1)=='\n'))
{
                        match('\n');
                        newline();
        }
                else {
                        throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
        }
                
        }
                if ( _createToken && MParser_Token::is_nil(_token) && _ttype!=MParser_Token::SKIP )
{
                        _token = makeToken(_ttype);
                        _token->setText(MLANG_String(text_.getBuffer() + _begin, text_.length()-_begin));
        }
                returnToken_ = _token;
}
        
void MGrammar_PreprocessorLexer::mBANG(bool _createToken)

{
   int _ttype; MParser_Token_var _token; int _begin=text_.length();
   _ttype = BANG;
   int _saveIndex;
                
   match('!');
   if ( _createToken && MParser_Token::is_nil(_token) && _ttype!=MParser_Token::SKIP )
    {
                        _token = makeToken(_ttype);
                        _token->setText(MLANG_String(text_.getBuffer() + _begin, text_.length()-_begin));
        }
                returnToken_ = _token;
}
        
void MGrammar_PreprocessorLexer::mSEMI(bool _createToken)

{
   int _ttype; MParser_Token_var _token; int _begin=text_.length();
   _ttype = SEMI;
   int _saveIndex;
                
   match(';');
   if ( _createToken && MParser_Token::is_nil(_token) && _ttype!=MParser_Token::SKIP )
    {
       _token = makeToken(_ttype);
       _token->setText(MLANG_String(text_.getBuffer() + _begin, text_.length()-_begin));
    }
   returnToken_ = _token;
}
        
void MGrammar_PreprocessorLexer::mCOMMA(bool _createToken)

{
   int _ttype; MParser_Token_var _token; int _begin=text_.length();
   _ttype = COMMA;
   int _saveIndex;
                
   match(',');
   if ( _createToken && MParser_Token::is_nil(_token) && _ttype!=MParser_Token::SKIP )
    {
      _token = makeToken(_ttype);
      _token->setText(MLANG_String(text_.getBuffer() + _begin, text_.length()-_begin));
    }
   returnToken_ = _token;
}
        
void MGrammar_PreprocessorLexer::mRCURLY(bool _createToken)

{
                int _ttype; MParser_Token_var _token; int _begin=text_.length();
                _ttype = RCURLY;
                int _saveIndex;
                
                match('}');
   if ( _createToken && MParser_Token::is_nil(_token) && _ttype!=MParser_Token::SKIP )
    {
      _token = makeToken(_ttype);
      _token->setText(MLANG_String(text_.getBuffer() + _begin, text_.length()-_begin));
    }
   returnToken_ = _token;
}
        
void MGrammar_PreprocessorLexer::mLPAREN(bool _createToken)

{
   int _ttype; MParser_Token_var _token; int _begin=text_.length();
   _ttype = LPAREN;
   int _saveIndex;
                
   match('(');
   if ( _createToken && MParser_Token::is_nil(_token) && _ttype!=MParser_Token::SKIP )
    {
      _token = makeToken(_ttype);
      _token->setText(MLANG_String(text_.getBuffer() + _begin, text_.length()-_begin));
    }
   returnToken_ = _token;
}
        
void MGrammar_PreprocessorLexer::mRPAREN(bool _createToken)

{
                int _ttype; MParser_Token_var _token; int _begin=text_.length();
                _ttype = RPAREN;
                int _saveIndex;
                
                match(')');
                if ( _createToken && MParser_Token::is_nil(_token) && _ttype!=MParser_Token::SKIP )
{
                        _token = makeToken(_ttype);
                        _token->setText(MLANG_String(text_.getBuffer() + _begin, text_.length()-_begin));
        }
                returnToken_ = _token;
}
        
/** This rule picks off keywords in the lexer that need to be
 *  handled specially.  For example, "header" is the start
 *  of the header action (used to distinguish between options
 *  block and an action).  We do not want "header" to go back
 *  to the parser as a simple keyword...it must pick off
 *  the action afterwards.
 */
void MGrammar_PreprocessorLexer::mID_OR_KEYWORD(bool _createToken)

{
   int _ttype; MParser_Token_var _token; int _begin=text_.length();
   _ttype = ID_OR_KEYWORD;
   int _saveIndex;
   MParser_Token_var id;
 
   mID(true);
   id=returnToken_;
   _ttype = id->getType();
   {
      if (((_tokenSet_9.member(LA(1))) && ((LA(2) >= int(0x03) && LA(2) <= int(0xff))))&&(id->getText().equals("header")))
       {
         {
            if ((_tokenSet_1.member(LA(1))) && (_tokenSet_9.member(LA(2))))
             {
               mWS(false);
             }
            else if ((_tokenSet_9.member(LA(1))) && ((LA(2) >= int(0x03) && LA(2) <= int(0xff))))
             {
             }
            else
             {
               throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
             }
                        
         }
         {
            switch ( LA(1))
            {
            case '"':
                 {
                    mSTRING_LITERAL(false);
                    break;
                 }
            case '\t':  case '\n':  case '\r':  case ' ':
            case '/':  case '{':
                 {
                    break;
                 }
            default:
                 {
                    throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
                 }
            }
         }
         {
            LABEL(_loop69)
            do
             {
                switch ( LA(1))
                {
                case '\t':  case '\n':  case '\r':  case ' ':
                     {
                         mWS(false);
                         break;
                     }
                case '/':
                     {
                         mCOMMENT(false);
                         break;
                     }
                default:
                     {
                         BREAK(_loop69);
                     }
                }
             }
            while (true);
         }
         mACTION(false);
         _ttype = HEADER_ACTION;
       }
      else if (((_tokenSet_10.member(LA(1))) && ((LA(2) >= int(0x03) && LA(2) <= int(0xff))))&&(id->getText().equals("tokens")))
       {
         {
            LABEL(_loop71)
            do
             {
                switch ( LA(1))
                {
                case '\t':  case '\n':  case '\r':  case ' ':
                     {
                         mWS(false);
                         break;
                     }
                case '/':
                     {
                         mCOMMENT(false);
                         break;
                     }
                default:
                     {
                         BREAK(_loop71);
                     }
                }
             }
            while (true);
         }
        mCURLY_BLOCK_SCARF(false);
        _ttype = TOKENS_SPEC;
      }
     else if (((_tokenSet_10.member(LA(1))) && (true))&&(id->getText().equals("options")))
      {
        {
           LABEL(_loop73)
           do
            {
                switch ( LA(1))
                {
                case '\t':  case '\n':  case '\r':  case ' ':
                     {
                         mWS(false);
                         break;
                     }
                case '/':
                     {
                         mCOMMENT(false);
                         break;
                     }
                default:
                     {
                         BREAK(_loop73);
                     }
                }
             }
            while (true);
         }
         match('{');
         _ttype = OPTIONS_START;
      }
     else
      {
      }
                
   }
  if ( _createToken && MParser_Token::is_nil(_token) && _ttype!=MParser_Token::SKIP )
   {
      _token = makeToken(_ttype);
      _token->setText(MLANG_String(text_.getBuffer() + _begin, text_.length()-_begin));
   }
  returnToken_ = _token;
}
        
void MGrammar_PreprocessorLexer::mID(bool _createToken)

{
   int _ttype; MParser_Token_var _token; int _begin=text_.length();
   _ttype = ID;
   int _saveIndex;
                
   {
      switch ( LA(1))
      {
      case 'a':  case 'b':  case 'c':  case 'd':
      case 'e':  case 'f':  case 'g':  case 'h':
      case 'i':  case 'j':  case 'k':  case 'l':
      case 'm':  case 'n':  case 'o':  case 'p':
      case 'q':  case 'r':  case 's':  case 't':
      case 'u':  case 'v':  case 'w':  case 'x':
      case 'y':  case 'z':
           {
              matchRange('a','z');
              break;
           }
      case 'A':  case 'B':  case 'C':  case 'D':
      case 'E':  case 'F':  case 'G':  case 'H':
      case 'I':  case 'J':  case 'K':  case 'L':
      case 'M':  case 'N':  case 'O':  case 'P':
      case 'Q':  case 'R':  case 'S':  case 'T':
      case 'U':  case 'V':  case 'W':  case 'X':
      case 'Y':  case 'Z':
           {
              matchRange('A','Z');
              break;
           }
      case '_':
           {
              match('_');
              break;
           }
      default:
           {
              throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
           }
      }
   }
   {
      LABEL(_loop80)
      do
       {
          switch ( LA(1))
          {
          case 'a':  case 'b':  case 'c':  case 'd':
          case 'e':  case 'f':  case 'g':  case 'h':
          case 'i':  case 'j':  case 'k':  case 'l':
          case 'm':  case 'n':  case 'o':  case 'p':
          case 'q':  case 'r':  case 's':  case 't':
          case 'u':  case 'v':  case 'w':  case 'x':
          case 'y':  case 'z':
               {
                  matchRange('a','z');
                  break;
               }
          case 'A':  case 'B':  case 'C':  case 'D':
          case 'E':  case 'F':  case 'G':  case 'H':
          case 'I':  case 'J':  case 'K':  case 'L':
          case 'M':  case 'N':  case 'O':  case 'P':
          case 'Q':  case 'R':  case 'S':  case 'T':
          case 'U':  case 'V':  case 'W':  case 'X':
          case 'Y':  case 'Z':
               {
                  matchRange('A','Z');
                  break;
               }
          case '_':
               {
                  match('_');
                  break;
               }
          case '0':  case '1':  case '2':  case '3':
          case '4':  case '5':  case '6':  case '7':
          case '8':  case '9':
               {
                  matchRange('0','9');
                  break;
               }
          default:
               {
                  BREAK(_loop80);
               }
          }
       }
      while (true);
   }
   _ttype = testLiteralsTable(MLANG_String(text_.getBuffer() + _begin,text_.length()-_begin),_ttype);
   if ( _createToken && MParser_Token::is_nil(_token) && _ttype!=MParser_Token::SKIP )
    {
      _token = makeToken(_ttype);
      _token->setText(MLANG_String(text_.getBuffer() +  _begin, text_.length()-_begin));
    }
   returnToken_ = _token;
}
        
void MGrammar_PreprocessorLexer::mCURLY_BLOCK_SCARF(bool _createToken)

{
                int _ttype; MParser_Token_var _token; int _begin=text_.length();
                _ttype = CURLY_BLOCK_SCARF;
                int _saveIndex;
                
                match('{');
                {
                LABEL(_loop76)
                do {
                        // nongreedy exit test
                        if ((LA(1)=='}') && (true)) BREAK(_loop76);
                        if ((LA(1)=='\n'||LA(1)=='\r') && ((LA(2) >= int(0x03) && LA(2) <= int(0xff))))
{
                                mNEWLINE(false);
                }
                        else if ((LA(1)=='"') && ((LA(2) >= int(0x03) && LA(2) <= int(0xff))))
{
                                mSTRING_LITERAL(false);
                }
                        else if ((LA(1)=='\'') && (_tokenSet_6.member(LA(2))))
{
                                mCHAR_LITERAL(false);
                }
                        else if ((LA(1)=='/') && (LA(2)=='*'||LA(2)=='/'))
{
                                mCOMMENT(false);
                }
                        else if (((LA(1) >= int(0x03) && LA(1) <= int(0xff))) && ((LA(2) >= int(0x03) && LA(2) <= int(0xff))))
{
                                matchNot(EOF_CHAR);
                }
                        else {
                                BREAK(_loop76);
                }
                        
        } while (true);
        }
                match('}');
                if ( _createToken && MParser_Token::is_nil(_token) && _ttype!=MParser_Token::SKIP )
{
                        _token = makeToken(_ttype);
                        _token->setText(MLANG_String(text_.getBuffer() + _begin, text_.length()-_begin));
        }
                returnToken_ = _token;
}
        
void MGrammar_PreprocessorLexer::mASSIGN_RHS(bool _createToken)

{
                int _ttype; MParser_Token_var _token; int _begin=text_.length();
                _ttype = ASSIGN_RHS;
                int _saveIndex;
                
                _saveIndex=text_.length();
                match('=');
                text_.setLength(_saveIndex);
                {
                LABEL(_loop83)
                do {
                        // nongreedy exit test
                        if ((LA(1)==';') && (true)) BREAK(_loop83);
                        if ((LA(1)=='"') && ((LA(2) >= int(0x03) && LA(2) <= int(0xff))))
{
                                mSTRING_LITERAL(false);
                }
                        else if ((LA(1)=='\'') && (_tokenSet_6.member(LA(2))))
{
                                mCHAR_LITERAL(false);
                }
                        else if ((LA(1)=='\n'||LA(1)=='\r') && ((LA(2) >= int(0x03) && LA(2) <= int(0xff))))
{
                                mNEWLINE(false);
                }
                        else if (((LA(1) >= int(0x03) && LA(1) <= int(0xff))) && ((LA(2) >= int(0x03) && LA(2) <= int(0xff))))
{
                                matchNot(EOF_CHAR);
                }
                        else {
                                BREAK(_loop83);
                }
                        
        } while (true);
        }
                match(';');
                if ( _createToken && MParser_Token::is_nil(_token) && _ttype!=MParser_Token::SKIP )
{
                        _token = makeToken(_ttype);
                        _token->setText(MLANG_String(text_.getBuffer() + _begin, text_.length()-_begin));
        }
                returnToken_ = _token;
}
        
void MGrammar_PreprocessorLexer::mSL_COMMENT(bool _createToken)

{
                int _ttype; MParser_Token_var _token; int _begin=text_.length();
                _ttype = SL_COMMENT;
                int _saveIndex;
                
                match("//");
                {
                LABEL(_loop93)
                do {
                        // nongreedy exit test
                        if ((LA(1)=='\n'||LA(1)=='\r') && (true)) BREAK(_loop93);
                        if (((LA(1) >= int(0x03) && LA(1) <= int(0xff))) && ((LA(2) >= int(0x03) && LA(2) <= int(0xff))))
{
                                matchNot(EOF_CHAR);
                }
                        else {
                                BREAK(_loop93);
                }
                        
        } while (true);
        }
                mNEWLINE(false);
                if ( _createToken && MParser_Token::is_nil(_token) && _ttype!=MParser_Token::SKIP )
{
                        _token = makeToken(_ttype);
                        _token->setText(MLANG_String(text_.getBuffer() + _begin, text_.length()-_begin));
        }
                returnToken_ = _token;
}
        
void MGrammar_PreprocessorLexer::mML_COMMENT(bool _createToken)

{
                int _ttype; MParser_Token_var _token; int _begin=text_.length();
                _ttype = ML_COMMENT;
                int _saveIndex;
                
                match("/*");
                {
                LABEL(_loop96)
                do {
                        // nongreedy exit test
                        if ((LA(1)=='*') && (LA(2)=='/')) BREAK(_loop96);
                        if ((LA(1)=='\n'||LA(1)=='\r') && ((LA(2) >= int(0x03) && LA(2) <= int(0xff))))
{
                                mNEWLINE(false);
                }
                        else if (((LA(1) >= int(0x03) && LA(1) <= int(0xff))) && ((LA(2) >= int(0x03) && LA(2) <= int(0xff))))
{
                                matchNot(EOF_CHAR);
                }
                        else {
                                BREAK(_loop96);
                }
                        
        } while (true);
        }
                match("*/");
                if ( _createToken && MParser_Token::is_nil(_token) && _ttype!=MParser_Token::SKIP )
{
                        _token = makeToken(_ttype);
                        _token->setText(MLANG_String(text_.getBuffer() + _begin, text_.length()-_begin));
        }
                returnToken_ = _token;
}
        
void MGrammar_PreprocessorLexer::mESC(bool _createToken)

{
                int _ttype; MParser_Token_var _token; int _begin=text_.length();
                _ttype = ESC;
                int _saveIndex;
                
                match('\\');
                {
                switch ( LA(1))
{
                case 'n':
                {
                        match('n');
                        break;
        }
                case 'r':
                {
                        match('r');
                        break;
        }
                case 't':
                {
                        match('t');
                        break;
        }
                case 'b':
                {
                        match('b');
                        break;
        }
                case 'f':
                {
                        match('f');
                        break;
        }
                case 'w':
                {
                        match('w');
                        break;
        }
                case 'a':
                {
                        match('a');
                        break;
        }
                case '"':
                {
                        match('"');
                        break;
        }
                case '\'':
                {
                        match('\'');
                        break;
        }
                case '\\':
                {
                        match('\\');
                        break;
        }
                case '0':  case '1':  case '2':  case '3':
                {
                        {
                        matchRange('0','3');
                }
                        {
                        if (((LA(1) >= '0' && LA(1) <= '9')) && ((LA(2) >= int(0x03) && LA(2) <= int(0xff))))
{
                                mDIGIT(false);
                                {
                                if (((LA(1) >= '0' && LA(1) <= '9')) && ((LA(2) >= int(0x03) && LA(2) <= int(0xff))))
{
                                        mDIGIT(false);
                        }
                                else if (((LA(1) >= int(0x03) && LA(1) <= int(0xff))) && (true))
{
                        }
                                else {
                                        throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
                        }
                                
                        }
                }
                        else if (((LA(1) >= int(0x03) && LA(1) <= int(0xff))) && (true))
{
                }
                        else {
                                throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
                }
                        
                }
                        break;
        }
                case '4':  case '5':  case '6':  case '7':
                {
                        {
                        matchRange('4','7');
                }
                        {
                        if (((LA(1) >= '0' && LA(1) <= '9')) && ((LA(2) >= int(0x03) && LA(2) <= int(0xff))))
{
                                mDIGIT(false);
                }
                        else if (((LA(1) >= int(0x03) && LA(1) <= int(0xff))) && (true))
{
                }
                        else {
                                throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
                }
                        
                }
                        break;
        }
                case 'u':
                {
                        match('u');
                        mXDIGIT(false);
                        mXDIGIT(false);
                        mXDIGIT(false);
                        mXDIGIT(false);
                        break;
        }
                default:
                {
                        throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
        }
        }
        }
                if ( _createToken && MParser_Token::is_nil(_token) && _ttype!=MParser_Token::SKIP )
{
                        _token = makeToken(_ttype);
                        _token->setText(MLANG_String(text_.getBuffer() + _begin, text_.length()-_begin));
        }
                returnToken_ = _token;
}
        
void MGrammar_PreprocessorLexer::mDIGIT(bool _createToken)

{
   int _ttype; MParser_Token_var _token; int _begin=text_.length();
   _ttype = DIGIT;
   int _saveIndex;
                
   matchRange('0','9');
   if ( _createToken && MParser_Token::is_nil(_token) && _ttype!=MParser_Token::SKIP )
    {
      _token = makeToken(_ttype);
      _token->setText(MLANG_String(text_.getBuffer() + _begin, text_.length()-_begin));
    }
   returnToken_ = _token;
}
        
void MGrammar_PreprocessorLexer::mXDIGIT(bool _createToken)

{
   int _ttype; MParser_Token_var _token; int _begin=text_.length();
   _ttype = XDIGIT;
   int _saveIndex;
                
   switch ( LA(1))
   {
   case '0':  case '1':  case '2':  case '3':
   case '4':  case '5':  case '6':  case '7':
   case '8':  case '9':
   {
           matchRange('0','9');
           break;
   }
   case 'a':  case 'b':  case 'c':  case 'd':
   case 'e':  case 'f':
   {
           matchRange('a','f');
           break;
   }
   case 'A':  case 'B':  case 'C':  case 'D':
   case 'E':  case 'F':
   {
           matchRange('A','F');
           break;
   }
   default:
   {
           throw MParser_NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
   }
   }
   if ( _createToken && MParser_Token::is_nil(_token) && _ttype!=MParser_Token::SKIP )
    {
      _token = makeToken(_ttype);
      _token->setText(MLANG_String(text_.getBuffer() + _begin, text_.length()-_begin));
    }
   returnToken_ = _token;
}
        
void MGrammar_PreprocessorLexer::mARG_ACTION(bool _createToken)

{
   int _ttype; MParser_Token_var _token; int _begin=text_.length();
   _ttype = ARG_ACTION;
   int _saveIndex;
                
   match('[');
   {
      LABEL(_loop113)
      do {
         // nongreedy exit test
         if ((LA(1)==']') && (true)) BREAK(_loop113);
         if ((LA(1)=='[') && ((LA(2) >= int(0x03) && LA(2) <= int(0xff))))
          {
            mARG_ACTION(false);
          }
         else if ((LA(1)=='\n'||LA(1)=='\r') && ((LA(2) >= int(0x03) && LA(2) <= int(0xff))))
          {
            mNEWLINE(false);
          }
         else if ((LA(1)=='\'') && (_tokenSet_6.member(LA(2))))
          {
            mCHAR_LITERAL(false);
          }
         else if ((LA(1)=='"') && ((LA(2) >= int(0x03) && LA(2) <= int(0xff))))
          {
            mSTRING_LITERAL(false);
          }
         else if (((LA(1) >= int(0x03) && LA(1) <= int(0xff))) && ((LA(2) >= int(0x03) && LA(2) <= int(0xff))))
          {
            matchNot(EOF_CHAR);
          }
         else
          {
            BREAK(_loop113);
          }
                        
        }
       while (true);
   }
   match(']');
   if ( _createToken && MParser_Token::is_nil(_token) && _ttype!=MParser_Token::SKIP )
    {
      _token = makeToken(_ttype);
      _token->setText(MLANG_String(text_.getBuffer() + _begin, text_.length()-_begin));
    }
   returnToken_ = _token;
}
        
longArray MGrammar_PreprocessorLexer::mk_tokenSet_0()
{
   static ACE_UINT64 data[8];
   data[0]=-576460752303423496L;
   for (int i = 1; i<=3; i++)
   { data[i]=-1L; }
   return longArray(data, sizeof(data)/sizeof(data[0]));
}
MParser_BitSet MGrammar_PreprocessorLexer::_tokenSet_0(MGrammar_PreprocessorLexer::mk_tokenSet_0());
longArray MGrammar_PreprocessorLexer::mk_tokenSet_1()
{
   static ACE_UINT64 data[] = { 4294977024L, 0L, 0L, 0L, 0L};
   return longArray(data, sizeof(data)/sizeof(data[0]));
}
MParser_BitSet MGrammar_PreprocessorLexer::_tokenSet_1(MGrammar_PreprocessorLexer::mk_tokenSet_1());
longArray MGrammar_PreprocessorLexer::mk_tokenSet_2()
{
   static ACE_UINT64 data[8];
   data[0]=-2199023255560L;
   for (int i = 1; i<=3; i++)
   { data[i]=-1L; }
   return longArray(data, sizeof(data)/sizeof(data[0]));
}
MParser_BitSet MGrammar_PreprocessorLexer::_tokenSet_2(MGrammar_PreprocessorLexer::mk_tokenSet_2());
longArray MGrammar_PreprocessorLexer::mk_tokenSet_3()
{
   static ACE_UINT64 data[8];
   data[0]=-576462951326679048L;
   for (int i = 1; i<=3; i++)
   { data[i]=-1L; }
   return longArray(data, sizeof(data)/sizeof(data[0]));
}
MParser_BitSet MGrammar_PreprocessorLexer::_tokenSet_3(MGrammar_PreprocessorLexer::mk_tokenSet_3());
longArray MGrammar_PreprocessorLexer::mk_tokenSet_4()
{
   static ACE_UINT64 data[] = { 4294977024L, 1152921504606846976L, 0L, 0L, 0L};
   return longArray(data, sizeof(data)/sizeof(data[0]));
}
MParser_BitSet MGrammar_PreprocessorLexer::_tokenSet_4(MGrammar_PreprocessorLexer::mk_tokenSet_4());
longArray MGrammar_PreprocessorLexer::mk_tokenSet_5()
{
   static ACE_UINT64 data[8];
   data[0]=-576605355262354440L;
   data[1]=-576460752303423489L;
   for (int i = 2; i<=3; i++)
   { data[i]=-1L; }
   return longArray(data, sizeof(data)/sizeof(data[0]));
}
MParser_BitSet MGrammar_PreprocessorLexer::_tokenSet_5(MGrammar_PreprocessorLexer::mk_tokenSet_5());
longArray MGrammar_PreprocessorLexer::mk_tokenSet_6()
{
   static ACE_UINT64 data[8];
   data[0]=-549755813896L;
   for (int i = 1; i<=3; i++)
   { data[i]=-1L; }
   return longArray(data, sizeof(data)/sizeof(data[0]));
}
MParser_BitSet MGrammar_PreprocessorLexer::_tokenSet_6(MGrammar_PreprocessorLexer::mk_tokenSet_6());
longArray MGrammar_PreprocessorLexer::mk_tokenSet_7()
{
   static ACE_UINT64 data[8];
   data[0]=-17179869192L;
   data[1]=-268435457L;
   for (int i = 2; i<=3; i++)
   { data[i]=-1L; }
   return longArray(data, sizeof(data)/sizeof(data[0]));
}
MParser_BitSet MGrammar_PreprocessorLexer::_tokenSet_7(MGrammar_PreprocessorLexer::mk_tokenSet_7());
longArray MGrammar_PreprocessorLexer::mk_tokenSet_8()
{
   static ACE_UINT64 data[8];
   data[0]=-549755813896L;
   data[1]=-268435457L;
   for (int i = 2; i<=3; i++)
    { data[i]=-1L; }
   return longArray(data, sizeof(data)/sizeof(data[0]));
}
MParser_BitSet MGrammar_PreprocessorLexer::_tokenSet_8(MGrammar_PreprocessorLexer::mk_tokenSet_8());
longArray MGrammar_PreprocessorLexer::mk_tokenSet_9()
{
   static ACE_UINT64 data[] = { 140758963201536L, 576460752303423488L, 0L, 0L, 0L};
   return longArray(data, sizeof(data)/sizeof(data[0]));
}
MParser_BitSet MGrammar_PreprocessorLexer::_tokenSet_9(MGrammar_PreprocessorLexer::mk_tokenSet_9());
longArray MGrammar_PreprocessorLexer::mk_tokenSet_10()
{
   static ACE_UINT64 data[] = { 140741783332352L, 576460752303423488L, 0L, 0L, 0L};
   return longArray(data, sizeof(data)/sizeof(data[0]));
}
MParser_BitSet MGrammar_PreprocessorLexer::_tokenSet_10(MGrammar_PreprocessorLexer::mk_tokenSet_10());

MGrammar_PreprocessorLexer::~MGrammar_PreprocessorLexer ()

{
}
