#ifndef __MGRAMMAR_PREPROCESSOROPTION_H__
#define __MGRAMMAR_PREPROCESSOROPTION_H__
#include "MLANG/Refcountable.h"
#include "MLANG/SmartPtr.h"
#include "MLANG/String.h"

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/preprocessor/Option.java#1 $
 */
class MGrammar_PreprocessorGrammar;
typedef MGrammar_PreprocessorGrammar *MGrammar_PreprocessorGrammar_ptr;
class MGrammar_PreprocessorOption;
typedef MGrammar_PreprocessorOption *MGrammar_PreprocessorOption_ptr;

class MGrammar_PreprocessorOption : public MLANG_Refcountable<ACE_SYNCH_MUTEX>
{
protected:
   MLANG_String name_;
protected:
   MLANG_String rhs_;
protected:
   MGrammar_PreprocessorGrammar_ptr enclosingGrammar_;

public:
   MGrammar_PreprocessorOption (
      const MLANG_String& n, 
      const MLANG_String& rhs, 
      MGrammar_PreprocessorGrammar_ptr gr
    );

   virtual ~MGrammar_PreprocessorOption ();

public:
   static bool is_nil (MGrammar_PreprocessorOption_ptr option)
   { return option == 0; }

   static MGrammar_PreprocessorOption_ptr _nil()
   { return 0; }

   static MGrammar_PreprocessorOption_ptr _duplicate(MGrammar_PreprocessorOption_ptr option)
   { return ::MLANG_acquire(option); }
public:
   MGrammar_PreprocessorGrammar_ptr getEnclosingGrammar() const
   {
        return enclosingGrammar_;
   }

public:
   const MLANG_String& getName() const
   {
        return name_;
   }

public:
   const MLANG_String& getRHS() 
   {
        return rhs_;
   }

public:
   void setEnclosingGrammar(MGrammar_PreprocessorGrammar_ptr g) 
   {
        enclosingGrammar_ = g;
   }

public:
   void setName(const MLANG_String& n) 
   {
        name_ = n;
   }

public:
   void setRHS(const MLANG_String& rhs)
   {
        rhs_ = rhs;
   }

public:
   MLANG_String toString() const
   {
        return "\t" + name_ + "=" + rhs_;
   }
};

typedef MLANG_SmartPtr<MGrammar_PreprocessorOption> MGrammar_PreprocessorOption_var;

#endif /* __MGRAMMAR_PREPROCESSOROPTION_H__ */
