#ifndef __MGRAMMAR_PREPROCESSORTOOL_H__
#define __MGRAMMAR_PREPROCESSORTOOL_H__
#include "ace/ARGV.h"
#include "ace/Vector_T.h"
#include "MLANG/Refcountable.h"
#include "MLANG/SmartPtr.h"
#include "MLANG/String.h"
#include "MGrammar/Preprocessor/Hierarchy.h"

class MGrammar_PreprocessorTool;
typedef class MGrammar_PreprocessorTool *MGrammar_PreprocessorTool_ptr;

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/preprocessor/Tool.java#1 $
 */

/** Tester for the preprocessor */
class MGrammar_PreprocessorTool : public MLANG_Refcountable<ACE_SYNCH_MUTEX>
{
protected:
   MGrammar_Hierarchy_var theHierarchy_;
   MLANG_String grammarFileName_;
   ACE_ARGV args_;
   int nargs_;		// how many args in new args list
   ACE_Vector<MLANG_String> grammars_;
   MGrammar_Tool_ptr antlrTool_;

public:
   MGrammar_PreprocessorTool (MGrammar_Tool_ptr t, ACE_ARGV& args);
 
   virtual ~MGrammar_PreprocessorTool();

public:

   static bool is_nil (MGrammar_PreprocessorTool_ptr tool)
   { return tool == 0; }

   static MGrammar_PreprocessorTool_ptr _nil()
   { return 0; }

   static MGrammar_PreprocessorTool_ptr _duplicate(MGrammar_PreprocessorTool_ptr tool)
   { return ::MLANG_acquire(tool); }
public:

   static void main(ACE_ARGV& args);

   bool preprocess();

    /** create new arg list with correct length to pass to ANTLR */
    ACE_ARGV preprocessedArgList();

    /** Process -glib options and grammar file.  Create a new args list
     *  that does not contain the -glib option.  The grammar file name
     *  might be modified and, hence, is not added yet to args list.
     */
private:
   void processArguments(ACE_ARGV& incomingArgs);
};

typedef MLANG_SmartPtr<MGrammar_PreprocessorTool> MGrammar_PreprocessorTool_var;

#endif /* __MGRAMMAR_PREPROCESSORTOOL_H__ */
