#include "MGrammar/Grammar.h"
#include "MGrammar/BlockEndElement.h"
#include "MGrammar/RuleEndElement.h"

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/RuleEndElement.java#1 $
 */

/**Contains a list of all places that reference
 * this enclosing rule.  Useful for FOLLOW computations.
 */

MGrammar_RuleEndElement::MGrammar_RuleEndElement(MGrammar_Grammar_ptr g) 
   : MGrammar_BlockEndElement(g),
     noFOLLOW_(false)
{
  cache_.resize (g->maxk_ + 1, MGrammar_Lookahead());
  for (int j=0; j<grammar_->maxk_ + 1; j++)
     cache_[j].set_null();
}

MGrammar_Lookahead MGrammar_RuleEndElement::look(int k)

{
   return grammar_->theLLkAnalyzer_->look(k, this);
}

MLANG_String MGrammar_RuleEndElement::toString() const

{
   //return " [RuleEnd]";
   return "";
}

MGrammar_RuleEndElement::~MGrammar_RuleEndElement()

{
}
