#ifndef __MGRAMMAR_RULEENDELEMENT_H__
#define __MGRAMMAR_RULEENDELEMENT_H__
#include "ace/Vector_T.h"
#include "MLANG/SmartPtr.h"
#include "MLANG/String.h"
#include "MGrammar/Lookahead.h"
#include "MGrammar/BlockEndElement.h"

class MGrammar_RuleEndElement;
typedef class MGrammar_RuleEndElement *MGrammar_RuleEndElement_ptr;

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/RuleEndElement.java#1 $
 */

/**Contains a list of all places that reference
 * this enclosing rule.  Useful for FOLLOW computations.
 */
class MGrammar_RuleEndElement : public MGrammar_BlockEndElement
{
public:
    ACE_Vector<MGrammar_Lookahead> cache_;	// Each rule can cache it's lookahead computation.
    // The FOLLOW(rule) is stored in this cache.
    // 1..k
    bool noFOLLOW_;

public:

    MGrammar_RuleEndElement(MGrammar_Grammar_ptr g);

    virtual ~MGrammar_RuleEndElement();

public:

   static bool is_nil (MGrammar_RuleEndElement_ptr ree)
   { return ree == 0; }

   static MGrammar_RuleEndElement_ptr _nil()
   { return 0; }

   static MGrammar_RuleEndElement_ptr _duplicate(MGrammar_RuleEndElement_ptr ree)
   { return MLANG_acquire(ree); }

public:

    bool noFOLLOW () const
    { return noFOLLOW_; }

    MGrammar_RuleEndElement& noFOLLOW (bool newval) 
    { noFOLLOW_ = newval; return *this; }

    const ACE_Vector<MGrammar_Lookahead>& getCache() const
    { return cache_; }

    MGrammar_Lookahead look(int k);

    MLANG_String toString() const;
};

typedef MLANG_SmartPtr<MGrammar_RuleEndElement> MGrammar_RuleEndElement_var;

#endif /* __MGRAMMAR_RULEENDELEMENT_H__ */
