#include "MGrammar/ANTLRTokenTypes.h"
#include "MGrammar/Grammar.h"
#include "MGrammar/LLkAnalyzer.h"
#include "MGrammar/CodeGenerator.h"
#include "MGrammar/RuleRefElement.h"

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/RuleRefElement.java#1 $
 */

MGrammar_RuleRefElement::MGrammar_RuleRefElement (
   MGrammar_Grammar_ptr g,
   const MParser_Token_var& t,
   int autoGenType
) : super(g, t, autoGenType),
    targetRule_(t->getText())

{
   //		if ( Character.isUpperCase(targetRule.charAt(0)) ) { // lexer rule?
   if (t->getType() == ANTLRTokenTypes::TOKEN_REF)
    { // lexer rule?
      targetRule_ = MGrammar_CodeGenerator::encodeLexerRuleName(targetRule_);
    }
}

//	public RuleRefElement(Grammar g, String t, int line, int autoGenType_) {
//		super(g, autoGenType_);
//		targetRule = t;
//		if ( Character.isUpperCase(targetRule.charAt(0)) ) { // lexer rule?
//			targetRule = CodeGenerator.lexerRuleName(targetRule);
//		}
//		this.line = line;
//	}

void MGrammar_RuleRefElement::generate()

{
   grammar_->generator_->gen(this);
}

MGrammar_Lookahead MGrammar_RuleRefElement::look(int k)

{
   return grammar_->theLLkAnalyzer_->look(k, this);
}

MLANG_String MGrammar_RuleRefElement::toString() const

{
   if (args_.length() != 0)
      return " " + targetRule_ + args_;
   else
      return " " + targetRule_;
}

MGrammar_RuleRefElement::~MGrammar_RuleRefElement ()

{
}
