#ifndef __MGRAMMAR_RULEREFELEMENT_H__
#define __MGRAMMAR_RULEREFELEMENT_H__
#include "MLANG/SmartPtr.h"
#include "MLANG/String.h"
#include "MParser/Token.h"
#include "MGrammar/AlternativeElement.h"

class MGrammar_RuleRefElement;
typedef class MGrammar_RuleRefElement *MGrammar_RuleRefElement_ptr;

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/RuleRefElement.java#1 $
 */

class MGrammar_RuleRefElement : public MGrammar_AlternativeElement

{
public:
    typedef MGrammar_AlternativeElement super;
protected:
    MLANG_String targetRule_; // which rule is being called?
    MLANG_String args_;		 // were any args passed to rule?
    MLANG_String idAssign_;	 // is the return type assigned to a variable?
    MLANG_String label_;

public:

    MGrammar_RuleRefElement (
       MGrammar_Grammar_ptr g,
       const MParser_Token_var& t,
       int autoGenType);

    virtual ~MGrammar_RuleRefElement ();

public:

   static bool is_nil (MGrammar_RuleRefElement_ptr rre)
   { return rre == 0; }

   static MGrammar_RuleRefElement_ptr _nil()
   { return 0; }

   static MGrammar_RuleRefElement_ptr _duplicate(MGrammar_RuleRefElement_ptr rre)
   { return MLANG_acquire (rre); }

   static MGrammar_RuleRefElement_ptr _narrow(MGrammar_AlternativeElement_ptr rre)
   { return MLANG_acquire (ACE_dynamic_cast(MGrammar_RuleRefElement_ptr, rre)); }

public:

    void generate();

    const MLANG_String& targetRule() const
    {
        return targetRule_;
    }

    const MLANG_String& getArgs() const
    {
        return args_;
    }

    const MLANG_String& getIdAssign() const
    {
        return idAssign_;
    }

    const MLANG_String& getLabel() const
    {
        return label_;
    }

    MGrammar_Lookahead look(int k);

    void setArgs(const MLANG_String& a)
    {
        args_ = a;
    }

    void setIdAssign(const MLANG_String& id) 
    {
        idAssign_ = id;
    }

    void setLabel(const MLANG_String& label)
    {
        label_ = label;
    }

    MLANG_String toString() const;
};

typedef MLANG_SmartPtr<MGrammar_RuleRefElement> MGrammar_RuleRefElement_var;

#endif /* __MGRAMMAR_RULEREFELEMENT_H__ */
