#include "MGrammar/RuleRefElement.h"
#include "MGrammar/RuleBlock.h"
#include "MGrammar/RuleSymbol.h"

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.co)m
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/RuleSymbol.java#1 $
 */

MGrammar_RuleSymbol::MGrammar_RuleSymbol(const MLANG_String& r)
   : MGrammar_GrammarSymbol(r),
     defined_(false)

{
}

void MGrammar_RuleSymbol::addReference(MGrammar_RuleRefElement_ptr e)

{
   references_.push_back(MGrammar_RuleRefElement::_duplicate(e));
}

void MGrammar_RuleSymbol::removeReference(MGrammar_RuleRefElement_ptr e)

{
   size_t i;
   for (i=0; i<references_.size(); i++)
    {
       if (references_[i].in()==e)
        {
          break;
        }
    }
   if (i==references_.size())
      return;

   for (size_t j=i; j+1<references_.size(); j++)
       references_[j] = references_[j+1];
   references_.resize (references_.size() - 1, MGrammar_RuleRefElement_var());
}

void MGrammar_RuleSymbol::setBlock(MGrammar_RuleBlock_ptr rb)

{
   block_ = MGrammar_RuleBlock::_duplicate(rb);
}

MGrammar_RuleSymbol::~MGrammar_RuleSymbol()

{
}
