#ifndef __MGRAMMAR_STRINGLITERALELEMENT_H__
#define __MGRAMMAR_STRINGLITERALELEMENT_H__
#include "MLANG/SmartPtr.h"
#include "MLANG/String.h"
#include "MParser/Token.h"
#include "MGrammar/Lookahead.h"
#include "MGrammar/GrammarAtom.h"

class MGrammar_StringLiteralElement;
typedef class MGrammar_StringLiteralElement *MGrammar_StringLiteralElement_ptr;

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/StringLiteralElement.java#1 $
 */

class MGrammar_StringLiteralElement : public MGrammar_GrammarAtom

{
protected:
    // atomText with quotes stripped and escape codes processed
    MLANG_String processedAtomText_;

public:

    MGrammar_StringLiteralElement (
       MGrammar_Grammar_ptr g, 
       const MParser_Token_var& t,
       int autoGenType
     );

    virtual ~MGrammar_StringLiteralElement ();

public:

   static bool is_nil (MGrammar_StringLiteralElement_ptr element)
   { return element == 0; }

   static MGrammar_StringLiteralElement_ptr _nil()
   { return 0; }

   static MGrammar_StringLiteralElement_ptr _duplicate(MGrammar_StringLiteralElement_ptr element)
   { return ::MLANG_acquire(element); }

public:

    const MLANG_String& processedAtomText() const
    { return processedAtomText_; }

    MGrammar_StringLiteralElement& processedAtomText(const MLANG_String& value)
    { processedAtomText_ = value; return *this; }

    void generate();

    MGrammar_Lookahead look(int k);
};

typedef MLANG_SmartPtr<MGrammar_StringLiteralElement> MGrammar_StringLiteralElement_var;

#endif /* __MGRAMMAR_STRINGLITERALELEMENT_H__ */
