#ifndef __MGRAMMAR_STRINGLITERALSYMBOL_H__
#define __MGRAMMAR_STRINGLITERALSYMBOL_H__
#include "MLANG/SmartPtr.h"
#include "MLANG/String.h"
#include "MGrammar/TokenSymbol.h"

class MGrammar_StringLiteralSymbol;
typedef class MGrammar_StringLiteralSymbol *MGrammar_StringLiteralSymbol_ptr;

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/StringLiteralSymbol.java#1 $
 */

class MGrammar_StringLiteralSymbol : public MGrammar_TokenSymbol

{
protected:
    MLANG_String label_;	// was this string literal labeled?

public:

    MGrammar_StringLiteralSymbol(const MLANG_String& r);

    virtual ~MGrammar_StringLiteralSymbol();

public:

   static bool is_nil (MGrammar_StringLiteralSymbol_ptr a)
   { return a == 0; }

   static MGrammar_StringLiteralSymbol_ptr _nil()
   { return 0; }

   static MGrammar_StringLiteralSymbol_ptr _duplicate(MGrammar_StringLiteralSymbol_ptr t)
   { return MLANG_acquire(t); }

   static MGrammar_StringLiteralSymbol_ptr _narrow(MGrammar_GrammarSymbol_ptr t)
   { return MLANG_acquire(ACE_dynamic_cast(MGrammar_StringLiteralSymbol_ptr, t)); }

public:

    const MLANG_String& getLabel() const
    
    {
        return label_;
    }

    void setLabel(const MLANG_String& label)
    {
        label_ = label;
    }
};

typedef MLANG_SmartPtr<MGrammar_StringLiteralSymbol> MGrammar_StringLiteralSymbol_var;

#endif /* __MGRAMMAR_STRINGLITERALSYMBOL_H__ */
