#include "MGrammar/Grammar.h"
#include "MGrammar/CodeGenerator.h"
#include "MGrammar/SynPredBlock.h"

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/SynPredBlock.java#1 $
 */

MGrammar_SynPredBlock::MGrammar_SynPredBlock(MGrammar_Grammar_ptr g)
   : MGrammar_AlternativeBlock(g)

{
}

MGrammar_SynPredBlock::MGrammar_SynPredBlock (
   MGrammar_Grammar_ptr g,
   const MParser_Token_var& start
) : MGrammar_AlternativeBlock(g, start, false)

{
}

void MGrammar_SynPredBlock::generate()

{
   grammar_->generator_->gen(this);
}

MGrammar_Lookahead MGrammar_SynPredBlock::look(int k)

{
   return grammar_->theLLkAnalyzer_->look(k, this);
}

MLANG_String MGrammar_SynPredBlock::toString() const

{
   return MGrammar_AlternativeBlock::toString() + "=>";
}

MGrammar_SynPredBlock::~MGrammar_SynPredBlock()

{
}
