#ifndef __MGRAMMAR_SYNPREDBLOCK_H__
#define __MGRAMMAR_SYNPREDBLOCK_H__
#include "MLANG/SmartPtr.h"
#include "MLANG/String.h"
#include "MGrammar/Lookahead.h"
#include "MGrammar/AlternativeBlock.h"

class MGrammar_SynPredBlock;
typedef class MGrammar_SynPredBlock *MGrammar_SynPredBlock_ptr;

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/SynPredBlock.java#1 $
 */

class MGrammar_SynPredBlock : public MGrammar_AlternativeBlock

{
public:
    MGrammar_SynPredBlock(MGrammar_Grammar_ptr g);

    MGrammar_SynPredBlock (
       MGrammar_Grammar_ptr g,
       const MParser_Token_var& start
     );

    virtual ~MGrammar_SynPredBlock();

public:
   static bool is_nil (MGrammar_SynPredBlock_ptr block)
   { return block == 0; }

   static MGrammar_SynPredBlock_ptr _nil()
   { return 0; }

   static MGrammar_SynPredBlock_ptr _duplicate(MGrammar_SynPredBlock_ptr block)
   { return ::MLANG_acquire(block); }

   static MGrammar_SynPredBlock_ptr _narrow(MGrammar_AlternativeBlock_ptr block)
   { return ::MLANG_acquire(ACE_dynamic_cast(MGrammar_SynPredBlock_ptr, block)); }

public:

    void generate();

    MGrammar_Lookahead look(int k);

    MLANG_String toString() const;
};

typedef MLANG_SmartPtr<MGrammar_SynPredBlock> MGrammar_SynPredBlock_var;

#endif /* __MGRAMMAR_SYNPREDBLOCK_H__ */
