#include "MGrammar/Tool.h"
#include "MGrammar/CodeGenerator.h"
#include "MGrammar/Grammar.h"
#include "MGrammar/TokenRangeElement.h"

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/TokenRangeElement.java#1 $
 */


MGrammar_TokenRangeElement::MGrammar_TokenRangeElement (
   MGrammar_Grammar_ptr g,
   const MParser_Token_var& t1,
   const MParser_Token_var& t2,
   int autoGenType
) : MGrammar_AlternativeElement(g, t1, autoGenType),
    begin_(MParser_Token::INVALID_TYPE),
    end_(MParser_Token::INVALID_TYPE)

{
    begin_ = grammar_->tokenManager_->getTokenSymbol(t1->getText())->getTokenType();
    beginText_ = t1->getText();
    end_ = grammar_->tokenManager_->getTokenSymbol(t2->getText())->getTokenType();
    endText_ = t2->getText();
    line_ = t1->getLine();
}

void MGrammar_TokenRangeElement::generate()

{
   grammar_->generator_->gen(this);
}

MGrammar_Lookahead MGrammar_TokenRangeElement::look(int k)

{
   return grammar_->theLLkAnalyzer_->look(k, this);
}

void MGrammar_TokenRangeElement::setLabel(const MLANG_String& label)

{
   label_ = label;
}

MLANG_String MGrammar_TokenRangeElement::toString() const

{
   if (label_.length() != 0) 
    {
      return " " + label_ + ":" + beginText_ + ".." + endText_;
    }
   else
    {
      return " " + beginText_ + ".." + endText_;
    }
}

MGrammar_TokenRangeElement::~MGrammar_TokenRangeElement ()

{
}
