#ifndef __MPARSER_TOKENREANGEELEMENT_H__
#define __MPARSER_TOKENREANGEELEMENT_H__
#include "MLANG/SmartPtr.h"
#include "MLANG/String.h"
#include "MParser/Token.h"
#include "MGrammar/Lookahead.h"
#include "MGrammar/AlternativeElement.h"

class MGrammar_TokenRangeElement;
typedef MGrammar_TokenRangeElement *MGrammar_TokenRangeElement_ptr;

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/TokenRangeElement.java#1 $
 */

class MGrammar_TokenRangeElement : public MGrammar_AlternativeElement
{
protected:
    MLANG_String label_;
    int begin_;
    int end_;
    MLANG_String beginText_;
    MLANG_String endText_;

public:

    MGrammar_TokenRangeElement (
      MGrammar_Grammar_ptr g,
      const MParser_Token_var& t1,
      const MParser_Token_var& t2,
      int autoGenType
    );

    virtual ~MGrammar_TokenRangeElement ();

public:

   static bool is_nil (MGrammar_TokenRangeElement_ptr element)
   { return element == 0; }

   static MGrammar_TokenRangeElement_ptr _nil()
   { return 0; }

   static MGrammar_TokenRangeElement_ptr _duplicate(MGrammar_TokenRangeElement_ptr element)
   { return ::MLANG_acquire(element); }

public:

    void generate();

public:

    int begin() const
    { return begin_; }

    int end() const
    { return end_; }

    const MLANG_String& getLabel() const
    { return label_; }

    MGrammar_Lookahead look(int k);

    void setLabel(const MLANG_String& label);

    const MLANG_String& beginText() const
    { return beginText_; }

    const MLANG_String& endText() const
    { return endText_; }

    MLANG_String toString() const;
};

typedef MLANG_SmartPtr<MGrammar_TokenRangeElement> MGrammar_TokenRangeElement_var;
#endif /* __MPARSER_TOKENREANGEELEMENT_H__ */
