#include "MGrammar/Lookahead.h"
#include "MParser/Token.h"
#include "MGrammar/TokenSymbol.h"
#include "MGrammar/Tool.h"
#include "MGrammar/CodeGenerator.h"
#include "MGrammar/Grammar.h"
#include "MGrammar/TokenRefElement.h"

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/TokenRefElement.java#1 $
 */

MGrammar_TokenRefElement::MGrammar_TokenRefElement (
   MGrammar_Grammar_ptr g,
   const MParser_Token_var& t,
   bool inverted,
   int autoGenType
) : super(g, t, autoGenType)

{
  no_ = inverted;
   MGrammar_TokenSymbol_var ts =
     MGrammar_TokenSymbol::_narrow(grammar_->tokenManager_->getTokenSymbol(atomText_));
   if (MGrammar_TokenSymbol::is_nil(ts))
    {
      g->antlrTool_->error("Undefined token symbol: " +
                     atomText_, grammar_->getFilename(), t->getLine(), t->getColumn());
    }
   else
    {
      tokenType_ = ts->getTokenType();
      // set the AST node type to whatever was set in tokens {...}
      // section (if anything);
      // Lafter, after this is created, the element option can set this.
      setASTNodeType(ts->getASTNodeType());
    }
   line_ = t->getLine();
}

void MGrammar_TokenRefElement::generate()

{
   grammar_->generator_->gen(this);
}

MGrammar_Lookahead MGrammar_TokenRefElement::look(int k)

{
   return grammar_->theLLkAnalyzer_->look(k, this);
}

MGrammar_TokenRefElement::~MGrammar_TokenRefElement ()

{
}
