#ifndef __MGRAMMAR_TOKENREFELEMENT_H__
#define __MGRAMMAR_TOKENREFELEMENT_H__
#include "MLANG/SmartPtr.h"
#include "MParser/Token.h"
#include "MGrammar/Lookahead.h"
#include "MGrammar/GrammarAtom.h"

class MGrammar_TokenRefElement;
typedef class MGrammar_TokenRefElement *MGrammar_TokenRefElement_ptr;

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/TokenRefElement.java#1 $
 */

class MGrammar_TokenRefElement : public MGrammar_GrammarAtom

{
public:
   typedef MGrammar_GrammarAtom super;
public:
    MGrammar_TokenRefElement(MGrammar_Grammar_ptr g,
                           const MParser_Token_var& t,
                           bool inverted,
                           int autoGenType);

    virtual ~MGrammar_TokenRefElement();

public:

   static bool is_nil (MGrammar_TokenRefElement_ptr element)
   { return element == 0; }

   static MGrammar_TokenRefElement_ptr _nil()
   { return 0; }

   static MGrammar_TokenRefElement_ptr _duplicate(MGrammar_TokenRefElement_ptr element)
   { return ::MLANG_acquire(element); }

   static MGrammar_TokenRefElement_ptr _narrow(MGrammar_GrammarAtom_ptr atom)
   { return ::MLANG_acquire(ACE_dynamic_cast(MGrammar_TokenRefElement_ptr, atom)); }

   static MGrammar_TokenRefElement_ptr _narrow(MGrammar_AlternativeElement_ptr element)
   { return ::MLANG_acquire(ACE_dynamic_cast(MGrammar_TokenRefElement_ptr, element)); }
public:

    void generate();

    MGrammar_Lookahead look(int k);
};

typedef MLANG_SmartPtr<MGrammar_TokenRefElement> MGrammar_TokenRefElement_var;

#endif /* __MGRAMMAR_TOKENREFELEMENT_H__ */
