#ifndef __MGRAMMAR_TOKENSYMBOL_H__
#define __MGRAMMAR_TOKENSYMBOL_H__
#include "MLANG/SmartPtr.h"
#include "MLANG/String.h"
#include "MGrammar/GrammarSymbol.h"

class MGrammar_TokenSymbol;
typedef class MGrammar_TokenSymbol *MGrammar_TokenSymbol_ptr;

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/TokenSymbol.java#1 $
 */

class MGrammar_TokenSymbol : public MGrammar_GrammarSymbol

{
protected:
    int ttype_;
    /** describes what token matches in "human terms" */
    MLANG_String paraphrase_;

    /** Set to a value in the tokens {...} section */
    MLANG_String ASTNodeType_;

public:

    MGrammar_TokenSymbol(const MLANG_String& r);

    virtual ~MGrammar_TokenSymbol();

public:

   static bool is_nil (MGrammar_TokenSymbol_ptr a)
   { return a == 0; }

   static MGrammar_TokenSymbol_ptr _nil()
   { return 0; }

   static MGrammar_TokenSymbol_ptr _duplicate(MGrammar_TokenSymbol_ptr ts)
   { return MLANG_acquire (ts); }

   static MGrammar_TokenSymbol_ptr _narrow(MGrammar_GrammarSymbol_ptr ts)
   { return MLANG_acquire (ACE_dynamic_cast(MGrammar_TokenSymbol_ptr, ts)); }

public:

    MLANG_String getASTNodeType() const;

    void setASTNodeType(const MLANG_String& type);

    MLANG_String getParaphrase() const;

    int getTokenType() const;

    void setParaphrase(const MLANG_String& p);

    void setTokenType(int t);
};

typedef MLANG_SmartPtr<MGrammar_TokenSymbol> MGrammar_TokenSymbol_var;

#endif /* __MGRAMMAR_TOKENSYMBOL_H__ */
