#include "MGrammar/TreeElement.h"
#include "MGrammar/GrammarAtom.h"
#include "MGrammar/TreeBlockContext.h"

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/TreeBlockContext.java#1 $
 */

/**The context needed to add root,child elements to a Tree.  There
 * is only one alternative (i.e., a list of children).  We subclass to
 * specialize. MakeGrammar.addElementToCurrentAlt will work correctly
 * now for either a block of alts or a Tree child list.
 *
 * The first time addAlternativeElement is called, it sets the root element
 * rather than adding it to one of the alternative lists.  Rather than have
 * the grammar duplicate the rules for grammar atoms etc... we use the same
 * grammar and same refToken behavior etc...  We have to special case somewhere
 * and here is where we do it.
 */
MGrammar_TreeBlockContext::MGrammar_TreeBlockContext()
  : nextElementIsRoot_(true)

{
}


void MGrammar_TreeBlockContext::addAlternativeElement (
   const MGrammar_AlternativeElement_var& e
) 

{
    MGrammar_TreeElement_var tree = 
      Dynamic_Cast<MGrammar_TreeElement>(block_);
    if (nextElementIsRoot_)
     {
       tree->root_ = Dynamic_Cast<MGrammar_GrammarAtom>(e);
       nextElementIsRoot_ = false;
     }
    else
     {
       super::addAlternativeElement(e);
     }
}

MGrammar_TreeBlockContext::~MGrammar_TreeBlockContext()

{
}
