#include "MGrammar/Grammar.h"
#include "MGrammar/CodeGenerator.h"
#include "MGrammar/Alternative.h"
#include "MGrammar/TreeElement.h"

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/TreeElement.java#1 $
 */

/** A TreeElement is a block with one alternative and a root node */
MGrammar_TreeElement::MGrammar_TreeElement (
   MGrammar_Grammar_ptr g, 
   const MParser_Token_var& start
) : MGrammar_AlternativeBlock (g, start, false)

{
}

void MGrammar_TreeElement::generate()

{
   grammar_->generator_->gen(this);
}

MGrammar_Lookahead MGrammar_TreeElement::look(int k)

{
  return grammar_->theLLkAnalyzer_->look(k, this);
}

MLANG_String MGrammar_TreeElement::toString() const

{
   MLANG_String s = " #(" + root_->toString();
   MGrammar_Alternative_var a = alternatives_[0];
   MGrammar_AlternativeElement_var p = a->head_;
   while (!MGrammar_AlternativeElement::is_nil(p))
    {
       s += p->toString();
       p = p->next_;
    }
   return s + " )";
}

MGrammar_TreeElement::~MGrammar_TreeElement ()

{
}
