#ifndef __MPARSER_TREELEMENT_H__
#define __MPARSER_TREELEMENT_H__
#include "MLANG/SmartPtr.h"
#include "MLANG/String.h"
#include "MGrammar/Lookahead.h"
#include "MParser/Token.h"
#include "MGrammar/GrammarAtom.h"
#include "MGrammar/GrammarElement.h"
#include "MGrammar/AlternativeBlock.h"

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/TreeElement.java#1 $
 */

class MGrammar_TreeElement;
typedef class MGrammar_TreeElement *MGrammar_TreeElement_ptr;

/** A TreeElement is a block with one alternative and a root node */
class MGrammar_TreeElement : public MGrammar_AlternativeBlock

{
public:
    MGrammar_GrammarAtom_var root_;

public:

   MGrammar_TreeElement (
      MGrammar_Grammar_ptr g,
      const MParser_Token_var& start
    );

   virtual ~MGrammar_TreeElement();

public:

public:
   static bool is_nil (MGrammar_TreeElement_ptr te)
   { return te == 0; }

   static MGrammar_TreeElement_ptr _nil()
   { return 0; }

   static MGrammar_TreeElement_ptr _duplicate(MGrammar_TreeElement_ptr element)
   { return ::MLANG_acquire(element); }

   static MGrammar_TreeElement_ptr _narrow(MGrammar_AlternativeElement_ptr element)
   { return ::MLANG_acquire(ACE_dynamic_cast(MGrammar_TreeElement_ptr, element)); }

   static MGrammar_TreeElement_ptr _narrow(MGrammar_GrammarElement_ptr element)
   { return ::MLANG_acquire(ACE_dynamic_cast(MGrammar_TreeElement_ptr, element)); }
public:

   const MGrammar_GrammarAtom_var& root() const
   { return root_; }

   void generate();

   MGrammar_Lookahead look(int k);

   MLANG_String toString() const;
};

typedef MLANG_SmartPtr<MGrammar_TreeElement> MGrammar_TreeElement_var;

#endif /* __MPARSER_TREELEMENT_H__ */
