#ifndef __MGRAMMAR_TREEWALKERGRAMMAR_H__
#define __MGRAMMAR_TREEWALKERGRAMMAR_H__
#include "ace/ARGV.h"
#include "MLANG/SmartPtr.h"
#include "MLANG/String.h"
#include "MParser/Token.h"
#include "MGrammar/Tool.h"

class MGrammar_TreeWalkerGrammar;
typedef MGrammar_TreeWalkerGrammar *MGrammar_TreeWalkerGrammar_ptr;
typedef MLANG_SmartPtr<MGrammar_TreeWalkerGrammar> MGrammar_TreeWalkerGrammar_var;

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/TreeWalkerGrammar.java#1 $
 */

#include "MGrammar/Grammar.h"

/** Parser-specific grammar subclass */
class MGrammar_TreeWalkerGrammar : public MGrammar_Grammar

{
protected:
   // true for transform mode
   bool transform_;

public:

    MGrammar_TreeWalkerGrammar (
       const MLANG_String& className,
       MGrammar_Tool_ptr tool,
       const MLANG_String& superClass
     );

    virtual ~MGrammar_TreeWalkerGrammar ();

public:

    /** Top-level call to generate the code for this grammar */
   void generate() ;

protected:

   // Get name of class from which generated parser/lexer inherits
   const MLANG_String getSuperClass() const;

public:

   /**Process command line arguments.
    * -trace			have all rules call traceIn/traceOut
    * -traceParser		have parser rules call traceIn/traceOut
    * -debug			generate debugging output for parser debugger
    */
   void processArguments(ACE_ARGV& args);

   /** Set tree parser options */
   bool setOption (
      const MLANG_String& key,
      const MParser_Token_var& value
    );
};

#endif /* __MGRAMMAR_TREEWALKERGRAMMAR_H__ */
