#include "MParser/Token.h"
#include "MGrammar/Grammar.h"
#include "MGrammar/CodeGenerator.h"
#include "MGrammar/WildcardElement.h"

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/WildcardElement.java#1 $
 */

MGrammar_WildcardElement::MGrammar_WildcardElement (
   MGrammar_Grammar_ptr g, 
   const MParser_Token_var& t, 
   int autoGenType
) : MGrammar_GrammarAtom(g, t, autoGenType)

{
   line_ = t->getLine();
}

void MGrammar_WildcardElement::generate()

{
   grammar_->generator_->gen(this);
}

MGrammar_Lookahead MGrammar_WildcardElement::look(int k) 

{
   return grammar_->theLLkAnalyzer_->look(k, this);
}

void MGrammar_WildcardElement::setLabel(const MLANG_String& label)

{
   label_ = label;
}

MLANG_String MGrammar_WildcardElement::toString() const

{
    MLANG_String s = " ";
    if (label_.length()) s += label_ + ":";
    return s + ".";
}

MGrammar_WildcardElement::~MGrammar_WildcardElement ()

{
}
