#ifndef __MGRAMMAR_WILDCARDELEMENT_H__
#define __MGRAMMAR_WILDCARDELEMENT_H__
#include "MLANG/SmartPtr.h"
#include "MLANG/String.h"
#include "MGrammar/Lookahead.h"
#include "MParser/Token.h"
#include "MGrammar/GrammarAtom.h"

class MGrammar_WildcardElement;
typedef class MGrammar_WildcardElement *MGrammar_WildcardElement_ptr;

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/WildcardElement.java#1 $
 */

class MGrammar_WildcardElement : public MGrammar_GrammarAtom

{
protected:

    MLANG_String label_;

public:
    MGrammar_WildcardElement (
       MGrammar_Grammar_ptr g, 
       const MParser_Token_var& t, 
       int autoGenType
     );

    virtual ~MGrammar_WildcardElement ();

public:
   static bool is_nil (MGrammar_WildcardElement_ptr a)
   { return a == 0; }

   static MGrammar_WildcardElement_ptr _nil()
   { return 0; }

   static MGrammar_WildcardElement_ptr _duplicate(MGrammar_WildcardElement_ptr we)
   { return ::MLANG_acquire(we); }

   static MGrammar_WildcardElement_ptr _narrow(MGrammar_GrammarAtom_ptr atom)
   { return ::MLANG_acquire(ACE_dynamic_cast(MGrammar_WildcardElement_ptr, atom)); }
public:

    void generate();

    const MLANG_String& getLabel() const
    {
        return label_;
    }

    MGrammar_Lookahead look(int k);

    void setLabel(const MLANG_String& label);

    MLANG_String toString() const;
};

typedef MLANG_SmartPtr<MGrammar_WildcardElement> MGrammar_WildcardElement_var;

#endif /* __MGRAMMAR_WILDCARDELEMENT_H__ */
