#include "MGrammar/Grammar.h"
#include "MGrammar/CodeGenerator.h"
#include "MGrammar/ZeroOrMoreBlock.h"

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/ZeroOrMoreBlock.java#1 $
 */

MGrammar_ZeroOrMoreBlock::MGrammar_ZeroOrMoreBlock(MGrammar_Grammar_ptr g)
 : MGrammar_BlockWithImpliedExitPath(g)

{
}

MGrammar_ZeroOrMoreBlock::MGrammar_ZeroOrMoreBlock (
   MGrammar_Grammar_ptr g,
   const MParser_Token_var& start
) : MGrammar_BlockWithImpliedExitPath(g, start)

{
}

void MGrammar_ZeroOrMoreBlock::generate()

{
   grammar_->generator_->gen(this);
}

MGrammar_Lookahead MGrammar_ZeroOrMoreBlock::look(int k)

{
   return grammar_->theLLkAnalyzer_->look(k, this);
}

MLANG_String MGrammar_ZeroOrMoreBlock::toString() const

{
   return MGrammar_BlockWithImpliedExitPath::toString() + "*";
}

MGrammar_ZeroOrMoreBlock::~MGrammar_ZeroOrMoreBlock()

{
}
