#ifndef __MGRAMMAR_ZEROORMOREBLOCK_H__
#define __MGRAMMAR_ZEROORMOREBLOCK_H__
#include "MLANG/SmartPtr.h"
#include "MLANG/String.h"
#include "MParser/Token.h"
#include "MGrammar/Lookahead.h"
#include "MGrammar/BlockWithImpliedExitPath.h"

class MGrammar_ZeroOrMoreBlock;
typedef class MGrammar_ZeroOrMoreBlock *MGrammar_ZeroOrMoreBlock_ptr;

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/ZeroOrMoreBlock.java#1 $
 */

class MGrammar_ZeroOrMoreBlock : public MGrammar_BlockWithImpliedExitPath

{
public:
    MGrammar_ZeroOrMoreBlock(MGrammar_Grammar_ptr g);

    MGrammar_ZeroOrMoreBlock (
        MGrammar_Grammar_ptr g,
        const MParser_Token_var& start
     );

    virtual ~MGrammar_ZeroOrMoreBlock();

public:
   static bool is_nil (MGrammar_ZeroOrMoreBlock_ptr block)
   { return block == 0; }

   static MGrammar_ZeroOrMoreBlock_ptr _nil()
   { return 0; }

   static MGrammar_ZeroOrMoreBlock_ptr _duplicate(MGrammar_ZeroOrMoreBlock_ptr block)
   { return ::MLANG_acquire(block); }
public:

    void generate();

    MGrammar_Lookahead look(int k);

    MLANG_String toString() const;
};

typedef MLANG_SmartPtr<MGrammar_ZeroOrMoreBlock> MGrammar_ZeroOrMoreBlock_var;

#endif /* __MGRAMMAR_ZEROORMOREBLOCK_H__ */
