#ifndef __MIO_FILE_H__
#define __MIO_FILE_H__
#include "MLANG/Refcountable.h"
#include "MLANG/SmartPtr.h"
#include "MLANG/String.h"

class MIO_File;
typedef class MIO_File *MIO_File_ptr;

class MIO_File : public MLANG_Refcountable<ACE_SYNCH_MUTEX>

{
public:
   MIO_File (const MLANG_String& filename);

   MIO_File (const MLANG_String& parent, const MLANG_String& child);

   virtual ~MIO_File ();

public:

   static MLANG_String separator();

public:

   static bool is_nil (MIO_File_ptr file)
   { return file == 0; }

   static MIO_File_ptr _nil()
   { return 0; }

   static MIO_File_ptr _duplicate(MIO_File_ptr file)
   { return MLANG_acquire(file); }

public:

   virtual const MLANG_String& filename() const
   { return filename_; }

   virtual bool isFile() const;

   virtual bool canRead() const;
   
   virtual bool canWrite() const;

   virtual bool isAbsolute() const;

   virtual bool exists() const;

   virtual bool mkdir() const;

   virtual bool mkdirs() const;

   virtual long length() const;

   virtual MLANG_String getParent() const;

   virtual bool remove() const;

protected:

   MLANG_String filename_;
};

typedef MLANG_SmartPtr<MIO_File> MIO_File_var;

#endif /* __MIO_FILE_H__ */
