#ifndef __MIO_FILEREADER_H__
#define __MIO_FILEREADER_H__
#include "MLANG/SmartPtr.h"
#include "MLANG/String.h"
#include "MLANG/Exception.h"
#include "MIO/Reader.h"
#include "MIO/InputStreamReader.h"
#include "MIO/File.h"

class MIO_FileReader;
typedef class MIO_FileReader *MIO_FileReader_ptr;

/**
 * @class MIO_FileReader
 *
 * @brief Implementa un lector de un flujo de entrada.
 */

class MIO_FileReader : public MIO_InputStreamReader
{
public:
   MIO_FileReader (
       const MIO_File_var& file
    );
   MIO_FileReader (
       const MLANG_String& filename
    );
   virtual ~MIO_FileReader ();

public:
   static bool is_nil (MIO_FileReader_ptr reader)
   { return reader == 0; }

   static MIO_FileReader_ptr _nil()
   { return 0; }

   static MIO_FileReader_ptr _duplicate(MIO_FileReader_ptr reader)
   { return MLANG_acquire(reader); }
};

/// El SmartPtr a un objeto de tipo MIO_FileReader
typedef MLANG_SmartPtr<MIO_FileReader> MIO_FileReader_var;

#endif /* __MIO_FILEREADER_H__ */
