#ifndef __MIO_FILEWRITER_H__
#define __MIO_FILEWRITER_H__
#include "MLANG/SmartPtr.h"
#include "MLANG/String.h"
#include "MIO/File.h"
#include "MIO/OutputStreamWriter.h"

class MIO_FileWriter;
typedef class MIO_FileWriter *MIO_FileWriter_ptr;

class MIO_FileWriter : public MIO_OutputStreamWriter
{
public:
   MIO_FileWriter (
      const MIO_File_var& fileName,
      bool append = false
    );

   MIO_FileWriter (
      const MLANG_String& fileName,
      bool append = false
    );
public:
   virtual ~MIO_FileWriter();

public:
   static bool is_nil (MIO_FileWriter_ptr writer)
   { return writer == 0; }

   static MIO_FileWriter_ptr _nil()
   { return 0; }

   static MIO_FileWriter_ptr _duplicate(MIO_FileWriter_ptr writer)
   { return MLANG_acquire(writer); }
};

typedef MLANG_SmartPtr<MIO_FileWriter> MIO_FileWriter_var;

#endif /* __MIO_FILEWRITER_H__ */
