#ifndef __MIO_FILTEROUTPUTSTREAM_H__
#define __MIO_FILTEROUTPUTSTREAM_H__
#include "MLANG/SmartPtr.h"
#include "MIO/Export.h"
#include "MIO/OutputStream.h"

class MIO_Export MIO_FilterOutputStream;
typedef class MIO_FilterOutputStream *MIO_FilterOutputStream_ptr;

class MIO_Export MIO_FilterOutputStream : public MIO_OutputStream
{
public:
   MIO_FilterOutputStream (
      const MIO_OutputStream_var& output
    );
   virtual ~MIO_FilterOutputStream ();
public:
   static bool is_nil (MIO_OutputStream_ptr s)
   { return s == 0; }

   static MIO_OutputStream_ptr _nil()
   { return 0; }

   static MIO_OutputStream_ptr _duplicate(MIO_OutputStream_ptr stream)
   { return MLANG_acquire(stream); }
public:
   virtual void close();
   virtual void flush();
   virtual void write (const char *buf, ssize_t len);
   virtual void write (char c);
protected:
   MIO_OutputStream_var output_;
};

typedef MLANG_SmartPtr<MIO_FilterOutputStream> MIO_FilterOutputStream_var;

#endif /* __MIO_FILTEROUTPUTSTREAM_H__ */
