#include "MIO/InputStreamReader.h"

MIO_InputStreamReader::MIO_InputStreamReader (
   const MIO_InputStream_var& input
) : input_(input)

{
}

/// Marca la posicion actual en el flujo
///
/// @param readAheadLimit Limita el numero de caracteres que pueden ser
/// leidos mientras se preserva la marca. Despues de leer esta cantidad
/// de caracteres reintentar reiniciar el flujo podria falla. 
void MIO_InputStreamReader::mark (int readAheadLimit)

{
   input_->mark (readAheadLimit);
}

/// Lee una caracter del flujo de entrada
///
/// @retval el caracter leído
/// @retval -1, si se encontro el fin de archivo
/// @throw MIO_IOException Si hubo algun error de entrada/salida
ssize_t MIO_InputStreamReader::read ()

{
   return input_->read ();
}

ssize_t MIO_InputStreamReader::read(char buf[], ssize_t len)

{
   return input_->read (buf, len);
}

void MIO_InputStreamReader::close()

{
   input_->close();
}


MIO_InputStreamReader::~MIO_InputStreamReader ()

{
}
