#ifndef __MIO_OUTPUTSTREAM_H__
#define __MIO_OUTPUTSTREAM_H__
#include "MLANG/Refcountable.h"
#include "MLANG/SmartPtr.h"
#include "MIO/Export.h"

class MIO_Export MIO_OutputStream;
typedef class MIO_OutputStream *MIO_OutputStream_ptr;

class MIO_Export MIO_OutputStream : public MLANG_Refcountable<ACE_SYNCH_MUTEX>
{
public:
   MIO_OutputStream();
   virtual ~MIO_OutputStream();
public:
   static bool is_nil (MIO_OutputStream_ptr s)
   { return s == 0; }

   static MIO_OutputStream_ptr _nil()
   { return 0; }

   static MIO_OutputStream_ptr _duplicate(MIO_OutputStream_ptr stream)
   { return MLANG_acquire(stream); }
public:
   virtual void close();
   virtual void flush();
   virtual void write (const char buf[], ssize_t len) = 0;
   virtual void write (char c);
};

typedef MLANG_SmartPtr<MIO_OutputStream> MIO_OutputStream_var;

#endif /* __MIO_OUTPUTSTREAM_H__ */
