#include "MIO/OutputStreamWriter.h"

MIO_OutputStreamWriter::MIO_OutputStreamWriter (
   const MIO_OutputStream_var& output
 ) : output_(output)

{
}

/// Cierra el flujo de salida realizando vaciado de los datos si es necesario
///
void MIO_OutputStreamWriter::close()

{
   output_->close();
}

/// Realiza un vaciado de los datos si es necesario
///
void MIO_OutputStreamWriter::flush()

{
   output_->flush();
}

/// Escribe el @a buffer de @a count bytes al flujo de salida
///
/// @throws IOException si hubo algun error de entrada salida
void MIO_OutputStreamWriter::write (const char* buffer, size_t count)

{
   output_->write (buffer, count);
}

/// 
void MIO_OutputStreamWriter::write (int c)

{
   output_->write(c);
}

void MIO_OutputStreamWriter::write (const MLANG_String& s, int off, int len)

{
   output_->write (s.c_str() + off, len);
}

MIO_OutputStreamWriter::~MIO_OutputStreamWriter()

{
}
