#ifndef __MIO_OUTPUTSTREAMWRITER_H__
#define __MIO_OUTPUTSTREAMWRITER_H__
#include "MLANG/SmartPtr.h"
#include "MLANG/String.h"
#include "MIO/OutputStream.h"
#include "MIO/Writer.h"

class MIO_OutputStreamWriter;
typedef class MIO_OutputStreamWriter *MIO_OutputStreamWriter_ptr;

class MIO_OutputStreamWriter : public MIO_Writer
{
public:
   MIO_OutputStreamWriter (
      const MIO_OutputStream_var& output
    );
public:
   virtual ~MIO_OutputStreamWriter();

public:
   static bool is_nil (MIO_OutputStreamWriter_ptr writer)
   { return writer == 0; }

   static MIO_OutputStreamWriter_ptr _nil()
   { return 0; }

   static MIO_OutputStreamWriter_ptr _duplicate(MIO_OutputStreamWriter_ptr writer)
   { return MLANG_acquire(writer); }
public:
   /// Cierra el flujo de salida realizando vaciado de los datos si es necesario
   ///
   virtual void close();

   /// Realiza un vaciado de los datos si es necesario
   ///
   virtual void flush();

   /// Escribe el @a buffer de @a count bytes al flujo de salida
   ///
   /// @throws IOException si hubo algun error de entrada salida
   virtual void write (const char* buffer, size_t count);

   /// 
   virtual void write (int c);

   virtual void write (const MLANG_String&s, int off, int len);
protected:
   MIO_OutputStream_var output_;
};

typedef MLANG_SmartPtr<MIO_OutputStreamWriter> MIO_OutputStreamWriter_var;

#endif /* __MIO_OUTPUTSTREAMWRITER_H__ */
