#include "MIO/PrintStream.h"

MIO_PrintStream::MIO_PrintStream (
   const MIO_OutputStream_var& output
) : MIO_FilterOutputStream (output)

{
}

void MIO_PrintStream::close()

{
   output_->close();
}

void MIO_PrintStream::flush()

{
   output_->flush();
}

void MIO_PrintStream::write (const char* buf, ssize_t len)

{
   for (ssize_t i=0; i<len; i++)
     this->write (buf[i]);
}

void MIO_PrintStream::write (char c)

{
   output_->write (&c, 1);
}

void MIO_PrintStream::print (char c)

{
   this->write (c);
}

void MIO_PrintStream::print (bool b)

{
   print (MLANG_String::valueOf(b));
}

void MIO_PrintStream::print (short s)

{  
   print (MLANG_String::valueOf(s));
}

void MIO_PrintStream::print (long l)

{  
   print (MLANG_String::valueOf(l));
}

void MIO_PrintStream::print (float f)

{  
   print (MLANG_String::valueOf(f));
}

void MIO_PrintStream::print (double d)

{  
   print (MLANG_String::valueOf(d));
}

void MIO_PrintStream::print(const char* buf, ssize_t len)

{
   for (ssize_t i=0; i<len; i++)
       print (buf[i]);
}

void MIO_PrintStream::print (const MLANG_String& s)

{
   this->print (s.c_str(), s.length());
}

void MIO_PrintStream::println()

{
   this->write ('\n');
}

void MIO_PrintStream::println(bool b)

{
   this->print(b);
   this->println();
}

void MIO_PrintStream::println(char c)

{
   this->print (c);
   this->println();
}

void MIO_PrintStream::println(const char* buf, ssize_t len)

{
   this->print (buf, len);
   this->println ();
}

void MIO_PrintStream::println(double d)

{
   this->print(d);
   this->println();
}

void MIO_PrintStream::println(float f)

{
   this->print(f);
   this->println();
}

void MIO_PrintStream::println(short s)

{
   this->print(s);
   this->println();
}

void MIO_PrintStream::println(long l)

{
   this->print (l);
   this->println();
}

void MIO_PrintStream::println(const MLANG_String& s)

{
   this->println (s.c_str(), s.length());
}

MIO_PrintStream::~MIO_PrintStream()

{
}
