#ifndef __MIO_PRINTSTREAM_H__
#define __MIO_PRINTSTREAM_H__
#include "MLANG/SmartPtr.h"
#include "MLANG/String.h"
#include "MIO/Export.h"
#include "MIO/OutputStream.h"
#include "MIO/FilterOutputStream.h"

class MIO_Export MIO_PrintStream;
typedef class MIO_PrintStream *MIO_PrintStream_ptr;

class MIO_Export MIO_PrintStream : public MIO_FilterOutputStream
{
public:
   MIO_PrintStream (
     const MIO_OutputStream_var& output
    );
   virtual ~MIO_PrintStream();
public:
   static bool is_nil (MIO_PrintStream_ptr s)
   { return s == 0; }

   static MIO_PrintStream_ptr _nil()
   { return 0; }

   static MIO_PrintStream_ptr _duplicate(MIO_PrintStream_ptr stream)
   { return MLANG_acquire(stream); }
public:
   virtual void close();
   virtual void flush();
   virtual void write (const char buf[], ssize_t len);
   virtual void write (char c);
public:
   virtual void print(bool b);
   virtual void print(char c);
   virtual void print(const char* buf, ssize_t len);
   virtual void print(double d);
   virtual void print(float f);
   virtual void print(short s);
   virtual void print(long l);
   virtual void print(const MLANG_String& s);
public:
   virtual void println();
   virtual void println(bool b);
   virtual void println(char c);
   virtual void println(const char* buf, ssize_t len);
   virtual void println(double d);
   virtual void println(float f);
   virtual void println(short s);
   virtual void println(long l);
   virtual void println(const MLANG_String& s);
};

typedef MLANG_SmartPtr<MIO_PrintStream> MIO_PrintStream_var;

#endif /* __MIO_PRINTSTREAM_H__ */
