#include "MIO/OutputStreamWriter.h"
#include "MIO/PrintWriter.h"

MIO_PrintWriter::MIO_PrintWriter ( 
   const MIO_Writer_var& output,
   bool autoflush
 ) : output_(output),
     autoflush_(autoflush)

{
}

MIO_PrintWriter::MIO_PrintWriter (
   const MIO_OutputStream_var& stream,
   bool autoflush
 ) : output_(new MIO_OutputStreamWriter(stream)),
     autoflush_(autoflush)

{
}

void MIO_PrintWriter::close()

{
}

void MIO_PrintWriter::flush()

{
}

void MIO_PrintWriter::write (const char *buf, size_t len)

{
   output_->write (buf, len);
}

void MIO_PrintWriter::write (char c)

{
   write (&c, 1);
}

void MIO_PrintWriter::print(bool b)

{
   print(MLANG_String::valueOf(b));
}

void MIO_PrintWriter::print(char c)

{
   write (c);
   if (c=='\n')
      flush();
   
}

void MIO_PrintWriter::print(const char* buf, ssize_t len)

{
   for (ssize_t i=0; i<len; i++)
     print (buf[i]);
}

void MIO_PrintWriter::print(double d)

{
   print (MLANG_String::valueOf(d));
}

void MIO_PrintWriter::print(float f)

{
   print (MLANG_String::valueOf(f));
}

void MIO_PrintWriter::print(short s)

{
   print (MLANG_String::valueOf(s));
}

void MIO_PrintWriter::print(long l)

{
   print (MLANG_String::valueOf(l));
}

void MIO_PrintWriter::print(const MLANG_String& s)

{
   for (size_t i=0; i<s.length(); i++)
       print (s[i]);
}

void MIO_PrintWriter::println()

{
   print('\n');
}

void MIO_PrintWriter::println(bool b)

{
   println (MLANG_String::valueOf(b));
}

void MIO_PrintWriter::println(char c)

{
   print (c);
   println ();
}

void MIO_PrintWriter::println(const char* buf, ssize_t len)

{
   for (ssize_t i=0; i<len; i++)
       print (buf[i]);
   println();
}

void MIO_PrintWriter::println(double d)

{
   println (MLANG_String::valueOf(d));
}

void MIO_PrintWriter::println(float f)

{
   println (MLANG_String::valueOf(f));
}

void MIO_PrintWriter::println(short s)

{
   println (MLANG_String::valueOf(s));
}

void MIO_PrintWriter::println(long l)

{
   println (MLANG_String::valueOf(l));
}

void MIO_PrintWriter::println(const MLANG_String& s)

{
   println (s.c_str(), s.length());   
}

MIO_PrintWriter::~MIO_PrintWriter ()

{
}
