#ifndef __MIO_WRITER_H__
#define __MIO_WRITER_H__
#include "MLANG/Refcountable.h"
#include "MLANG/SmartPtr.h"
#include "MLANG/String.h"

class MIO_Writer;
typedef class MIO_Writer *MIO_Writer_ptr;

class MIO_Writer : public MLANG_Refcountable<ACE_SYNCH_MUTEX>
{
protected:
   MIO_Writer (
    );
public:
   virtual ~MIO_Writer();

public:
   static bool is_nil (MIO_Writer_ptr writer)
   { return writer == 0; }

   static MIO_Writer_ptr _nil()
   { return 0; }

   static MIO_Writer_ptr _duplicate(MIO_Writer_ptr writer)
   { return MLANG_acquire(writer); }
public:
   /// Cierra el flujo de salida realizando vaciado de los datos si es necesario
   ///
   virtual void close() = 0;

   /// Realiza un vaciado de los datos si es necesario
   ///
   virtual void flush() = 0;

   /// Escribe el @a buffer de @a count bytes al flujo de salida
   ///
   /// @throws IOException si hubo algun error de entrada salida
   virtual void write (const char* buffer, size_t count) = 0;

   /// 
   virtual void write (int c);

   virtual void write (const MLANG_String& s);

   virtual void write (const MLANG_String&s, int off, int len);
};

typedef MLANG_SmartPtr<MIO_Writer> MIO_Writer_var;

#endif /* __MIO_WRITER_H__ */
