#include "MLANG/Reflection/Type.h"
#include "MLANG/Reflection/Class.h"
#include "MLANG/Reflection/Tools.h"
#include "MLANG/Class.h"

MLANG_ClassNotFoundException::MLANG_ClassNotFoundException (const char *name) 
  : MLANG_Exception(name)

{
}

MLANG_ClassNotFoundException::~MLANG_ClassNotFoundException ()

{
}


MLANG_InstantiationException::MLANG_InstantiationException (const char *message) 
  : MLANG_Exception(message)

{
}

MLANG_InstantiationException::~MLANG_InstantiationException ()

{
}


MLANG_IllegalAccessException::MLANG_IllegalAccessException (const char *message) 
  : MLANG_Exception(message)

{
}

MLANG_IllegalAccessException::~MLANG_IllegalAccessException ()

{
}

MLANG_IllegalArgumentException::MLANG_IllegalArgumentException (const char *message)
  : MLANG_Exception(message)

{
}

MLANG_IllegalArgumentException::~MLANG_IllegalArgumentException ()

{
}

MLANG_Class::MLANG_Class (const MLANG_Reflection::Type& impl)
 : impl_(impl)

{
}

MLANG_String MLANG_Class::getName() const

{
   return impl_.name();
}

MLANG_String MLANG_Class::toString() const

{
   return this->getName();
}

MLANG_Class_var MLANG_Class::forName (const MLANG_String& name)

{
   MLANG_Reflection::Type t = MLANG_Reflection::Type::byName(name);
  
   if (!t || !t.isClass())
    { 
      throw MLANG_ClassNotFoundException (name.c_str());
    }
   MLANG_Class_var c = new MLANG_Class (t);
   return c;
}

MLANG_Class_var MLANG_Class::forTypeId (const std::type_info& ti)

{
   return forName (MLANG_Reflection::Tools::demangle(ti));
}

void *MLANG_Class::newInstance()

{
   MLANG_Reflection::Object v = impl_.construct();
   return v.address();
//   throw MLANG_InstantiationException ("Operacion no implementada todavia");
}

MLANG_Class::~MLANG_Class ()

{
}

