#ifndef __MLANG_EXCEPTION_H__
#define __MLANG_EXCEPTION_H__
#include "MLANG/Export.h"
#include "MLANG/String.h"


namespace MLANG
{

class Exception;
typedef class Exception *Exception_ptr;
typedef class Exception *Exception_var;

class MLANG_Export Exception
{
public:
    Exception(const char *s = "");
    virtual ~Exception(); 
public:
    virtual MLANG_String toString() const
    { return message_; }
    virtual MLANG_String getMessage() const
    { return toString(); }
protected:
    MLANG_String message_; 
};
}

typedef MLANG::Exception MLANG_Exception;
typedef MLANG_Exception *MLANG_Exception_ptr;
typedef MLANG_Exception *MLANG_Exception_var;

#endif /* __MLANG_EXCEPTION_H__ */
