#ifndef __MLANG_HASHMAP_H__
#define __MLANG_HASHMAP_H__
#include <map>

template <class Key, class Value>
class MLANG_HashMap : public std::map<Key, Value>
{
    typedef std::map<Key, Value> BASE;
public:
    bool containsKey (const Key& key) const
    { return BASE::count(key)!=0; }

    bool contains (const Key& key) const
    { return BASE::count(key)!=0; }

    void put (const Key& key, const Value& value)
    { BASE::operator[] (key) = value; }

    void appendElement (const Key& key, const Value& value)
    { put (key, value); }

    Value get (const Key& key) const
    { typename BASE::const_iterator iter = find (key);
      if (iter!=BASE::end())
         return iter->second;
      else 
         return Value();
    }

    void remove (const Key& key)
    { BASE::erase (key); }

    bool is_null() const
    { return begin() == end(); }
};

#endif /* __MPARSER_HASHMAP_H__ */
