/* -*- C++ -*- */
//Object.inl,v 4.1 2001/12/10 21:44:43 bala Exp

ACE_INLINE
Object::Object (size_t refcount)
  : refcount_ (refcount)
{
}

ACE_INLINE
Object::~Object (void)
{
}

ACE_INLINE size_t
Object::increment (void)
{
  ACE_Guard<LOCK> guard(lock_);
  return ++this->refcount_;
}

ACE_INLINE size_t
Object::decrement (void)
{
  ACE_Guard<LOCK> guard(lock_);
  size_t newcount = --this->refcount_;
  if (newcount == 0)
   {
     guard.release();
     delete this;
   }
  return newcount;
}
