//$Id: Object.cpp,v 1.3 2004/11/30 22:57:58 roiser Exp $

#include "MLANG/Reflection/Kernel.h"
#include "MLANG/Reflection/Object.h"
#include "MLANG/Reflection/Class.h"
#include "MLANG/Reflection/DataMember.h"
#include "MLANG/Reflection/FunctionMember.h"

//-------------------------------------------------------------------------------
void * MLANG_Reflection::Object::field( const MLANG_String & data ) const {
//-------------------------------------------------------------------------------
  if ( ! type().isClass() ) throw RuntimeError("Object is not a composite");
  Class c = type();
  for ( size_t i = 0; i < c.dataMemberCount(); ++i ) {
    Member dm = c.dataMember( i );
    if ( dm.name() == data ) {
      return (void*)((char*)address() + dm.offset());
    }
  }
  throw RuntimeError("Data member not found in class");
}


//-------------------------------------------------------------------------------
void * MLANG_Reflection::Object::invoke( const MLANG_String & method, 
                                     std::vector<void*> args, 
                                     const Type & signature ) const {
//-------------------------------------------------------------------------------
  if ( ! type().isClass() ) throw RuntimeError("Object is not a composite");
  Class c = type();
  for ( size_t i = 0; i < c.functionMemberCount(); ++i ) {
    Member fm = c.functionMember( i );
    if ( fm.name() == method && (signature.id() ? fm.type().id() == signature.id() : true) ) {
      return fm.invoke( *this, args );
    }
  }
  throw RuntimeError("Function member not found in class");
}

