//$Id: Array.cpp,v 1.6 2004/11/30 22:57:58 roiser Exp $

#include "MLANG/Reflection/Array.h"
#include "MLANG/Reflection/Type.h"

//-------------------------------------------------------------------------------
MLANG_Reflection::Array::Array( const Type & arrayType,
                            size_t length,
                            const std::type_info & typeinfo ) 
//-------------------------------------------------------------------------------
: TypeBase( buildTypeName(arrayType, length ).c_str(), 
            length*(arrayType.sizeOf()), ARRAY, typeinfo ), 
  m_arrayType( arrayType ), 
  m_length( length ) { }


//-------------------------------------------------------------------------------
MLANG_String MLANG_Reflection::Array::fullName( bool /*typedefexp*/ ) const {
//-------------------------------------------------------------------------------
  return buildTypeName(m_arrayType, m_length);
}



//-------------------------------------------------------------------------------
MLANG_String MLANG_Reflection::Array::buildTypeName( const Type & type, 
                                                size_t length ) {
//-------------------------------------------------------------------------------
  return type.fullName() + "[" + MLANG_String::valueOf(length) + "]";
}
