//$Id: Callback.cpp,v 1.1 2004/12/01 14:50:41 mato Exp $

#include "MLANG/Reflection/Kernel.h"
#include "MLANG/Reflection/Callback.h"
#include <list>


typedef std::list<MLANG_Reflection::ICallback*> CbList; 
static CbList s_classCallbacks;


//-------------------------------------------------------------------------------
void MLANG_Reflection::installClassCallback( MLANG_Reflection::ICallback * cb ) {
//-------------------------------------------------------------------------------
  s_classCallbacks.push_back( cb );
}

//-------------------------------------------------------------------------------
void MLANG_Reflection::uninstallClassCallback( MLANG_Reflection::ICallback * cb ) {
//-------------------------------------------------------------------------------
  s_classCallbacks.remove( cb );
}

//-------------------------------------------------------------------------------
void MLANG_Reflection::fireClassCallback( const MLANG_Reflection::Type & ty ) {
//-------------------------------------------------------------------------------
  for ( CbList::const_iterator i = s_classCallbacks.begin(); 
        i != s_classCallbacks.end(); i++ ) {
    (**i)(ty);
  }
}

