//$Id: Callback.h,v 1.1 2004/12/01 14:50:41 mato Exp $

#ifndef MLANG_REFLECTION_CALLBACK_H
#define MLANG_REFLECTION_CALLBACK_H

// Include files

namespace MLANG_Reflection
{

    // forward declarations
    class Type;

    /** 
     * @class  Callback.h MLANG/Reflection/Callback.h
     * @author Pere Mato
     * @date 12/11/2004
     * @ingroup Ref
     */
    class ICallback {
      
    public:

      /** destructor */
      virtual ~ICallback() {}

      /**
       * operator call (virtual)
       */
       virtual void operator () ( const Type & ) = 0;


    }; // class ICallback
    
    
    void installClassCallback( ICallback * cb );
    void uninstallClassCallback( ICallback * cb );
    void fireClassCallback( const Type & );
    
} // namespace MLANG_Reflection



#endif // MLANG_REFLECTION_CALLBACK_H
