//$Id: ConstVolatile.h,v 1.5 2004/10/07 10:03:42 roiser Exp $
#ifndef MLANG_REFLECTION_CONSTVOLATILE_H
#define MLANG_REFLECTION_CONSTVOLATILE_H

// Include files

namespace MLANG_Reflection

{


    /**
     * @class ConstVolatile ConstVolatile.h Reflection/ConstVolatile.h
     * @author Stefan Roiser
     * @date 15/06/2004
     */
    class ConstVolatile : public TypeBase {
    public:

      /** Constructor */
      ConstVolatile( const Type * constVolatileType, const std::type_info &  );


      /** Destructor */
      virtual ~ConstVolatile() {}


      /**
       * type will return the pointer to the type the cv is pointing to
       * @return pointer to Type
       */
      const Type * toType() const;

    private:

      /** static funtion that composes the type name */
      static MLANG_String buildTypeName(const Type* constVolatileType );

      /** 
       * the pointer to the corresponding type 
       * @label const volatile type
       * @link aggregation
       * @supplierCardinality 1
       */
      const Type * m_constVolatileType;

    }; // class ConstVolatile
} //namespace MLANG_Reflection

//-------------------------------------------------------------------------------
inline MLANG_Reflection::ConstVolatile::ConstVolatile( const Type * constVolatileType, const std::type_info & ti )
//-------------------------------------------------------------------------------
: TypeBase( buildTypeName(constVolatileType).c_str(), constVolatileType->sizeOf(), CONSTVOLATILE, ti ), 
    m_constVolatileType( constVolatileType ) {}

//-------------------------------------------------------------------------------
inline const MLANG_Reflection::Type * MLANG_Reflection::ConstVolatile::toType() const {
//-------------------------------------------------------------------------------
  return m_constVolatileType;
}

//-------------------------------------------------------------------------------
inline MLANG_String MLANG_Reflection::ConstVolatile::buildTypeName( const Type* constVolatileType )
//-------------------------------------------------------------------------------
{
  if ( constVolatileType->isReference() || constVolatileType->isPointer() ) {
    return constVolatileType->name() + " const volatile";
  }
  else {
    return MLANG_String("const volatile ") + constVolatileType->name();
  }
}

#endif // MLANG_REFLECTIONION_CONSTVOLATILE_H

