//$Id: DataMember.cpp,v 1.7 2004/11/30 22:57:58 roiser Exp $

#include "MLANG/Reflection/DataMember.h"
#include "MLANG/Reflection/Scope.h"
#include "MLANG/Reflection/Tools.h"
#include "MLANG/Reflection/Class.h"
#include "MLANG/Reflection/Object.h"
#include "MLANG/Reflection/Member.h"

//-------------------------------------------------------------------------------
MLANG_Reflection::DataMember::DataMember( const char *  name,
                                      const Type &  type,
                                      size_t        offset,
                                      unsigned int  modifiers )
//-------------------------------------------------------------------------------
  : MemberBase ( name, type, DATAMEMBER, modifiers ),
    m_offset( offset) { }


//-------------------------------------------------------------------------------
MLANG_Reflection::DataMember::~DataMember() {}
//-------------------------------------------------------------------------------


//-------------------------------------------------------------------------------
MLANG_String MLANG_Reflection::DataMember::fullName( bool typedefexp ) const {
//-------------------------------------------------------------------------------
  MLANG_String s = "";
  if ( isPublic())          { s += "public ";    }
  if ( isProtected())       { s += "protected "; }
  if ( isPrivate())         { s += "private ";   }
  if ( isExtern())          { s += "extern ";    }
  if ( isStatic())          { s += "static ";    }
  if ( isAuto())            { s += "auto ";      }
  if ( isRegister())        { s += "register ";  }
  if ( isMutable())         { s += "mutable ";   }
  s += type().fullName(typedefexp) + " ";
  s += scope().fullName();
  if ( ! scope().isTopScope()) { s += "::"; }
  s += name();
  return s;
}


//-------------------------------------------------------------------------------
void * MLANG_Reflection::DataMember::get( const Object & obj ) const {
//-------------------------------------------------------------------------------
  void * mem = calculateBaseObject( obj );
  mem = (char*)mem + offset();
  return mem;
}


//-------------------------------------------------------------------------------
void MLANG_Reflection::DataMember::set( const Object & obj,
                                    const void * value ) const {
//-------------------------------------------------------------------------------
  void * mem = calculateBaseObject( obj );
  mem = (char*)mem + offset();
  if (type().isClass() ) {
    // Should use the asigment operator if exists (FIX-ME)
    memcpy( mem, value, type().sizeOf());
  }
  else {
    memcpy( mem, value, type().sizeOf() );
  }
}
