//$Id: DataMember.h,v 1.8 2004/11/30 22:57:58 roiser Exp $
#ifndef MLANG_REFLECTION_DATAMEMBER_H
#define MLANG_REFLECTION_DATAMEMBER_H

// Include files
#include "MLANG/Reflection/MemberBase.h"

namespace MLANG_Reflection
{

    // forward declarations
    class TypeBase;
    class Type;

    /**
     * @class DataMember DataMember.h MLANG/Reflection/DataMember.h
     * @author Stefan Roiser
     * @date 24/11/2003
     * @ingroup Ref
     */
    class DataMember : public MemberBase {

    public:

      /** default constructor */
      DataMember( const char *   name,
                  const Type &   type, 
                  size_t         offset,
                  unsigned int   modifiers = 0 );


      /** destructor */
      virtual ~DataMember();


      /** return fullName of data member */
      MLANG_String fullName( bool typedefexp = false ) const;


      /** get the member value (as void*) */
      void * get( const Object & obj ) const;


      /** return the offset of the member */
      size_t offset() const;


      /** set the member value */
      void set( const Object & obj,
                const void * value ) const;

    private:

      /** offset of the member */
      size_t m_offset;

    }; // class DataMember
} //namespace MLANG_Reflection


//-------------------------------------------------------------------------------
inline size_t MLANG_Reflection::DataMember::offset() const {
//-------------------------------------------------------------------------------
  return m_offset;
}

#endif // MLANG_REFLECTION_DATAMEMBER_H

