//$Id: EnumInfo.h,v 1.1 2004/11/30 22:57:58 roiser Exp $
#ifndef MLANG_REFLECTION_ENUMINFO_H
#define MLANG_REFLECTION_ENUMINFO_H

// Include files
#include "MLANG/String.h"

namespace MLANG_Reflection
{

    // forward declarations 


    /** 
     * @class EnumInfo Enum.h MLANG/Reflection/Enum.h
     * @author Stefan Roiser
     * @date 07/11/2004
     * @ingroup Ref
     */
    class EnumInfo {

    private:

      struct Info {                     // info about one enum
        Info( const char * name,  
              long value );             // constructor
        virtual ~Info() {}              // destructor 
        MLANG_String m_name;             // name of enum
        long m_value;                   // value of enum
      };                                // class Info

    public:

      /** default constructor */
      EnumInfo();


      /** constructor */
      EnumInfo( const char * name,
                long value );


      /** destructor */
      ~EnumInfo();


      /** return the name of the enum */
      const MLANG_String & name() const;


      /** return the value of the enum */
      size_t value() const;

    private:

      /** pointer to enum info */
      Info * m_enumInfo;

    }; // class EnumInfo

} //namespace MLANG_Reflection

#include "MLANG/Reflection/Enum.h"

//-------------------------------------------------------------------------------
inline MLANG_Reflection::EnumInfo::EnumInfo() 
//-------------------------------------------------------------------------------
  : m_enumInfo( 0 ) {}


//-------------------------------------------------------------------------------
inline MLANG_Reflection::EnumInfo::EnumInfo( const char * name,
                                         long value ) 
//-------------------------------------------------------------------------------
  : m_enumInfo( new Info(name, value)) {}


//-------------------------------------------------------------------------------
inline MLANG_Reflection::EnumInfo::~EnumInfo() {
//-------------------------------------------------------------------------------
  delete m_enumInfo;
}


//-------------------------------------------------------------------------------
inline const MLANG_String & MLANG_Reflection::EnumInfo::name() const {
//-------------------------------------------------------------------------------
  return m_enumInfo->m_name;
}


//-------------------------------------------------------------------------------
inline size_t MLANG_Reflection::EnumInfo::value() const {
//-------------------------------------------------------------------------------
  return m_enumInfo->m_value;
}


//-------------------------------------------------------------------------------
inline MLANG_Reflection::EnumInfo::Info::Info( const char * name, 
                                           long value ) 
//-------------------------------------------------------------------------------
  : m_name( name ), 
    m_value( value ) { }


#endif // MLANG_REFLECTION_ENUMINFO_H

