//$Id: FuncHandler.cpp,v 1.2 2004/10/12 12:56:37 roiser Exp $

#include "FuncHandler.h"
#include "Reflection/Tools.h"
#include <typeinfo>


//-------------------------------------------------------------------------------
template < class R, class C >
const MLANG_String MLANG_Reflection::FuncHandler::demangleFunRetType(R(C::*)()) {
//-------------------------------------------------------------------------------
  return Tools::demangle(typeid(R).name());
}


//-------------------------------------------------------------------------------
template < class R, class C, class T0>
const MLANG_String MLANG_Reflection::FuncHandler::demangleFunRetType(R(C::*)(T0)) {
//-------------------------------------------------------------------------------
  return Tools::demangle(typeid(R).name());
}


//-------------------------------------------------------------------------------
template < class R, class C, class T0, class T1 >
const MLANG_String MLANG_Reflection::FuncHandler::demangleFunRetType(R(C::*)(T0,T1)) {
//-------------------------------------------------------------------------------
  return Tools::demangle(typeid(R).name());
}


//-------------------------------------------------------------------------------
template < class R, class C, class T0, class T1, class T2 >
const MLANG_String MLANG_Reflection::FuncHandler::demangleFunRetType(R(C::*)(T0,T1,T2)) {
//-------------------------------------------------------------------------------
  return Tools::demangle(typeid(R).name());
}


//-------------------------------------------------------------------------------
template < class R, class C, class T0, class T1, class T2, class T3 >
const MLANG_String MLANG_Reflection::FuncHandler::demangleFunRetType(R(C::*)(T0,T1,T2,T3)) {
//-------------------------------------------------------------------------------
  return Tools::demangle(typeid(R).name());
}


//-------------------------------------------------------------------------------
template < class R, class C, class T0, class T1, class T2, class T3, class T4 >
const MLANG_String MLANG_Reflection::FuncHandler::demangleFunRetType(R(C::*)(T0,T1,T2,T3,T4)) {
//-------------------------------------------------------------------------------
  return Tools::demangle(typeid(R).name());
}


//-------------------------------------------------------------------------------
template < class R, class C >
const MLANG_String MLANG_Reflection::FuncHandler::demangleFunParTypes(R(C::*)()) {
//-------------------------------------------------------------------------------
  return "void";
}


//-------------------------------------------------------------------------------
template < class R, class C, class T0>
const MLANG_String MLANG_Reflection::FuncHandler::demangleFunParTypes(R(C::*)(T0)) {
//-------------------------------------------------------------------------------
  return Tools::demangle(typeid(T0).name());
}


//-------------------------------------------------------------------------------
template < class R, class C, class T0, class T1 >
const MLANG_String MLANG_Reflection::FuncHandler::demangleFunParTypes(R(C::*)(T0,T1)) {
//-------------------------------------------------------------------------------
  MLANG_String s = 
    Tools::demangle(typeid(T0).name()) + ";" +
    Tools::demangle(typeid(T1).name());
  return s;
}


//-------------------------------------------------------------------------------
template < class R, class C, class T0, class T1, class T2 >
const MLANG_String MLANG_Reflection::FuncHandler::demangleFunParTypes(R(C::*)(T0,T1,T2)) {
//-------------------------------------------------------------------------------
  MLANG_String s =
    Tools::demangle(typeid(T0).name()) + ";" +
    Tools::demangle(typeid(T1).name()) + ";" +
    Tools::demangle(typeid(T2).name());
  return s;
}


//-------------------------------------------------------------------------------
template < class R, class C, class T0, class T1, class T2, class T3 >
const MLANG_String MLANG_Reflection::FuncHandler::demangleFunParTypes(R(C::*)(T0,T1,T2,T3)) {
//-------------------------------------------------------------------------------
  MLANG_String s = 
    Tools::demangle(typeid(T0).name()) + ";" +
    Tools::demangle(typeid(T1).name()) + ";" +
    Tools::demangle(typeid(T2).name()) + ";" +
    Tools::demangle(typeid(T3).name());
  return s;
}


//-------------------------------------------------------------------------------
template < class R, class C, class T0, class T1, class T2, class T3, class T4 >
const MLANG_String MLANG_Reflection::FuncHandler::demangleFunParTypes(R(C::*)(T0,T1,T2,T3,T4)) {
//-------------------------------------------------------------------------------
  MLANG_String s = 
    Tools::demangle(typeid(T0).name()) + ";" +
    Tools::demangle(typeid(T1).name()) + ";" +
    Tools::demangle(typeid(T2).name()) + ";" +
    Tools::demangle(typeid(T3).name()) + ";" +
    Tools::demangle(typeid(T4).name());
  return s;
}


//-------------------------------------------------------------------------------
template < class R >
const MLANG_String MLANG_Reflection::FuncHandler::demangleFunRetType(R(*)()) {
//-------------------------------------------------------------------------------
  return Tools::demangle(typeid(R).name());
}


//-------------------------------------------------------------------------------
template < class R, class T0>
const MLANG_String MLANG_Reflection::FuncHandler::demangleFunRetType(R(*)(T0)) {
//-------------------------------------------------------------------------------
  return Tools::demangle(typeid(R).name());
}


//-------------------------------------------------------------------------------
template < class R, class T0, class T1 >
const MLANG_String MLANG_Reflection::FuncHandler::demangleFunRetType(R(*)(T0,T1)) {
//-------------------------------------------------------------------------------
  return Tools::demangle(typeid(R).name());
}


//-------------------------------------------------------------------------------
template < class R, class T0, class T1, class T2 >
const MLANG_String MLANG_Reflection::FuncHandler::demangleFunRetType(R(*)(T0,T1,T2)) {
//-------------------------------------------------------------------------------
  return Tools::demangle(typeid(R).name());
}


//-------------------------------------------------------------------------------
template < class R, class T0, class T1, class T2, class T3 >
const MLANG_String MLANG_Reflection::FuncHandler::demangleFunRetType(R(*)(T0,T1,T2,T3)) {
//-------------------------------------------------------------------------------
  return Tools::demangle(typeid(R).name());
}


//-------------------------------------------------------------------------------
template < class R, class T0, class T1, class T2, class T3, class T4 >
const MLANG_String MLANG_Reflection::FuncHandler::demangleFunRetType(R(*)(T0,T1,T2,T3,T4)) {
//-------------------------------------------------------------------------------
  return Tools::demangle(typeid(R).name());
}


//-------------------------------------------------------------------------------
template < class R >
const MLANG_String MLANG_Reflection::FuncHandler::demangleFunParTypes(R(*)()) {
//-------------------------------------------------------------------------------
  return "void";
}


//-------------------------------------------------------------------------------
template < class R, class T0>
const MLANG_String MLANG_Reflection::FuncHandler::demangleFunParTypes(R(*)(T0)) {
//-------------------------------------------------------------------------------
  return Tools::demangle(typeid(T0).name());
}


//-------------------------------------------------------------------------------
template < class R, class T0, class T1 >
const MLANG_String MLANG_Reflection::FuncHandler::demangleFunParTypes(R(*)(T0,T1)) {
//-------------------------------------------------------------------------------
  MLANG_String s = 
    Tools::demangle(typeid(T0).name()) + ";" +
    Tools::demangle(typeid(T1).name());
  return s;
}


//-------------------------------------------------------------------------------
template < class R, class T0, class T1, class T2 >
const MLANG_String MLANG_Reflection::FuncHandler::demangleFunParTypes(R(*)(T0,T1,T2)) {
//-------------------------------------------------------------------------------
  MLANG_String s = 
    Tools::demangle(typeid(T0).name()) + ";" +
    Tools::demangle(typeid(T1).name()) + ";" +
    Tools::demangle(typeid(T2).name());
  return s;
}


//-------------------------------------------------------------------------------
template < class R, class T0, class T1, class T2, class T3 >
const MLANG_String MLANG_Reflection::FuncHandler::demangleFunParTypes(R(*)(T0,T1,T2,T3)) {
//-------------------------------------------------------------------------------
  MLANG_String s = 
    Tools::demangle(typeid(T0).name()) + ";" +
    Tools::demangle(typeid(T1).name()) + ";" +
    Tools::demangle(typeid(T2).name()) + ";" +
    Tools::demangle(typeid(T3).name());
  return s;
}


//-------------------------------------------------------------------------------
template < class R, class T0, class T1, class T2, class T3, class T4 >
const MLANG_String MLANG_Reflection::FuncHandler::demangleFunParTypes(R(*)(T0,T1,T2,T3,T4)) {
//-------------------------------------------------------------------------------
  MLANG_String s = 
    Tools::demangle(typeid(T0).name()) + ";" +
    Tools::demangle(typeid(T1).name()) + ";" +
    Tools::demangle(typeid(T2).name()) + ";" +
    Tools::demangle(typeid(T3).name()) + ";" +
    Tools::demangle(typeid(T4).name());
  return s;
}
