//$Id: FuncHandler.h,v 1.1.1.1 2004/06/21 15:22:25 roiser Exp $

#ifndef SEAL_REFLECT_FUNCHANDLER_H
#define SEAL_REFLECT_FUNCHANDLER_H


// Include files
#include <string>


namespace seal {
  namespace reflex {


    class FuncHandler {

    public:

      template < class R, class C >
        static const MLANG_String demangleFunRetType(R(C::*)());

      template < class R, class C, class T0>
        static const MLANG_String demangleFunRetType(R(C::*)(T0));

      template < class R, class C, class T0, class T1 >
        static const MLANG_String demangleFunRetType(R(C::*)(T0,T1));

      template < class R, class C, class T0, class T1, class T2 >
        static const MLANG_String demangleFunRetType(R(C::*)(T0,T1,T2));

      template < class R, class C, class T0, class T1, class T2, class T3 >
        static const MLANG_String demangleFunRetType(R(C::*)(T0,T1,T2,T3));

      template < class R, class C, class T0, class T1, class T2, class T3, class T4 >
        static const MLANG_String demangleFunRetType(R(C::*)(T0,T1,T2,T3,T4));


      template < class R, class C >
        static const MLANG_String demangleFunParTypes(R(C::*)());

      template < class R, class C, class T0>
        static const MLANG_String demangleFunParTypes(R(C::*)(T0));

      template < class R, class C, class T0, class T1 >
        static const MLANG_String demangleFunParTypes(R(C::*)(T0,T1));

      template < class R, class C, class T0, class T1, class T2 >
        static const MLANG_String demangleFunParTypes(R(C::*)(T0,T1,T2));

      template < class R, class C, class T0, class T1, class T2, class T3 >
        static const MLANG_String demangleFunParTypes(R(C::*)(T0,T1,T2,T3));

      template < class R, class C, class T0, class T1, class T2, class T3, class T4 >
        static const MLANG_String demangleFunParTypes(R(C::*)(T0,T1,T2,T3,T4));


      template < class R >
        static const MLANG_String demangleFunRetType(R(*)());

      template < class R, class T0>
        static const MLANG_String demangleFunRetType(R(*)(T0));

      template < class R, class T0, class T1 >
        static const MLANG_String demangleFunRetType(R(*)(T0,T1));

      template < class R, class T0, class T1, class T2 >
        static const MLANG_String demangleFunRetType(R(*)(T0,T1,T2));

      template < class R, class T0, class T1, class T2, class T3 >
        static const MLANG_String demangleFunRetType(R(*)(T0,T1,T2,T3));

      template < class R, class T0, class T1, class T2, class T3, class T4 >
        static const MLANG_String demangleFunRetType(R(*)(T0,T1,T2,T3,T4));

 
      template < class R >
        static const MLANG_String demangleFunParTypes(R(*)());

      template < class R, class T0>
        static const MLANG_String demangleFunParTypes(R(*)(T0));

      template < class R, class T0, class T1 >
        static const MLANG_String demangleFunParTypes(R(*)(T0,T1));

      template < class R, class T0, class T1, class T2 >
        static const MLANG_String demangleFunParTypes(R(*)(T0,T1,T2));

      template < class R, class T0, class T1, class T2, class T3 >
        static const MLANG_String demangleFunParTypes(R(*)(T0,T1,T2,T3));

      template < class R, class T0, class T1, class T2, class T3, class T4 >
        static const MLANG_String demangleFunParTypes(R(*)(T0,T1,T2,T3,T4));

    }; // class FuncHandler
  } // namespace reflex
} // namespace seal

#endif // SEAL_REFLECT_FUNCHANDLER
