//$Id: Function.cpp,v 1.9 2004/11/30 22:57:58 roiser Exp $


#include "MLANG/Reflection/Function.h"
#include "MLANG/Reflection/Tools.h"

//-------------------------------------------------------------------------------
MLANG_Reflection::Function::Function( const Type & returnType,
                                  std::vector< Type > parameters,
                                  const std::type_info & typeInfo,
                                  TYPE functionType) 
//-------------------------------------------------------------------------------
  : TypeBase( buildTypeName(returnType, parameters).c_str(), 0, functionType, typeInfo ),
    m_parameters(parameters),
    m_returnType(returnType),
    m_modifiers(0) { }


//-------------------------------------------------------------------------------
MLANG_String MLANG_Reflection::Function::fullName( bool /*typedefexp*/ ) const {
//-------------------------------------------------------------------------------
  return buildTypeName(m_returnType, m_parameters);
}


//-------------------------------------------------------------------------------
MLANG_String MLANG_Reflection::Function::buildTypeName( const Type & ret, 
                                                   const std::vector< Type > & pars) {
//-------------------------------------------------------------------------------
  std::vector< Type >::const_iterator it;
  MLANG_String tyname = ret.fullName()+ " (";
  if ( pars.size() > 0 ) {
    for (it = pars.begin(); it != pars.end(); ) {
      tyname += it->fullName();
      if ( ++it != pars.end() ) tyname += ", ";
    }
  }
  else {
    tyname += "void";
  }
  tyname += ")";
  return tyname;
}
