//$Id: InstantiatedTemplate.cpp,v 1.3 2004/11/30 22:57:58 roiser Exp $


#include "MLANG/Reflection/InstantiatedTemplate.h"
#include "MLANG/Reflection/InstantiatedTemplateClass.h"
#include "MLANG/Reflection/InstantiatedTemplateFunction.h"

//-------------------------------------------------------------------------------
MLANG_Reflection::InstantiatedTemplate::
InstantiatedTemplate( const TemplateFamily * templateFamily,
                      TYPE instantiatedTemplateType,
                      const std::vector < TemplateArgument > & templateArguments )
//-------------------------------------------------------------------------------
  : m_templateFamily( templateFamily ),
    m_instantiatedTemplateType( instantiatedTemplateType ),
    m_templateArguments( templateArguments ) {}



//-------------------------------------------------------------------------------
MLANG_String 
MLANG_Reflection::InstantiatedTemplate::instantiatedTemplateTypeAsString() const {
//-------------------------------------------------------------------------------
  switch ( m_instantiatedTemplateType ) {
  case INSTANTIATEDTEMPLATECLASS:
    return "INSTANTIATEDTEMPLATECLASS";
    break;
  case INSTANTIATEDTEMPLATEFUNCTION:
    return "INSTANTIATEDTEMPLATEFUNCTION";
    break;
  default:
    return "Templated " + fullName() + "is not assigned to a instantiated template species";
  }
}

//-------------------------------------------------------------------------------
MLANG_String MLANG_Reflection::InstantiatedTemplate::fullName( bool typedefexp ) const {
//-------------------------------------------------------------------------------
  MLANG_String s = "<";
  for ( size_t i = 0; i < m_templateArguments.size(); ++i ) {
    s += m_templateArguments[ i ].fullName( typedefexp );
    if ( i < ( m_templateArguments.size() - 1 ) ) { s += ", "; }
  }
  s += ">";
  return s;
}


//-------------------------------------------------------------------------------
MLANG_Reflection::InstantiatedTemplate::TemplateArgument::TemplateArgument( const Type & type ) 
//-------------------------------------------------------------------------------
  : m_templateArgumentType( type ) {}

