//$Id: InstantiatedTemplateClass.h,v 1.3 2004/11/01 10:12:02 roiser Exp $
#ifndef MLANG_REFLECTION_TEMPLATEDCLASS_H
#define MLANG_REFLECTION_TEMPLATEDCLASS_H

// Include files
#include "MLANG/Reflection/Class.h"
#include "MLANG/Reflection/InstantiatedTemplate.h"


namespace MLANG_Reflection

{


    /**
     * @class InstantiatedTemplateClass InstantiatedTemplateClass.h Reflection/InstantiatedTemplateClass.h
     * @author Stefan Roiser
     * @date 13/1/2004
     * @ingroup Ref
     */
    class InstantiatedTemplateClass : public Class, 
                                      public InstantiatedTemplate {
    public:

      /** default constructor */
      InstantiatedTemplateClass( const char * type, 
                                 size_t size, 
                                 const std::type_info & typeInfo, 
                                 const TemplateFamily * templateFamily,
                                 std::vector < TemplateArgument > & templateArguments );


      /** destructor */
      virtual ~InstantiatedTemplateClass() {}


      /**
       * fullName returns the fully qualified name of the templated class
       * @param  typedefexp expand typedefs or not
       * @return fully qualified name of templated class
       */
      MLANG_String fullName(bool typedefexp = false) const;

    }; // class TemplatedClass
} // namespace MLANG_Reflection

#endif // MLANG_REFLECTION_TEMPLATEDCLASS_H
