//$Id: InstantiatedTemplateFunction.h,v 1.3 2004/11/30 22:57:58 roiser Exp $

#ifndef MLANG_REFLECTION_TEMPLATEDFUNCTION_H
#define MLANG_REFLECTION_TEMPLATEDFUNCTION_H

// Include files
#include "MLANG/Reflection/Function.h"
#include "MLANG/Reflection/InstantiatedTemplate.h"

namespace MLANG_Reflection
{


    /**
     * @class InstantiatedTemplateFunction InstantiatedTemplateFunction.h MLANG/Reflection/InstantiatedTemplateFunction.h
     * @author Stefan Roiser
     * @date 13/1/2004
     * @ingroup Ref
     */
    class InstantiatedTemplateFunction : public Function, public InstantiatedTemplate {
    
    public:

      /** default constructor */
      InstantiatedTemplateFunction( const char * type,
                                    size_t size,
                                    const std::type_info & typeInfo,
                                    const char * returnType,
                                    const char * parameterTypes,
                                    const TemplateFamily & templateFamily,
                                    const std::vector < TemplateArgument > templateArguments );


      /** destructor */
      virtual ~InstantiatedTemplateFunction() {}


      /**
       * fullName returns the fully qualified name of the
       * templated function
       * @param  typedefexp expand typedefs or not
       * @return fully qualified name of templated function
       */
      MLANG_String fullName( bool typedefexp = false ) const;

    }; // class TemplatedFunction
} // namespace MLANG_Reflection



#endif // MLANG_REFLECTION_TEMPLATEDFUNCTION_H
