//$Id: Kernel.cpp,v 1.4 2004/11/30 22:57:58 roiser Exp $

#include "MLANG/Reflection/Kernel.h"
#include "MLANG/Reflection/Scope.h"
#include "MLANG/Reflection/ScopeName.h"
#include "MLANG/Reflection/Fundamental.h"
#include "MLANG/Reflection/Namespace.h"
#include "MLANG/Reflection/PropertyList.h"
#include "MLANG/Reflection/Typedef.h"
#include "MLANG/Reflection/Type.h"
#include "MLANG/Reflection/Base.h"
#include "MLANG/Reflection/Member.h"
#include "MLANG/Reflection/Class.h"
#include "MLANG/Reflection/Object.h"
#include "MLANG/Reflection/UnionInfo.h"
#include "MLANG/Reflection/EnumInfo.h"
#include "MLANG/Reflection/InstantiatedTemplate.h"
#include "MLANG/Reflection/PropertyList.h"
#include <typeinfo>

MLANG_String MLANG_Reflection::Reflex::argv0 = "Seal Reflex";


MLANG_Reflection::Scope MLANG_Reflection::Scope::__NIRVANA__ = 
  MLANG_Reflection::Scope( new ScopeName( "@N@I@R@V@A@N@A@", 0 ));


//-------------------------------------------------------------------------------
MLANG_Reflection::Reflex::Reflex() {
//-------------------------------------------------------------------------------

  /** initialisation of the global namespace */
  Namespace::initGlobalNamespace();

  // initialising fundamental types
  Fundamental * tb = 0;
  Type t = Type();
 
  // char [3.9.1.1]
  tb = new Fundamental( "char", 
                        sizeof( char ), 
                        typeid( char ));
  tb->propertyList().addProperty( "desc", "fundamental type" );

  // signed integer types [3.9.1.2]
  tb = new Fundamental( "signed char", 
                        sizeof( signed char ), 
                        typeid( signed char ));
  tb->propertyList().addProperty( "desc", "fundamental type" );

  tb = new Fundamental( "short int", 
                        sizeof( short int ), 
                        typeid( short int ));
  tb->propertyList().addProperty( "desc", "fundamental type" );
  t = (*tb);
  new Typedef( "short", t);
  new Typedef( "signed short", t);
  new Typedef( "short signed", t);
  new Typedef( "signed short int", t);
  new Typedef( "short signed int", t);

  tb = new Fundamental( "int", 
                        sizeof( int ), 
                        typeid( int ));
  tb->propertyList().addProperty( "desc", "fundamental type" );
  t = *tb;
  new Typedef( "signed", t);
  new Typedef( "signed int", t);

  tb = new Fundamental( "long int", 
                        sizeof( long int ), 
                        typeid( long int ));
  tb->propertyList().addProperty( "desc", "fundamental type" );
  t = *tb;
  new Typedef( "long", t);
  new Typedef( "signed long", t);
  new Typedef( "long signed", t);
  new Typedef( "signed long int", t);
  new Typedef( "long signed int", t);

  // unsigned integer types [3.9.1.3]
  tb = new Fundamental( "unsigned char", 
                        sizeof( unsigned char ), 
                        typeid( unsigned char ));
  tb->propertyList().addProperty( "desc", "fundamental type" );

  tb = new Fundamental( "unsigned short int", 
                        sizeof( unsigned short int ), 
                        typeid( unsigned short int ));
  tb->propertyList().addProperty( "desc", "fundamental type" );
  t = *tb;
  new Typedef( "unsigned short", t);
  new Typedef( "short unsigned int", t);

  tb = new Fundamental( "unsigned int", 
                        sizeof( unsigned int ), 
                        typeid( unsigned int ));
  tb->propertyList().addProperty( "desc", "fundamental type" );
  t = *tb;
  new Typedef( "unsigned", t);

  tb = new Fundamental( "unsigned long int", 
                        sizeof( unsigned long int ), 
                        typeid( unsigned long int ));
  tb->propertyList().addProperty( "desc", "fundamental type" );
  t = *tb;
  new Typedef( "unsigned long", t);
  new Typedef( "long unsigned", t);
  new Typedef( "long unsigned int", t);

  /*/ w_chart [3.9.1.5]
  tb = new Fundamental( "w_chart", 
                        sizeof( w_chart ), 
                        & typeid( w_chart ));
  tb->propertyList().addProperty( "desc", "fundamental type" );
  */

  // bool [3.9.1.6]
  tb = new Fundamental( "bool", 
                        sizeof( bool ), 
                        typeid( bool ));
  tb->propertyList().addProperty( "desc", "fundamental type" );

  // floating point types [3.9.1.8]
  tb = new Fundamental( "float", 
                        sizeof( float ), 
                        typeid( float ));
  tb->propertyList().addProperty( "desc", "fundamental type" );

  tb = new Fundamental( "double", 
                        sizeof( double ), 
                        typeid( double ));
  tb->propertyList().addProperty( "desc", "fundamental type" );

  tb = new Fundamental( "long double", 
                        sizeof( long double ), 
                        typeid( long double ));
  tb->propertyList().addProperty( "desc", "fundamental type" );

  // void [3.9.1.9]
  tb = new Fundamental( "void", 
                        0, 
                        typeid( void ));
  tb->propertyList().addProperty( "desc", "fundamental type" );

  // non fundamental types but also supported at initialisation
  tb = new Fundamental( "longlong", 
                        sizeof( longlong ), 
                        typeid( longlong ));
  tb->propertyList().addProperty( "desc", "fundamental type" );
  t = *tb;
  new Typedef( "long long", t);
  new Typedef( "long long int", t);

  tb = new Fundamental( "ulonglong", 
                        sizeof( ulonglong ), 
                        typeid( ulonglong ));
  tb->propertyList().addProperty( "desc", "fundamental type" );
  t = *tb;
  new Typedef( "long long unsigned", t);
  new Typedef( "unsigned long long", t);
  new Typedef( "unsigned long long int", t);
  new Typedef( "long long unsigned int", t);
}


//-------------------------------------------------------------------------------
namespace {
  static MLANG_Reflection::Reflex initialise;
}
//-------------------------------------------------------------------------------



