//-------------------------------------------------------------------------------
ACE_INLINE bool MLANG_Reflection::Member::operator < ( const Member & member ) const {
//-------------------------------------------------------------------------------
  if ( (*this) && member ) 
    return ( type() < member.type() && name() < member.name());
  return false;
}


//-------------------------------------------------------------------------------
ACE_INLINE bool MLANG_Reflection::Member::operator == ( const Member & member ) const {
//-------------------------------------------------------------------------------
  if ( (*this) && member ) 
    return ( type() == member.type() && name() == member.name() );
  return false;
}


//-------------------------------------------------------------------------------
ACE_INLINE MLANG_Reflection::Member & MLANG_Reflection::Member::operator = ( const Member & member ) {
//-------------------------------------------------------------------------------
  m_memberBase = member.m_memberBase;
  return * this;
}


//-------------------------------------------------------------------------------
ACE_INLINE MLANG_Reflection::Member::operator bool () const {
//-------------------------------------------------------------------------------
  return 0 != m_memberBase;
}


//-------------------------------------------------------------------------------
ACE_INLINE MLANG_String MLANG_Reflection::Member::fullName( bool typedefexp ) const {
//-------------------------------------------------------------------------------
  if ( m_memberBase ) return m_memberBase->fullName( typedefexp );
  return "";
}


//-------------------------------------------------------------------------------
ACE_INLINE void * MLANG_Reflection::Member::get( const Object & obj ) const {
//-------------------------------------------------------------------------------
  if ( m_memberBase ) return m_memberBase->get( obj );
  return 0;
}


//-------------------------------------------------------------------------------
ACE_INLINE void * MLANG_Reflection::Member::invoke( const Object & obj,
                                            const std::vector < void * > & paramList ) const {
//-------------------------------------------------------------------------------
  if ( m_memberBase ) return m_memberBase->invoke( obj, paramList );
  return 0;
}


//-------------------------------------------------------------------------------
ACE_INLINE void * 
MLANG_Reflection::Member::invoke( const std::vector < void * > & paramList ) const {
//-------------------------------------------------------------------------------
  if ( m_memberBase ) return m_memberBase->invoke( paramList );
  return 0;
}


//-------------------------------------------------------------------------------
ACE_INLINE bool MLANG_Reflection::Member::isAuto() const {
//-------------------------------------------------------------------------------
  if ( m_memberBase ) return m_memberBase->isAuto();
  return false;
}


//-------------------------------------------------------------------------------
ACE_INLINE bool MLANG_Reflection::Member::isConstructor() const {
//-------------------------------------------------------------------------------
  if ( m_memberBase ) return m_memberBase->isConstructor();
  return false;
}


//-------------------------------------------------------------------------------
ACE_INLINE bool MLANG_Reflection::Member::isConverter() const {
//-------------------------------------------------------------------------------
  if ( m_memberBase ) return m_memberBase->isConverter();
  return false;
}


//-------------------------------------------------------------------------------
ACE_INLINE bool MLANG_Reflection::Member::isCopyConstructor() const {
//-------------------------------------------------------------------------------
  if ( m_memberBase ) return m_memberBase->isCopyConstructor();\
  return false;
}


//-------------------------------------------------------------------------------
ACE_INLINE bool MLANG_Reflection::Member::isDataMember() const {
//-------------------------------------------------------------------------------
  if ( m_memberBase ) return m_memberBase->isDataMember();
  return false;
}


//-------------------------------------------------------------------------------
ACE_INLINE bool MLANG_Reflection::Member::isDestructor() const {
//-------------------------------------------------------------------------------
  if ( m_memberBase ) return m_memberBase->isDestructor();
  return false;
}


//-------------------------------------------------------------------------------
ACE_INLINE bool MLANG_Reflection::Member::isExplicit() const {
//-------------------------------------------------------------------------------
  if ( m_memberBase ) return m_memberBase->isExplicit();
  return false;
}


//-------------------------------------------------------------------------------
ACE_INLINE bool MLANG_Reflection::Member::isExtern() const {
//-------------------------------------------------------------------------------
  if ( m_memberBase ) return m_memberBase->isExtern();
  return false;
}


//-------------------------------------------------------------------------------
ACE_INLINE bool MLANG_Reflection::Member::isFunctionMember() const {
//-------------------------------------------------------------------------------
  if ( m_memberBase ) return m_memberBase->isFunctionMember();
  return false;
}


//-------------------------------------------------------------------------------
ACE_INLINE bool MLANG_Reflection::Member::isInline() const {
//-------------------------------------------------------------------------------
  if ( m_memberBase ) return m_memberBase->isInline();
  return false;
}


//-------------------------------------------------------------------------------
ACE_INLINE bool MLANG_Reflection::Member::isMutable() const {
//-------------------------------------------------------------------------------
  if ( m_memberBase ) return m_memberBase->isMutable();
  return false;
}


//-------------------------------------------------------------------------------
ACE_INLINE bool MLANG_Reflection::Member::isOperator() const {
//-------------------------------------------------------------------------------
  if ( m_memberBase ) return m_memberBase->isOperator();
  return false;
}


//-------------------------------------------------------------------------------
ACE_INLINE bool MLANG_Reflection::Member::isPrivate() const {
//-------------------------------------------------------------------------------
  if ( m_memberBase ) return m_memberBase->isPrivate();
  return false;
}


//-------------------------------------------------------------------------------
ACE_INLINE bool MLANG_Reflection::Member::isProtected() const {
//-------------------------------------------------------------------------------
  if ( m_memberBase ) return m_memberBase->isProtected();
  return false;
}


//-------------------------------------------------------------------------------
ACE_INLINE bool MLANG_Reflection::Member::isPublic() const {
//-------------------------------------------------------------------------------
  if ( m_memberBase ) return m_memberBase->isPublic();
  return false;
}


//-------------------------------------------------------------------------------
ACE_INLINE bool MLANG_Reflection::Member::isRegister() const {
//-------------------------------------------------------------------------------
  if ( m_memberBase ) return m_memberBase->isRegister();
  return false;
}


//-------------------------------------------------------------------------------
ACE_INLINE bool MLANG_Reflection::Member::isStatic() const {
//-------------------------------------------------------------------------------
  if ( m_memberBase ) return m_memberBase->isStatic();
  return false;
}


//-------------------------------------------------------------------------------
ACE_INLINE bool MLANG_Reflection::Member::isVirtual() const {
//-------------------------------------------------------------------------------
  if ( m_memberBase ) return m_memberBase->isVirtual();
  return false;
}


//-------------------------------------------------------------------------------
ACE_INLINE MLANG_Reflection::TYPE MLANG_Reflection::Member::memberType() const {
//-------------------------------------------------------------------------------
  if ( m_memberBase ) return m_memberBase->memberType();
  return UNRESOLVED;
}


//-------------------------------------------------------------------------------
ACE_INLINE MLANG_String MLANG_Reflection::Member::memberTypeAsString() const {
//-------------------------------------------------------------------------------
  if ( m_memberBase ) return m_memberBase->memberTypeAsString();
  return "";
}


//-------------------------------------------------------------------------------
ACE_INLINE MLANG_String MLANG_Reflection::Member::name() const {
//-------------------------------------------------------------------------------
  if ( m_memberBase ) return m_memberBase->name();
  return "";
}


//-------------------------------------------------------------------------------
ACE_INLINE size_t MLANG_Reflection::Member::offset() const {
//-------------------------------------------------------------------------------
  if ( m_memberBase ) return m_memberBase->offset();
  return 0;
}


//-------------------------------------------------------------------------------
ACE_INLINE size_t MLANG_Reflection::Member::parameterCount() const {
//-------------------------------------------------------------------------------
  if ( m_memberBase ) return m_memberBase->parameterCount();
  return 0;
}


//-------------------------------------------------------------------------------
ACE_INLINE MLANG_String MLANG_Reflection::Member::parameterDefault( size_t nth ) const {
//-------------------------------------------------------------------------------
  if ( m_memberBase ) return m_memberBase->parameterDefault( nth );
  return "";
}


//-------------------------------------------------------------------------------
ACE_INLINE MLANG_String MLANG_Reflection::Member::parameterName( size_t nth ) const {
//-------------------------------------------------------------------------------
  if ( m_memberBase ) return m_memberBase->parameterName( nth );
  return "";
}


//-------------------------------------------------------------------------------
ACE_INLINE MLANG_Reflection::PropertyList & MLANG_Reflection::Member::propertyList() const {
//-------------------------------------------------------------------------------
  if ( m_memberBase ) return m_memberBase->propertyList();
  return PropertyList::__NOPROPERTYLIST__;
}


//-------------------------------------------------------------------------------
ACE_INLINE MLANG_Reflection::Scope MLANG_Reflection::Member::scope() const {
//-------------------------------------------------------------------------------
  if ( m_memberBase ) return m_memberBase->scope();
  return Scope();
}


//-------------------------------------------------------------------------------
ACE_INLINE void MLANG_Reflection::Member::set( Object & obj ,
                                       const void * value ) const {
//-------------------------------------------------------------------------------
  if (m_memberBase ) m_memberBase->set( obj, value );
}


//-------------------------------------------------------------------------------
ACE_INLINE void MLANG_Reflection::Member::setScope( const Scope & scope ) const  {
//-------------------------------------------------------------------------------
  if ( m_memberBase ) m_memberBase->setScope( scope );
}


//-------------------------------------------------------------------------------
ACE_INLINE MLANG_Reflection::StubFunction MLANG_Reflection::Member::stubfunction() const {
//-------------------------------------------------------------------------------
  if ( m_memberBase ) return m_memberBase->stubfunction();
  return 0;
}


//-------------------------------------------------------------------------------
ACE_INLINE MLANG_Reflection::Type MLANG_Reflection::Member::type() const {
//-------------------------------------------------------------------------------
  if ( m_memberBase ) return m_memberBase->type();
  return Type();
}
