//$Id: Namespace.h,v 1.6 2004/11/30 22:57:58 roiser Exp $
#ifndef MLANG_REFLECTION_NAMESPACE_H
#define MLANG_REFLECTION_NAMESPACE_H

// Include files
#include "MLANG/Reflection/ScopeBase.h"

namespace MLANG_Reflection
{

    // forward declarations
    class Member;
    class Scope;

    /**
     * @class Namespace Namespace.h MLANG/Reflection/Namespace.h
     * @author Stefan Roiser
     * @date 24/11/2003
     * @ingroup Ref
     */
    class Namespace : public ScopeBase {

    public:

      /** default constructor */
      Namespace( const char * scope );


      /** destructor */
      virtual ~Namespace() {}


      /**
       * fullName will return the fully qualified name of the namespace
       * @param  typedefexp expand typedefs or not
       * @return fully qualified name of namespace
       */
      MLANG_String fullName( bool typedefexp = false ) const;


      /**
       * function for initialisation of the global namespace
       */
      static void initGlobalNamespace();

    private:

      /** constructor for initialisation of the global namespace */
      Namespace();

    }; // class Namespace
} //namespace MLANG_Reflection


//-------------------------------------------------------------------------------
inline MLANG_String MLANG_Reflection::Namespace::fullName( bool typedefexp ) const {
//-------------------------------------------------------------------------------
  return ScopeBase::fullName( typedefexp );
}

#endif // MLANG_REFLECTION_NAMESPACE_H
