//$Id: NamespaceBuilder.cpp,v 1.3 2004/11/30 22:57:58 roiser Exp $

#include "Reflection/NamespaceBuilder.h"
#include "Reflection/Namespace.h"
#include "Reflection/PropertyList.h"
#include "Reflection/Scope.h"


//-------------------------------------------------------------------------------
MLANG_Reflection::NamespaceBuilder::NamespaceBuilder( const char * name ) {
//-------------------------------------------------------------------------------
  Scope scope = Scope::byName( name );
  if ( scope && scope.isNamespace() ) {
    m_namespace       = scope;
  }
  else {
    m_namespace       = (new Namespace( name ))->scope();
  }
}


//-------------------------------------------------------------------------------
MLANG_Reflection::NamespaceBuilder & 
MLANG_Reflection::NamespaceBuilder::addProperty( const char * key, 
                                             const char * value ) {
//-------------------------------------------------------------------------------
  m_namespace.propertyList().addProperty( key , value );
  return * this;
}


//-------------------------------------------------------------------------------
MLANG_Reflection::NamespaceBuilder & 
MLANG_Reflection::NamespaceBuilder::addProperty( const char * key, 
                                             Any value ) {
//-------------------------------------------------------------------------------
  m_namespace.propertyList().addProperty( key , value );
  return * this;
}
    
