//$Id: NamespaceBuilder.h,v 1.5 2004/11/30 22:57:58 roiser Exp $

#ifndef SEAL_REFLECT_NAMESPACEBUILDER_H
#define SEAL_REFLECT_NAMESPACEBUILDER_H

// Include files
#include "MLANG/Reflection/Scope.h"

namespace MLANG_Reflection
{

    /** 
     * @class NamespaceBuilder NamespaceBuilder.h MLANG/Reflection/NamespaceBuilder.h
     * @author Stefan Roiser
     * @ingroup RefBld
     * @date 30/3/2004
     */
    class NamespaceBuilder  {

    public:            

      /** constructor */
      NamespaceBuilder( const char * name );


      /** destructor */
      virtual ~NamespaceBuilder() {}

      /** addProperty will add a property 
       * @param  key the property key
       * @param  value the value of the property
       * @return a reference to the building class
       */
      NamespaceBuilder & addProperty( const char * key, Any value );
      NamespaceBuilder & addProperty( const char * key, const char * value );

    private:

      /** the namespace */
      Scope m_namespace;

    }; // class NamespaceBuilder

} // namespace MLANG_Reflection


#endif //SEAL_REFLECT_NAMESPACEBUILDER_H
