//$Id: Pointer.cpp,v 1.6 2004/11/30 22:57:58 roiser Exp $

#include "MLANG/Reflection/Pointer.h"


//-------------------------------------------------------------------------------
MLANG_Reflection::Pointer::Pointer( const Type &           pointerType,
                                const std::type_info & typeInfo )
//-------------------------------------------------------------------------------
  : TypeBase( buildTypeName(pointerType).c_str(), sizeof(void*), POINTER, typeInfo ), 
    m_pointerType( pointerType ) { }


//-------------------------------------------------------------------------------
MLANG_String MLANG_Reflection::Pointer::fullName( bool typedefexp ) const {
//-------------------------------------------------------------------------------
  MLANG_String s = "";
  if ( toType().isConst()) { s += "const "; }
  if ( toType().isVolatile()) { s += "volatile "; }
  return m_pointerType.fullName(typedefexp) + s + "*";
}


//-------------------------------------------------------------------------------
MLANG_String MLANG_Reflection::Pointer::buildTypeName( const Type & pointerType ) {
//-------------------------------------------------------------------------------
  return pointerType.name() + "*";
}
