//$Id: PointerToMember.h,v 1.4 2004/11/30 22:57:58 roiser Exp $

#ifndef SEAL_REFLECT_POINTERTOMEMBER_H
#define SEAL_REFLECT_POINTERTOMEMBER_H

// Include files
#include "MLANG/Reflection/TypeBase.h"
#include "MLANG/Reflection/Type.h"

namespace MLANG_Reflection
{

    // forward declarations

    /** 
     * @class PointerToMember PointerToMember.h MLANG/Reflection/PointerToMember.h
     * @author Stefan Roiser
     * @date   2004-01-28
     * @ingroup Ref
     */
    class PointerToMember : public TypeBase {

    public:

      /** default constructor */
      PointerToMember( const char *           type,
                       size_t                 size,
                       const std::type_info & typeInfo,
                       const Type &           pointerToMemberType ) ;


      /** destructor */
      virtual ~PointerToMember() {}


      /**
       * fullName will return the fully qualified name of the pointer type
       * @param  typedefexp expand typedefs or not
       * @return fully qualified name of pointer type
       */
      MLANG_String fullName( bool typedefexp = false ) const;


      /** pointerToMemberType will return a pointer to the Type the pointer to
       * member points to
       * @return pointer to Type of pointer to member
       */
      Type toType() const;

    private:

      /**
       * @link aggregation
       * @label pointer to member type
       * @supplierCardinality 1
       */
      Type m_pointerToMemberType;

    }; // class PointerToMember
} // namespace MLANG_Reflection

//-------------------------------------------------------------------------------
inline MLANG_Reflection::Type MLANG_Reflection::PointerToMember::toType() const {
//-------------------------------------------------------------------------------
  return m_pointerToMemberType;
}


#endif //SEAL_REFLECT_POINTERTOMEMBER_H

