//$Id: Scope.cpp,v 1.7 2004/11/30 22:57:58 roiser Exp $

#include "MLANG/Reflection/Scope.h"
#include "MLANG/Reflection/ScopeBase.h"
#include "MLANG/Reflection/Tools.h"
#include "MLANG/Reflection/Class.h"
#include "MLANG/Reflection/Member.h"
#include "MLANG/Reflection/Type.h"
#ifdef WIN32
#include "MLANG/HashMap.h"
#else /* !WIN32 */
#include "stl_hash.h"
#endif /* !WIN32 */

#if !defined (__ACE_INLINE__)
#include "MLANG/Reflection/Scope.i"
#endif /* __ACE_INLINE__ */

//-------------------------------------------------------------------------------
MLANG_Reflection::Scope::operator MLANG_Reflection::Class () const {
//-------------------------------------------------------------------------------
  if (! isClass()) throw RuntimeError("Type " + fullName() + " is not a Class");
  return * dynamic_cast<Class*>(m_scopeName->m_scopeBase);
}


//-------------------------------------------------------------------------------
MLANG_Reflection::Scope MLANG_Reflection::Scope::byName( const MLANG_String & name ) {
//-------------------------------------------------------------------------------
  return ScopeName::byName( name );
}


//-------------------------------------------------------------------------------
MLANG_Reflection::Member MLANG_Reflection::Scope::dataMember( size_t nth ) const {
//-------------------------------------------------------------------------------
  if ( * this ) return m_scopeName->m_scopeBase->dataMember( nth ); 
  return Member();
}


//-------------------------------------------------------------------------------
size_t MLANG_Reflection::Scope::dataMemberCount() const {
//-------------------------------------------------------------------------------
  if ( * this ) return m_scopeName->m_scopeBase->dataMemberCount(); 
  return 0;
}


//-------------------------------------------------------------------------------
MLANG_Reflection::Member MLANG_Reflection::Scope::functionMember( size_t nth ) const {
//------------------------------------------------------------------------------- 
  if ( * this ) return m_scopeName->m_scopeBase->functionMember(nth); 
  return Member();
}


//-------------------------------------------------------------------------------
size_t MLANG_Reflection::Scope::functionMemberCount() const {
//-------------------------------------------------------------------------------
  if ( * this ) return m_scopeName->m_scopeBase->functionMemberCount(); 
  return 0;
}


//-------------------------------------------------------------------------------
MLANG_Reflection::Member 
MLANG_Reflection::Scope::member( const MLANG_String & name ) const {
//-------------------------------------------------------------------------------
  if ( * this ) return m_scopeName->m_scopeBase->member(name); 
  return Member();
}


//-------------------------------------------------------------------------------
MLANG_Reflection::Member MLANG_Reflection::Scope::member( size_t nth ) const {
//-------------------------------------------------------------------------------
  if ( * this ) return m_scopeName->m_scopeBase->member(nth); 
  return Member();
}


//-------------------------------------------------------------------------------
MLANG_Reflection::Scope MLANG_Reflection::Scope::scope( size_t nth ) {
//-------------------------------------------------------------------------------
  return ScopeName::scope( nth );
}


//-------------------------------------------------------------------------------
size_t MLANG_Reflection::Scope::scopeCount() {
//-------------------------------------------------------------------------------
  return ScopeName::scopeCount();
}


//-------------------------------------------------------------------------------
MLANG_Reflection::Type MLANG_Reflection::Scope::subType( size_t nth ) const {
//-------------------------------------------------------------------------------
  if ( * this ) return m_scopeName->m_scopeBase->subType( nth ); 
  return Type();
}


//-------------------------------------------------------------------------------
size_t MLANG_Reflection::Scope::subTypeCount() const {
//-------------------------------------------------------------------------------
  if ( * this ) return m_scopeName->m_scopeBase->subTypeCount(); 
  return 0;
}


//-------------------------------------------------------------------------------
void MLANG_Reflection::Scope::addDataMember( const Member & dm ) {
//-------------------------------------------------------------------------------
  if ( * this) m_scopeName->m_scopeBase->addDataMember( dm );
}


//-------------------------------------------------------------------------------
void MLANG_Reflection::Scope::removeDataMember( const Member & dm ) {
//-------------------------------------------------------------------------------
  if ( * this) m_scopeName->m_scopeBase->removeDataMember( dm );
}


//-------------------------------------------------------------------------------
void MLANG_Reflection::Scope::addFunctionMember( const Member & fm ) {
//-------------------------------------------------------------------------------
  if ( * this) m_scopeName->m_scopeBase->addFunctionMember( fm );
}


//-------------------------------------------------------------------------------
void MLANG_Reflection::Scope::removeFunctionMember( const Member & fm ) {
//-------------------------------------------------------------------------------
  if ( * this) m_scopeName->m_scopeBase->removeFunctionMember( fm );
}


//-------------------------------------------------------------------------------
void MLANG_Reflection::Scope::addSubType( const Type & ty ) {
//-------------------------------------------------------------------------------
  if ( * this) m_scopeName->m_scopeBase->addSubType( ty );
}


//-------------------------------------------------------------------------------
void MLANG_Reflection::Scope::removeSubType( const Type & ty ) {
//-------------------------------------------------------------------------------
  if ( * this) m_scopeName->m_scopeBase->removeSubType( ty );
}


