//-------------------------------------------------------------------------------
ACE_INLINE bool MLANG_Reflection::operator < ( const Scope & lh, 
                                       const Scope & rh ) {
//-------------------------------------------------------------------------------
  return const_cast<Scope*>(&lh)->id() < const_cast<Scope*>(&rh)->id();
}


//-------------------------------------------------------------------------------
ACE_INLINE bool MLANG_Reflection::operator == ( const Scope & lh,
                                        const Scope & rh ) {
//-------------------------------------------------------------------------------
  return const_cast<Scope*>(&lh)->id() == const_cast<Scope*>(&rh)->id();
}


//-------------------------------------------------------------------------------
ACE_INLINE MLANG_Reflection::Scope::Scope( const ScopeName * scopeName ) 
//-------------------------------------------------------------------------------
  : m_scopeName( scopeName ) {}


//-------------------------------------------------------------------------------
ACE_INLINE MLANG_Reflection::Scope::Scope( const Scope & rh ) 
//-------------------------------------------------------------------------------
  : m_scopeName( rh.m_scopeName ) {}


//-------------------------------------------------------------------------------
ACE_INLINE MLANG_Reflection::Scope::~Scope() {
//-------------------------------------------------------------------------------
}


//-------------------------------------------------------------------------------
ACE_INLINE MLANG_Reflection::Scope::operator bool () const {
//-------------------------------------------------------------------------------
  if ( this->m_scopeName && this->m_scopeName->m_scopeBase ) return true;
  return false;
}


//-------------------------------------------------------------------------------
ACE_INLINE MLANG_Reflection::Scope MLANG_Reflection::Scope::declaringScope() const {
//-------------------------------------------------------------------------------
  if ( * this ) return m_scopeName->m_scopeBase->declaringScope(); 
  return Scope();
}


//-------------------------------------------------------------------------------
ACE_INLINE MLANG_String MLANG_Reflection::Scope::fullName( bool typedefexp ) const {
//-------------------------------------------------------------------------------
  if ( * this ) return m_scopeName->m_scopeBase->fullName( typedefexp ); 
  return m_scopeName->name();
}


//-------------------------------------------------------------------------------
ACE_INLINE void * MLANG_Reflection::Scope::id() const {
//-------------------------------------------------------------------------------
  return (void*)m_scopeName;
}


//-------------------------------------------------------------------------------
ACE_INLINE bool MLANG_Reflection::Scope::isClass() const {
//-------------------------------------------------------------------------------
  Scope s = * this;
  if ( * this ) return m_scopeName->m_scopeBase->isClass(); 
  return false;
}


//-------------------------------------------------------------------------------
ACE_INLINE bool MLANG_Reflection::Scope::isInstantiatedTemplateClass() const {
//-------------------------------------------------------------------------------
  if ( * this ) return m_scopeName->m_scopeBase->isInstantiatedTemplateClass(); 
  return false;
}


//-------------------------------------------------------------------------------
ACE_INLINE bool MLANG_Reflection::Scope::isNamespace() const {
//-------------------------------------------------------------------------------
  if ( * this ) return m_scopeName->m_scopeBase->isNamespace(); 
  return false;
}


//-------------------------------------------------------------------------------
ACE_INLINE bool MLANG_Reflection::Scope::isTopScope() const {
//-------------------------------------------------------------------------------
  if ( * this ) return m_scopeName->m_scopeBase->isTopScope(); 
  return false;
}


//-------------------------------------------------------------------------------
ACE_INLINE size_t MLANG_Reflection::Scope::memberCount() const {
//-------------------------------------------------------------------------------
  if ( * this ) return m_scopeName->m_scopeBase->memberCount(); 
  return 0;
}


//-------------------------------------------------------------------------------
ACE_INLINE const MLANG_String & MLANG_Reflection::Scope::name() const {
//-------------------------------------------------------------------------------
  return m_scopeName->name();
}


//-------------------------------------------------------------------------------
ACE_INLINE MLANG_Reflection::PropertyList & MLANG_Reflection::Scope::propertyList() const {
//-------------------------------------------------------------------------------
  if ( * this ) return m_scopeName->m_scopeBase->propertyList();
  return PropertyList::__NOPROPERTYLIST__;
}


//-------------------------------------------------------------------------------
ACE_INLINE MLANG_Reflection::TYPE MLANG_Reflection::Scope::scopeType() const {
//-------------------------------------------------------------------------------
  if ( * this ) return m_scopeName->m_scopeBase->scopeType(); 
  return UNRESOLVED;
}


//-------------------------------------------------------------------------------
ACE_INLINE MLANG_String MLANG_Reflection::Scope::scopeTypeAsString() const {
//-------------------------------------------------------------------------------
  if ( * this ) return m_scopeName->m_scopeBase->scopeTypeAsString(); 
  return "UNRESOLVED";
}


//-------------------------------------------------------------------------------
ACE_INLINE MLANG_Reflection::Scope MLANG_Reflection::Scope::subScope( size_t nth ) const {
//-------------------------------------------------------------------------------
  if ( * this ) return m_scopeName->m_scopeBase->subScope( nth ); 
  return Scope();
}


//-------------------------------------------------------------------------------
ACE_INLINE size_t MLANG_Reflection::Scope::subScopeCount() const {
//-------------------------------------------------------------------------------
  if ( * this ) return m_scopeName->m_scopeBase->subScopeCount(); 
  return 0;
}


//-------------------------------------------------------------------------------
ACE_INLINE void MLANG_Reflection::Scope::addSubScope( const Scope & sc ) {
//-------------------------------------------------------------------------------
  if ( * this) m_scopeName->m_scopeBase->addSubScope( sc );
}


//-------------------------------------------------------------------------------
ACE_INLINE void MLANG_Reflection::Scope::removeSubScope( const Scope & sc ) {
//-------------------------------------------------------------------------------
  if ( * this) m_scopeName->m_scopeBase->removeSubScope( sc );
}
