//$Id: ScopeName.cpp,v 1.1 2004/11/30 22:57:58 roiser Exp $

#include "MLANG/Reflection/Scope.h"
#include "MLANG/Reflection/ScopeBase.h"
#include "MLANG/Reflection/Tools.h"
#include "MLANG/Reflection/Kernel.h"
#ifdef WIN32
#include "MLANG/HashMap.h"
#else /* !WIN32 */
#include "stl_hash.h"
#endif /* !WIN32 */


//-------------------------------------------------------------------------------
#ifdef WIN32
typedef MLANG_HashMap < const char *, MLANG_Reflection::ScopeName * > Name2Scope;
#else /* !WIN32 */
typedef __gnu_cxx::hash_map < const char *, MLANG_Reflection::ScopeName * > Name2Scope;
#endif /* !WIN32 */
Name2Scope &  sScopes();


//-------------------------------------------------------------------------------
Name2Scope & sScopes() {
//-------------------------------------------------------------------------------
  static Name2Scope m;
  return m;
}


//-------------------------------------------------------------------------------
MLANG_Reflection::ScopeName::ScopeName( const char * name,
                                    ScopeBase * scopeBase ) 
//-------------------------------------------------------------------------------
  : m_name(name),
    m_scopeBase(scopeBase) {
  sScopes() [ m_name.c_str() ] = this;
}


//-------------------------------------------------------------------------------
MLANG_Reflection::ScopeName::~ScopeName() {
//-------------------------------------------------------------------------------
}


//-------------------------------------------------------------------------------
MLANG_Reflection::Scope MLANG_Reflection::ScopeName::byName( const MLANG_String & name ) {
//-------------------------------------------------------------------------------
  Name2Scope::iterator it = sScopes().find(name.c_str());
  if (it != sScopes().end() ) return Scope( it->second );
  else                        return Scope();
}


//-------------------------------------------------------------------------------
MLANG_Reflection::Scope MLANG_Reflection::ScopeName::scope() const {
//-------------------------------------------------------------------------------
  return Scope( this );
}


//-------------------------------------------------------------------------------
MLANG_Reflection::Scope MLANG_Reflection::ScopeName::scope( size_t nth ) {
//-------------------------------------------------------------------------------
  if (nth > sScopes().size()) { return Scope( 0 ); }
  typedef Name2Scope::iterator ScopeIter;
  size_t n = 0;
  for (ScopeIter sIter = sScopes().begin(); sIter != sScopes().end(); ++sIter) {
    if (n == nth) { return Scope( sIter->second ); }
    else { ++n; }
  }
  return Scope();
}


//-------------------------------------------------------------------------------
size_t MLANG_Reflection::ScopeName::scopeCount() {
//-------------------------------------------------------------------------------
  return sScopes().size();
}

