//$Id: TemplateFamily.cpp,v 1.3 2004/10/12 12:56:38 roiser Exp $

#include "Reflection/TemplateFamily.h"
#include "Reflection/InstantiatedTemplate.h"
#include "stl_hash.h"

//-------------------------------------------------------------------------------

typedef __gnu_cxx::hash_map < const char*, MLANG_Reflection::TemplateFamily*> Name2TFamily;
static Name2TFamily&  sTemplateFamilies();

//-------------------------------------------------------------------------------
const MLANG_Reflection::InstantiatedTemplate * 
MLANG_Reflection::TemplateFamily::byNameAndTypes( const MLANG_String & name,
                                               const std::vector < const Type * > templates ) {
//-------------------------------------------------------------------------------
  const TemplateFamily * tf = sTemplateFamilies()[ name.c_str() ];
  if ( tf ) {
    for ( size_t i = 0; i < tf->instantiationCount(); ++i ) {
      const InstantiatedTemplate * templated = tf->instantiation( i );
      size_t numTemplates  = templates.size();
      size_t numTemplateds = templated->templateArgumentCount();
      if ( numTemplateds < numTemplates ) { break; }
      for ( size_t j = 0; j < numTemplates; ++j ) {
        if ( templates[ j ] != templated->templateArgument( j )->templatedArgumentType() ) {
          break;
        }
      }
    }
  }
  return 0;
}


//-------------------------------------------------------------------------------
const MLANG_Reflection::TemplateFamily * 
MLANG_Reflection::TemplateFamily::byName( const MLANG_String & name ) {
//------------------------------------------------------------------------------- 
 return sTemplateFamilies()[ name.c_str() ];
}


//-------------------------------------------------------------------------------
Name2TFamily& sTemplateFamilies() {
//-------------------------------------------------------------------------------
  static Name2TFamily m;
  return m;
}


