//$Id: Tools.h,v 1.5 2004/11/30 22:57:58 roiser Exp $

#ifndef SEAL_REFLECT_TOOLS
#define SEAL_REFLECT_TOOLS

// Include files
#include "MLANG/String.h"
#include <vector>
#include <typeinfo>

namespace MLANG_Reflection
{

    // forward declarations
    class Function;
    class Type;

   namespace Tools {

      /**
       * demangle will call the internal demangling routines and
       * return the demangled string of a type 
       * @param ti the mangled type string
       * @return the demangled string
       */
      MLANG_String demangle( const std::type_info & ti );


      /**
       * stringSplit will return a vector of splitted strings
       * @param  splitValues returns the vector with splitted strings
       * @param  str the input string
       * @param  delim the delimiter on which to split 
       */
      void stringSplit(std::vector <MLANG_String> & splitValues,
                       const MLANG_String & str, 
                       const MLANG_String & delim = ",");


      /** 
       * stringSplitPair will return two values which are split
       * @param  val1 returns the first value
       * @param  val2 returns the second value
       * @param  str the string to be split
       * @param  delim the delimiter on which to split
       */
      void stringSplitPair(MLANG_String & val1,
                           MLANG_String & val2,
                           const MLANG_String & str,
                           const MLANG_String & delim = ",");


      /**
       * stringStrip will strip off empty spaces of a string
       * @param str a reference to a string to be stripped
       */
      void stringStrip(MLANG_String & str);

      MLANG_String buildTypeName( Type & t, 
                                 unsigned int modifiers );

   
    } // namespace Tools
} // namespace MLANG_Reflection

#endif // SEAL_REFLECT_TOOLS
