//$Id: Type.cpp,v 1.12 2004/11/30 22:57:58 roiser Exp $

#include "MLANG/Reflection/Type.h"
#include "MLANG/Reflection/Object.h"
#include "MLANG/Reflection/Scope.h"
#include "MLANG/Reflection/Enum.h"
#include "MLANG/Reflection/Union.h"
#include "MLANG/Reflection/Class.h"

//-------------------------------------------------------------------------------
MLANG_Reflection::Type::operator MLANG_Reflection::Class () const {
//-------------------------------------------------------------------------------
  if (isClass()) return * (dynamic_cast< Class * >(m_typeName->m_typeBase));
	throw RuntimeError("Type " + name() + " is not a Class");
	return Class("",0,typeid(void),0,UNRESOLVED);
}


//-------------------------------------------------------------------------------
MLANG_Reflection::Type
MLANG_Reflection::Type::byName( const MLANG_String & key ) {
//-------------------------------------------------------------------------------
  return TypeName::byName( key );
}


//-------------------------------------------------------------------------------
MLANG_Reflection::Type
MLANG_Reflection::Type::byTypeInfo( const std::type_info & tid ) {
//-------------------------------------------------------------------------------
  return TypeName::byTypeInfo( tid );
}


//-------------------------------------------------------------------------------
MLANG_Reflection::Object 
MLANG_Reflection::Type::construct( const Type & signature,
                               const std::vector < void * > & values, 
                               void * mem ) const {
//-------------------------------------------------------------------------------
  if ( * this ) return m_typeName->m_typeBase->construct( signature, 
                                                                values, 
                                                                mem ); 
  return Object();
}


//-------------------------------------------------------------------------------
MLANG_Reflection::EnumInfo MLANG_Reflection::Type::enumInfo( size_t nth ) const {
//-------------------------------------------------------------------------------
  if ( * this ) return m_typeName->m_typeBase->enumInfo( nth );
  return EnumInfo();
}


//-------------------------------------------------------------------------------
size_t MLANG_Reflection::Type::enumInfoCount() const {
//-------------------------------------------------------------------------------
  if ( * this ) return m_typeName->m_typeBase->enumInfoCount();
  return 0;
}


//-------------------------------------------------------------------------------
MLANG_Reflection::Scope MLANG_Reflection::Type::scope() const {
//-------------------------------------------------------------------------------
  if ( * this ) return m_typeName->m_typeBase->scope();
  return Scope();
}


//-------------------------------------------------------------------------------
MLANG_Reflection::Type MLANG_Reflection::Type::type( size_t nth ) {
//-------------------------------------------------------------------------------
  return TypeName::type( nth );
}


//-------------------------------------------------------------------------------
size_t MLANG_Reflection::Type::typeCount() {
//-------------------------------------------------------------------------------
  return TypeName::typeCount();
}


//-------------------------------------------------------------------------------
MLANG_Reflection::UnionInfo MLANG_Reflection::Type::unionInfo( size_t nth ) const {
//-------------------------------------------------------------------------------
  if ( * this ) return m_typeName->m_typeBase->unionInfo( nth );
  return UnionInfo();
}


//-------------------------------------------------------------------------------
size_t MLANG_Reflection::Type::unionInfoCount() const {
//-------------------------------------------------------------------------------
  if ( * this ) return m_typeName->m_typeBase->unionInfoCount();
  return 0;
}


