//$Id: Typedef.h,v 1.5 2004/11/30 22:57:58 roiser Exp $
#ifndef MLANG_REFLECTION_TYPEDEF_H
#define MLANG_REFLECTION_TYPEDEF_H

// Include files
#include "MLANG/Reflection/TypeBase.h"
#include "MLANG/Reflection/Type.h"

namespace MLANG_Reflection
{


    /**
     * @class Typedef Typedef.h MLANG/Reflection/Typedef.h
     * @author Stefan Roiser
     * @date 24/11/2003
     * @ingroup Ref
     */
    class Typedef : public TypeBase {

    public:

      /** constructor */
      Typedef( const char * type,
               const Type & typedefType,
               const std::type_info * typeinfo = 0 ) ;


      /** destructor */
      virtual ~Typedef();

      /**
       * fullName will return the fully qualified name of the Typedef
       * @param  typedefexp expand typedefs or not
       * @return fully expanded name of typedef
       */
      MLANG_String fullName( bool typedefexp = true ) const;

      /**
       * typedefType will return a pointer to the type of the typedef.
       * @return pointer to Type of member et. al.
       */
      Type toType() const;

    private:

      /**
       * pointer to the type of the typedef
       * @label typedef type
       * @link aggregation
       * @supplierCardinality 1
       */
      Type m_typedefType;

    }; // class Typedef
} //namespace MLANG_Reflection


//-------------------------------------------------------------------------------
inline MLANG_String MLANG_Reflection::Typedef::fullName( bool typedefexp ) const {
//-------------------------------------------------------------------------------
  if ( typedefexp ) { return m_typedefType.fullName( typedefexp ); }
  else { return name(); }
}


//-------------------------------------------------------------------------------
inline MLANG_Reflection::Type MLANG_Reflection::Typedef::toType() const {
//-------------------------------------------------------------------------------
  return m_typedefType;
}


#endif // MLANG_REFLECTION_TYPEDEF_H



