//$Id: TypedefBuilder.h,v 1.3 2004/11/30 22:57:58 roiser Exp $

#ifndef SEAL_REFLECT_TYPEDEFBUILDER_H
#define SEAL_REFLECT_TYPEDEFBUILDER_H

// Include files
#include "MLANG/Reflection/TypeBuilder.h"


namespace MLANG_Reflection
{

    /** 
     * @class TypedefBuilder TypedefBuilder.h MLANG/Reflection/TypedefBuilder.h
     * @author Stefan Roiser
     * @date 30/3/2004
     * @ingroup RefBld
     */
    template < typename T >
    class TypedefBuilder  {

    public:            

      /** constructor */
      TypedefBuilder(const char * name);


      /** addProperty will add a property 
       * @param  key the property key
       * @param  value the value of the property
       * @return a reference to the building class
       */
      TypedefBuilder & addProperty( const char * key, 
                                    Any value );
      TypedefBuilder & addProperty( const char * key, 
                                    const char * value );

      /** destructor */
      virtual ~TypedefBuilder() { }

    private:

      /** the type of the typedef */
      Typedef * m_typedef;

    }; // class TypedefBuilder

} // namespace MLANG_Reflection


//-------------------------------------------------------------------------------
template < typename T >
inline MLANG_Reflection::TypedefBuilder<T>::TypedefBuilder( const char * name ) {
//-------------------------------------------------------------------------------
  m_typedef = new Typedef( name, TypeDistiller<T>::get());
}


//-------------------------------------------------------------------------------
template < typename T >
inline MLANG_Reflection::TypedefBuilder<T> & 
MLANG_Reflection::TypedefBuilder<T>::addProperty( const char * key, 
                                              const char * value ) {
//-------------------------------------------------------------------------------
  m_typedef->propertyList().addProperty( key , value );
  return * this;
}


//-------------------------------------------------------------------------------
template < typename T >
inline MLANG_Reflection::TypedefBuilder<T> & 
MLANG_Reflection::TypedefBuilder<T>::addProperty( const char * key, 
                                              Any value ) {
//-------------------------------------------------------------------------------
  m_typedef->propertyList().addProperty( key , value );
  return * this;
}


#endif //SEAL_REFLECT_TYPEDEFBUILDER_H
