//$Id: Union.cpp,v 1.5 2004/11/30 22:57:59 roiser Exp $

#include "MLANG/Reflection/Union.h"
#include "MLANG/Reflection/Tools.h"

//-------------------------------------------------------------------------------
MLANG_Reflection::Union::Union(  const char * type,
                             size_t size,
                             const std::type_info & typeInfo,
                             const MLANG_String & unionInfos ) 
//-------------------------------------------------------------------------------
  : TypeBase( type, size, UNION, typeInfo ),
    m_unions( std::vector < UnionInfo * > () ) {

  std::vector < MLANG_String >::iterator uIter;
  std::vector < MLANG_String > unionInfoVec;
  Tools::stringSplit( unionInfoVec, unionInfos, ";" );

  for (uIter = unionInfoVec.begin(); uIter != unionInfoVec.end(); ++uIter) {

    Type uType = Type();
    MLANG_String uTypeStr = "";
    MLANG_String uNameStr = "";

    Tools::stringSplitPair( uTypeStr, uNameStr, *uIter );
    //fixme construct Type uType

    m_unions.push_back( new UnionInfo( uType, uNameStr ) );
  }

}


//-------------------------------------------------------------------------------
MLANG_Reflection::Union::~Union() {
//-------------------------------------------------------------------------------
  for (size_t i = 0; i < m_unions.size(); ++i) delete m_unions[ i ];
}


//-------------------------------------------------------------------------------
MLANG_String MLANG_Reflection::Union::fullName( bool typedefexp ) const {
//-------------------------------------------------------------------------------
  MLANG_String s = "union {";
  for ( size_t i = 0; i < m_unions.size(); ++i ) {
    s += m_unions[i]->type().fullName(typedefexp);
    s += " " + m_unions[i]->name() + "; ";
    if ( i != ( m_unions.size() - 1 ) ) { s += " "; }
  }
  s += "}";
  return s;
}
