//$Id: UnionBuilder.h,v 1.2 2004/08/03 12:24:38 mato Exp $

#ifndef SEAL_REFLECT_UNIONBUILDER_H
#define SEAL_REFLECT_UNIONBUILDER_H

// Include files
#include "MLANG/Reflection/TypeBuilder.h"


namespace MLANG_Reflection
{

    /** 
     * @class UnionBuilder UnionBuilder.h MLANG/Reflection/UnionBuilder.h
     * @author Stefan Roiser
     * @date 30/3/2004
     * @ingroup RefBld
     */
    template < class C >
    class UnionBuilder {

    public:    

      /** constructor */
      UnionBuilder(const char * name );

      
      /** destructor */
      virtual ~UnionBuilder();

      
      /** pushProperty will add a property to the property stack
       * which will be emtpied with the next call of a builder
       * class and attached to the item built with this call
       *
       * @param  key the property key
       * @param  value the value of the property
       * @return a reference to the building class
       */
      UnionBuilder & pushProperty(const char * key,
                                  const void * value);

    private:
 
      /** 
       * build will populate the Reflex with the information
       * about the union
       */
      void build() const;

    private:

      /** string containing the union information */
      const char * m_unionInfos;

    }; //class UnionBuilder
} // namespace MLANG_Reflection


#endif //SEAL_REFLECT_UNIONBUILDER_H
