#ifndef __MLANG_VECTOR_T_C_
#define __MLANG_VECTOR_T_C_

#include "MLANG/Vector_T.h"

using namespace MLANG;

#if !defined (__ACE_INLINE__)
#include "MLANG/Vector_T.i"
#endif /* __ACE_INLINE__ */

template <class T, size_t DEFAULT_SIZE>
Vector<T, DEFAULT_SIZE>::Vector (
   const T* t,
   const size_t init_size,
   ACE_Allocator* alloc
)
  : ACE_Vector<T, DEFAULT_SIZE> (init_size, alloc)

{
  for (size_t i=0; i<init_size; i++)
     push_back(t[i]);
}

template <class T, size_t DEFAULT_SIZE>
bool Vector<T, DEFAULT_SIZE>::removeElement(T t)

{
   // find element
   size_t i;
   for (i = 0; i < this->size() && (*this)[i]  != t; i++)
    {
       ;
    }
   if (i != this->size())
    {
      if (i == this->size() - 1)
       {
         this->resize (i, T());
       }
      else
       {
         (*this)[i] = T();
       }
      return true;
    }
   return false;
}

template <class T, size_t DEFAULT_SIZE>
void Vector<T, DEFAULT_SIZE>::ensureCapacity(size_t minIndex)

{
   if ((size_t)minIndex + 1 > this->size())
    {
      size_t n = 2 * this->size();
      if ((size_t)minIndex + 1 > n)
       {
         n = (size_t)minIndex + 1;
       }
      this->resize(n, T());
    }
}

template <class T, size_t DEFAULT_SIZE>
void Vector<T,DEFAULT_SIZE>::setElementAt (
   T t,
   size_t i
)

{
   (*this)[i] = t;
}

#endif /* __LANG_VECTOR_T_C_ */
