#ifndef __MPARSER_ASTNULLTYPE_H__
#define __MPARSER_ASTNULLTYPE_H__
#include "MParser/AST.h"

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/ASTNULLType.java#1 $
 */

/** There is only one instance of this class **/
class MParser_ASTNULLType : public MParser_AST

{
public:
   MParser_ASTNULLType ();

   virtual ~MParser_ASTNULLType ();

public:
   void addChild(const MParser_AST_var& c)
    {
    }

public:
   bool equals(const MParser_AST_var& t)
    {
        return false;
    }

public:
   bool equalsList(const MParser_AST_var& t)
    {
        return false;
    }

public:
   bool equalsListPartial(const MParser_AST_var& t)
    {
        return false;
    }

public:
   bool equalsTree(const MParser_AST_var& t)
    {
        return false;
    }

public:
   bool equalsTreePartial(const MParser_AST_var& t)
    {
        return false;
    }

public:
   ASTEnumeration findAll(const MParser_AST_var& tree)
    {
        return ASTEnumeration();
    }

public:
   ASTEnumeration findAllPartial(const MParser_AST_var& subtree)
    {
        return ASTEnumeration();
    }

public:
   MParser_AST_var getFirstChild()
    {
        return MParser_ASTNULLType::_duplicate(this);
    }

public:
   MParser_AST_var getNextSibling()
    {
        return MParser_ASTNULLType::_duplicate(this);
    }

public:
   MLANG_String getText() const
    {
        return "<ASTNULL>";
    }

public:
   int getType()
    {
        return MParser_Token::NULL_TREE_LOOKAHEAD;
    }

public:
   int getLine()
    {
        return 0;
    }

public:
   int getColumn()
    {
        return 0;
    }

public:
   int getNumberOfChildren()
    {
       return 0;
    }

public:
   void initialize(int t, const MLANG_String& txt)
    {
    }

public:
   void initialize(const MParser_AST_var& t)
    {
    }

public:
   void initialize(const MParser_Token_var& t)
    {
    }

public:
   void setFirstChild(const MParser_AST_var& c)
    {
    }

public:
   void setNextSibling(const MParser_AST_var& n)
    {
    }

public:
   void setText(const MLANG_String& text)
    {
    }

public:
   void setType(int ttype)
    {
    }

public:
   MLANG_String toString() const
    {
        return getText();
    }

public:
   MLANG_String toStringList() const
    {
        return getText();
    }

public:
   MLANG_String toStringTree() const
    {
        return getText();
    }
};

#endif /* __MPARSER_ASTNULLTYPE_H__ */
