/* MParser Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/ByteBuffer.java#1 $
 */

/**A Stream of characters fed to the lexer from a InputStream that can
 * be rewound via mark()/rewind() methods.
 * <p>
 * A dynamic array is used to buffer up all the input characters.  Normally,
 * "k" characters are stored in the buffer.  More characters may be stored during
 * guess mode (testing syntactic predicate), or when LT(i>k) is referenced.
 * Consumption of characters is deferred.  In other words, reading the next
 * character is not done by conume(), but deferred until needed by LA or LT.
 * <p>
 *
 * @see antlr.CharQueue
 */
// SAS: added this class to handle Binary input w/ FileInputStream

#ifndef __MParser_BYTEBUFFER_H__
#define __MParser_BYTEBUFFER_H__
#include "MIO/InputStream.h"
#include "MParser/InputBuffer.h"

class MParser_ByteBuffer : public MParser_InputBuffer
{
public:
    // char source
    MIO_InputStream_var _input;


    /** Create a character buffer */
    MParser_ByteBuffer(const MIO_InputStream_var& input);

    virtual ~MParser_ByteBuffer();

public:
  /** Ensure that the character buffer is sufficiently full */
   void fill(int amount);
};

#endif /* __MParser_BYTEBUFFER_H__ */
