#ifndef __MPARSER_CHARBUFFER_H__
#define __MPARSER_CHARBUFFER_H__
#include "MIO/Reader.h"
#include "MParser/InputBuffer.h"

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/CharBuffer.java#1 $
 */

/**A Stream of characters fed to the lexer from a InputStream that can
 * be rewound via mark()/rewind() methods.
 * <p>
 * A dynamic array is used to buffer up all the input characters.  Normally,
 * "k" characters are stored in the buffer.  More characters may be stored during
 * guess mode (testing syntactic predicate), or when LT(i>k) is referenced.
 * Consumption of characters is deferred.  In other words, reading the next
 * character is not done by conume(), but deferred until needed by LA or LT.
 * <p>
 *
 * @see antlr.CharQueue
 */

// SAS: Move most functionality into InputBuffer -- just the file-specific
//      stuff is in here

namespace MParser
{

class CharBuffer : public MParser_InputBuffer
{
protected:
    // char source
    MIO_Reader_var input_;

public:

    /** Create a character buffer */
    CharBuffer(const MIO_Reader_var& input);

    virtual ~CharBuffer();
public:
    /** Ensure that the character buffer is sufficiently full */
    void fill(int amount);
};
}

typedef MParser::CharBuffer MParser_CharBuffer;

#endif /* __MPARSER_CHARBUFFER_H__ */
