#ifndef __MPARSER_CHARFORMATTER_H__
#define __MPARSER_CHARFORMATTER_H__
#include "ace/Synch.h"
#include "MLANG/Refcountable.h"
#include "MLANG/SmartPtr.h"
#include "MLANG/String.h"

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/CharFormatter.java#1 $
 */

class MParser_CharFormatter;
typedef class MParser_CharFormatter *MParser_CharFormatter_ptr;

/** Interface used by BitSet to format elements of the set when
 * converting to string
 */
class MParser_CharFormatter : public MLANG_Refcountable<ACE_SYNCH_MUTEX>

{
public:
    MParser_CharFormatter() {}

    virtual ~MParser_CharFormatter();

public:

    virtual MLANG_String escapeChar(int c, bool forCharLiteral) const = 0;

    virtual MLANG_String escapeString(const MLANG_String& s) const = 0;

    virtual MLANG_String literalChar(int c) const = 0;

    virtual MLANG_String literalString(const MLANG_String& s) const = 0;

public:
   static bool is_nil (MParser_CharFormatter_ptr f)
   { return f == 0; }

   static MParser_CharFormatter_ptr _nil()
   { return 0; }

   static MParser_CharFormatter_ptr _duplicate(MParser_CharFormatter_ptr f)
   { return MLANG_acquire(f); }
};

typedef MLANG_SmartPtr<MParser_CharFormatter> MParser_CharFormatter_var;

#endif /* __MPARSER_CHARFORMATTER_H__ */
