#include "MParser/CommonAST.h"

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/CommonAST.java#1 $
 */


/** Common AST node implementation */

DEFINE_CLASS_INFO(MParser_CommonAST)

    /** Get the token text for this node */
MLANG_String MParser_CommonAST::getText() const

{
   return text_;
}

    /** Get the token type for this node */
int MParser_CommonAST::getType()

{
   return ttype_;
}

void MParser_CommonAST::initialize (
   int t,
   const MLANG_String& txt
)

{
   setType(t);
   setText(txt);
}

void MParser_CommonAST::initialize (
   const MParser_AST_var& t
)

{
    setText(t->getText());
    setType(t->getType());
}

MParser_CommonAST::MParser_CommonAST()
  : ttype_(MParser_Token::INVALID_TYPE)

{
}

MParser_CommonAST::MParser_CommonAST(const MParser_Token_var& tok)
  : ttype_(MParser_Token::INVALID_TYPE)

{
   initialize(tok);
}

void MParser_CommonAST::initialize (
   const MParser_Token_var& tok
)

{
   setText(tok->getText());
   setType(tok->getType());
}

    /** Set the token text for this node */
void MParser_CommonAST::setText (const MLANG_String& text)

{
   text_ = text;
}

    /** Set the token type for this node */
void MParser_CommonAST::setType(int ttype)

{
   ttype_ = ttype;
}

MParser_CommonAST::~MParser_CommonAST()

{
}
