#ifndef __MPARSER_COMMONAST_H__
#define __MPARSER_COMMONAST_H__
#include "MLANG/SmartPtr.h"
#include "MLANG/Class.h"
#include "MParser/AST.h"
#include "MParser/BaseAST.h"

class MParser_CommonAST;
typedef MParser_CommonAST *MParser_CommonAST_ptr;
typedef MLANG_SmartPtr<MParser_CommonAST> MParser_CommonAST_var;

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/CommonAST.java#1 $
 */

/** Common AST node implementation */
class MParser_CommonAST : public MParser_BaseAST

{
    int ttype_;
    MLANG_String text_;


    /** Get the token text for this node */
public:
   MLANG_String getText() const;

    /** Get the token type for this node */
public:
   int getType();

public:
   void initialize(int t, const MLANG_String& txt);

public:
   void initialize(const MParser_AST_var& t);

public:
   MParser_CommonAST();

   MParser_CommonAST(const MParser_Token_var& tok);

   virtual ~MParser_CommonAST();

public:
   DECLARE_CLASS_INFO();

   static bool is_nil (MParser_CommonAST_ptr ast)
   { return ast == 0; }

   static MParser_CommonAST_ptr _nil()
   { return 0; }

   static MParser_CommonAST_ptr _duplicate(MParser_CommonAST_ptr ast)
   { return MLANG_acquire(ast); }
public:
   void initialize(const MParser_Token_var& tok);

    /** Set the token text for this node */
public:
   void setText(const MLANG_String& text);

    /** Set the token type for this node */
public:
   void setType(int ttype);
};

#endif /* __MPARSER_COMMONAST_H__ */
