#ifndef __MPARSER_COMMONTOTKEN_H__
#define __MPARSER_COMMONTOTKEN_H__
#include "MLANG/String.h"
#include "MParser/Token.h"

class MParser_CommonToken;
typedef class MParser_CommonToken *MParser_CommonToken_ptr;
typedef MLANG_SmartPtr<MParser_CommonToken> MParser_CommonToken_var;

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/CommonToken.java#1 $
 */

class MParser_CommonToken : public MParser_Token

{
protected:
    // most tokens will want line and text information
    int line_;
    MLANG_String text_;
    int col_;

public:

    MParser_CommonToken(const MLANG_String& s = "");

    MParser_CommonToken(int t, const MLANG_String& txt);

    virtual ~MParser_CommonToken();

public:

   static bool is_nil (MParser_CommonToken_ptr a)
   { return a == 0; }

   static MParser_CommonToken_ptr _nil()
   { return 0; }

   static MParser_CommonToken_ptr _duplicate(MParser_CommonToken_ptr t)
   { return MLANG_acquire(t); }

public:
    DECLARE_CLASS_INFO();

    int getLine() const
    {
        return line_;
    }

    MLANG_String getText() const
    {
        return text_;
    }

    void setLine(int l) 
    {
        line_ = l;
    }

    void setText(const MLANG_String& s) 
    {
        text_ = s;
    }

    MLANG_String toString() const;

    /** Return token's start column */
    int getColumn() const
    {
        return col_;
    }

    void setColumn(int c) 
    {
        col_ = c;
    }
private:

    MParser_CommonToken(const MParser_CommonToken& );
    MParser_CommonToken& operator=(const MParser_CommonToken& );
    friend class __MParser_CommonToken_dict;
};

#endif /* __MPARSER_COMMONTOTKEN_H__ */
