#include "MLANG/StringBuffer.h"
#include "MParser/DefaultFileLineFormatter.h"

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/DefaultFileLineFormatter.java#1 $
 */

MParser_DefaultFileLineFormatter::MParser_DefaultFileLineFormatter ()

{
}

MLANG_String MParser_DefaultFileLineFormatter::getFormatString (
   const MLANG_String& fileName,
   int line,
   int column)

{
   MLANG_StringBuffer buf;

   if (fileName.length())
    {
      buf.append(fileName);
      buf.append(":");
    }

   if (line != -1)
    {
      if (fileName.length())
         buf.append("line ");

      buf.append(MLANG_String::valueOf(line));

      if (column != -1)
       {
         buf.append(":");
         buf.append(MLANG_String::valueOf(column));
       }

      buf.append(":");
    }

   buf.append(" ");

   return buf.toString();
}

MParser_DefaultFileLineFormatter::~MParser_DefaultFileLineFormatter ()

{
}
