#ifndef __MPARSER_EXCEPTION_H__
#define __MPARSER_EXCEPTION_H__
#include "ace/SString.h"
#include "MLANG/Exception.h"
#include "MParser/Export.h"

namespace MParser
{

class Exception;
typedef class Exception *Exception_ptr;
typedef class Exception *Exception_var;

class MPARSER_Export Exception : public MLANG_Exception
{
public:
    Exception(const char *s = "");
    virtual ~Exception(); 
public:
    virtual MLANG_String toString() const
    { return message_; }
    virtual MLANG_String getMessage() const
    { return toString(); }
protected:
    MLANG_String message_; 
};
};

typedef MParser::Exception MParser_Exception;
typedef MParser_Exception *MParser_Exception_ptr;
typedef MParser_Exception *MParser_Exception_var;

#endif /* __MPARSER_EXCEPTION_H__ */
