#ifndef __MPARSER_FILELINEFORMATTER_H__
#define __MPARSER_FILELINEFORMATTER_H__
#include "MLANG/String.h"

class MIO_FileLineFormatter;
typedef class MIO_FileLineFormatter *MIO_FileLineFormatter_ptr;

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/FileLineFormatter.java#1 $
 */

class MIO_FileLineFormatter

{
protected:
    MIO_FileLineFormatter();
public:
    virtual ~MIO_FileLineFormatter();

private:
    static MIO_FileLineFormatter_ptr formatter_;

public:

    static MIO_FileLineFormatter_ptr getFormatter();

public:

    static void setFormatter(MIO_FileLineFormatter_ptr f);

    /** @param fileName the file that should appear in the prefix. (or null)
     * @param line the line (or -1)
     * @param column the column (or -1)
     */
    virtual MLANG_String getFormatString (
       const MLANG_String& fileName,
       int line,
       int column
     ) = 0;
};

#endif /* __MPARSER_FILELINEFORMATTER_H__ */
