#ifndef __MPARSER_LLKPARSER_H__
#define __MPARSER_LLKPARSER_H__
#include "MLANG/SmartPtr.h"
#include "MLANG/String.h"
#include "MParser/Token.h"
#include "MParser/TokenStream.h"
#include "MParser/TokenBuffer.h"
#include "MParser/ParserSharedInputState.h"
#include "MParser/Parser.h"

class MParser_LLkParser;
typedef class MParser_LLkParser *MParser_LLkParser_ptr;

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/LLkParser.java#1 $
 */

/**An LL(k) parser.
 *
 * @see antlr.Token
 * @see antlr.TokenBuffer
 */

class MParser_LLkParser : public MParser_Parser

{
public:
    typedef MParser_Parser super;
protected:
    int k_;
public:
    MParser_LLkParser(int k);

    MParser_LLkParser(const MParser_ParserSharedInputState_var& state, int k);

    MParser_LLkParser(const MParser_TokenBuffer_var& tokenBuf, int k);

    MParser_LLkParser(const MParser_TokenStream_var& lexer, int k);

    virtual ~MParser_LLkParser();

public:

   static bool is_nil (MParser_LLkParser_ptr parser)
   { return parser == 0; }

   static MParser_LLkParser_ptr _nil()
   { return 0; }

   static MParser_LLkParser_ptr _duplicate(MParser_LLkParser_ptr parser)
   { return MLANG_acquire(parser); }

public:

    int k() const
    { return k_; }

    MParser_LLkParser& k(int new_k)
    { k_ = new_k; return *this; }

public:

    /**Consume another token from the input stream.  Can only write sequentially!
     * If you need 3 tokens ahead, you must consume() 3 times.
     * <p>
     * Note that it is possible to overwrite tokens that have not been matched.
     * For example, calling consume() 3 times when k=2, means that the first token
     * consumed will be overwritten with the 3rd.
     */
    void consume();

    int LA(int i);

    MParser_Token_var LT(int i);

public:

    void trace (const MLANG_String& ee, const MLANG_String& rname);

    void traceIn(const MLANG_String& rname);

    void traceOut(const MLANG_String& rname);
};

typedef MLANG_SmartPtr<MParser_LLkParser> MParser_LLkParser_var;

#endif /* __MPARSER_LLKPARSER_H__ */
