#include "MParser/ByteBuffer.h"
#include "MParser/CharBuffer.h"
#include "MParser/LexerSharedInputState.h"

using namespace MParser;

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/LexerSharedInputState.java#1 $
 */

/** This object contains the data associated with an
 *  input stream of characters.  Multiple lexers
 *  share a single LexerSharedInputState to lex
 *  the same input stream.
 */

LexerSharedInputState::LexerSharedInputState (
   const MParser_InputBuffer_var& inbuf
)
  : column(1),
    line(1),
    tokenStartColumn(1),
    tokenStartLine(1),
    input(inbuf),
    guessing(0)
{
}

LexerSharedInputState::LexerSharedInputState (
   const MIO_InputStream_var& in
)
 :  column(1),
    line(1),
    tokenStartColumn(1),
    tokenStartLine(1),
    input(new MParser_ByteBuffer(in)),
    guessing(0)

{
}

LexerSharedInputState::LexerSharedInputState (
   const MIO_Reader_var& in
)
 :  column(1),
    line(1),
    tokenStartColumn(1),
    tokenStartLine(1),
    input(new MParser_CharBuffer(in)),
    guessing(0)

{
}

void LexerSharedInputState::reset()

{
   column = 1;
   line = 1;
   tokenStartColumn = 1;
   tokenStartLine = 1;
   guessing = 0;
   filename.clear();
   input->reset();
}

LexerSharedInputState::~LexerSharedInputState()

{
}
