#ifndef __MPARSER_LEXERSHAREDINPUTSTATE_H__
#define __MPARSER_LEXERSHAREDINPUTSTATE_H__
#include "MLANG/SmartPtr.h"
#include "MLANG/String.h"
#include "MLANG/Object.h"
#include "MIO/Reader.h"
#include "MIO/InputStream.h"
#include "MParser/InputBuffer.h"

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/LexerSharedInputState.java#1 $
 */


namespace MParser
{

class LexerSharedInputState;
typedef class LexerSharedInputState *LexerSharedInputState_ptr;
typedef MLANG_SmartPtr<LexerSharedInputState> LexerSharedInputState_var;

/** This object contains the data associated with an
 *  input stream of characters.  Multiple lexers
 *  share a single LexerSharedInputState to lex
 *  the same input stream.
 */
class LexerSharedInputState : public MLANG_Object

{
public:
    int column;
    int line;
    int tokenStartColumn ;
    int tokenStartLine;
    MParser_InputBuffer_var input;

    /** What file (if known) caused the problem? */
    MLANG_String filename;

    int guessing;

public:

    LexerSharedInputState();

    LexerSharedInputState(const MParser_InputBuffer_var& inbuf);

    LexerSharedInputState(const MIO_InputStream_var& in);

    LexerSharedInputState(const MIO_Reader_var& in);

    virtual ~LexerSharedInputState();

public:

   static bool is_nil (LexerSharedInputState_ptr state)
   { return state == 0; }

   static LexerSharedInputState_ptr _nil()
   { return 0; }

   static LexerSharedInputState_ptr _duplicate(LexerSharedInputState_ptr state)
   { return MLANG_acquire(state); }

public:

    void reset();
};
}

typedef MParser::LexerSharedInputState MParser_LexerSharedInputState;
typedef MParser_LexerSharedInputState *MParser_LexerSharedInputState_ptr;
typedef MLANG_SmartPtr<MParser_LexerSharedInputState> MParser_LexerSharedInputState_var;

#endif /* __MPARSER_LEXERSHAREDINPUTSTATE_H__ */
