#ifndef __MPARSER_NOVIABLEALTEXCEPTION_H__
#define __MPARSER_NOVIABLEALTEXCEPTION_H__
#include "MLANG/String.h"
#include "MParser/Export.h"
#include "MParser/RecognitionException.h"
#include "MParser/Token.h"
#include "MParser/AST.h"

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/NoViableAltException.java#1 $
 */

namespace MParser
{

class MPARSER_Export NoViableAltException : public MParser_RecognitionException
{
public:
   typedef MParser_RecognitionException super;
public:
   MParser_Token_var token_;
   MParser_AST_var node_;	// handles parsing and treeparsing

public:
   NoViableAltException (
      MParser_AST_ptr t
    );

   NoViableAltException (
      MParser_Token_ptr t,
      const MLANG_String& fileName
    );

   virtual ~NoViableAltException ();

public:
   /**
    * Returns a clean error message (no line number/column information)
    */
   MLANG_String getMessage() const;
};
}

typedef MParser::NoViableAltException MParser_NoViableAltException;

#endif /* __MPARSER_NOVIABLEALTEXCEPTION_H__ */
