#include "MParser/NoViableAltForCharException.h"

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/NoViableAltForCharException.java#2 $
 */

MParser_NoViableAltForCharException::MParser_NoViableAltForCharException (
   char c,
   MParser_CharScanner_ptr scanner
) : super("NoViableAlt", scanner->getFilename().c_str(),
         scanner->getLine(), scanner->getColumn()),
   foundChar_(c)

{
}

MParser_NoViableAltForCharException::MParser_NoViableAltForCharException (
   char c, 
   const MLANG_String& fileName, 
   int line, 
   int column
) : super("NoViableAlt", fileName.c_str(), line, column),
    foundChar_(c)

{
}

/**
 * Returns a clean error message (no line number/column information)
 */
MLANG_String MParser_NoViableAltForCharException::getMessage() const

{
   MLANG_String mesg = "unexpected char: ";

   // I'm trying to mirror a change in the C++ stuff.
   // But java seems to lack something convenient isprint-ish..
   // actually we're kludging around unicode and non unicode savy
   // output stuff like most terms.. Basically one would want to
   // be able to tweak the generation of this message.

   if ((foundChar_ >= ' ') && (foundChar_ <= '~'))
    {
      mesg += '\'';
      mesg += foundChar_;
      mesg += '\'';
    }
   else
    {
    #if 0
      mesg += "0x"+Integer.toHexString((int)foundChar).toUpperCase();
      #else
      assert(0);
      #endif
    }
   return mesg;
}

MParser_NoViableAltForCharException::~MParser_NoViableAltForCharException ()

{
}
