#ifndef __MPARSER_NOVIABLEALTFORCHAREXCEPTION_H__
#define __MPARSER_NOVIABLEALTFORCHAREXCEPTION_H__
#include "MLANG/String.h"
#include "MParser/RecognitionException.h"
#include "MParser/CharScanner.h"

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/NoViableAltForCharException.java#2 $
 */

class MParser_NoViableAltForCharException : public MParser_RecognitionException

{
public:
    typedef MParser_RecognitionException super;
public:
    char foundChar_;

    MParser_NoViableAltForCharException (
       char c,
       MParser_CharScanner_ptr scanner
      );

    MParser_NoViableAltForCharException (
      char c, 
      const MLANG_String& fileName,
      int line,
      int column = -1
    );

    virtual ~MParser_NoViableAltForCharException ();

public:
   /**
    * Returns a clean error message (no line number/column information)
    */
   MLANG_String getMessage() const;
};

#endif /* __MPARSER_NOVIABLEALTFORCHAREXCEPTION_H__ */
