#include "MParser/FileLineFormatter.h"
#include "MParser/RecognitionException.h"

using namespace MParser;

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/RecognitionException.java#1 $
 */


/**
 * RecognitionException constructor comment.
 * @param s java.lang.String
 */
RecognitionException::RecognitionException (
   const char* s, 
   const char* fileName,
   int line,
   int column
) : MParser_Exception(s),
    fileName_(fileName),
    line_(line),
    column_(column)

{
}

MLANG_String RecognitionException::toString() const

{
   return MLANG_String(MIO_FileLineFormatter::getFormatter()->
       getFormatString(fileName_.c_str(), line_, column_) + 
       MLANG_String(getMessage().c_str()));
}

RecognitionException::~RecognitionException()

{
}
