#ifndef __MPARSER_RECOGNITIONEXCEPTION_H__
#define __MPARSER_RECOGNITIONEXCEPTION_H__
#include "MLANG/String.h"
#include "MParser/Export.h"
#include "MParser/Exception.h"

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/RecognitionException.java#1 $
 */

namespace MParser
{

class MPARSER_Export RecognitionException : public MParser_Exception

{
protected:
    MLANG_String fileName_;		// not used by treeparsers
    int line_;
    int column_;

public:

    RecognitionException (
       const char *s = "", 
       const char *fileName = "",
       int line = -1,
       int column = -1
     );

    virtual ~RecognitionException ();   

public:
 
    const char* getFilename() const
    { return fileName_.c_str(); }

    int getLine() const
    { return line_; }

    int getColumn() const
    { return column_; }

    /** @deprecated As of ANTLR 2.7.0 */
    MLANG_String getErrorMessage() const
    {
        return getMessage();
    }

    MLANG_String toString() const;
};
}

typedef MParser::RecognitionException MParser_RecognitionException;

#endif /* __MPARSER_RECOGNITIONEXCEPTION_H__ */
