#ifndef __MPARSER_STRINGUTILS_H__
#define __MPARSER_STRINGUTILS_H__
#include "MLANG/String.h"

class MParser_StringUtils

{
public:
   /** General-purpose utility function for removing
   * characters from back of string
* @param s The string to process
     * @param c The character to remove
     * @return The resulting string
     */
   static MLANG_String stripBack (const MLANG_String& s, char c);

    /** General-purpose utility function for removing
     * characters from back of string
     * @param s The string to process
     * @param remove A string containing the set of characters to remove
     * @return The resulting string
     */
    static MLANG_String stripBack (
       const MLANG_String& s,
       const MLANG_String& remove
     );

    /** General-purpose utility function for removing
     * characters from front of string
     * @param s The string to process
     * @param c The character to remove
     * @return The resulting string
     */
    static MLANG_String stripFront (
       const MLANG_String& s,
       char c
     );

    /** General-purpose utility function for removing
     * characters from front of string
     * @param s The string to process
     * @param remove A string containing the set of characters to remove
     * @return The resulting string
     */
    static MLANG_String stripFront (
       const MLANG_String& s, 
       const MLANG_String& remove
     );

    /** General-purpose utility function for removing
     * characters from the front and back of string
     * @param s The string to process
     * @param head exact string to strip from head
     * @param tail exact string to strip from tail
     * @return The resulting string
     */
    static MLANG_String stripFrontBack (
       const MLANG_String& src,
       const MLANG_String& head,
       const MLANG_String& tail
     );
};

#endif /* __MPARSER_STRINGUTILS_H__ */
