#include "MIO/FileInputStream.h"
#include "MIO/FileOutputStream.h"
#include "MIO/PrintStream.h"
#include "MParser/System.h"

MParser_System::MParser_System()
  : in_(new MIO_FileInputStream(ACE_STDIN)),
    out_(new MIO_PrintStream(new MIO_FileOutputStream(ACE_STDOUT))),
    err_(new MIO_PrintStream(new MIO_FileOutputStream(ACE_STDERR)))

{
   properties_.put ("file.separator", ACE_DIRECTORY_SEPARATOR_STR);
   properties_.put ("line.separator", "\n");
}

void MParser_System::exit (int code)

{
   ACE_OS::exit(code);
}

MLANG_String MParser_System::getProperty (
   const MLANG_String& name
)

{
   return properties_.get(name);
}

MParser_System::~MParser_System()

{
}
