#ifndef __MPARSER_SYSTEM_H__
#define __MPARSER_SYSTEM_H__
#include "ace/Synch.h"
#include "ace/Singleton.h"
#include "MLANG/HashMap.h"
#include "MIO/InputStream.h"
#include "MIO/PrintStream.h"

class MParser_System
{
public:
   MParser_System();
   ~MParser_System();
public:
   const MIO_InputStream_var& in() const
   { return in_; }
   const MIO_PrintStream_var& out() const
   { return out_; }
   const MIO_PrintStream_var& err() const
   { return err_; }
   MLANG_String getProperty(const MLANG_String& propname);
   void exit(int code);
protected:
   MIO_InputStream_var in_;
   MIO_PrintStream_var out_;
   MIO_PrintStream_var err_;
   typedef MLANG_HashMap<MLANG_String, MLANG_String> PROPERTIES; 
   PROPERTIES properties_;
};

#define SYSTEM ACE_Singleton<MParser_System, ACE_SYNCH_MUTEX>::instance()

#endif /* __MPARSER_SYSTEM_H__ */
