#include "MParser/Token.h"

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/Token.java#1 $
 */

/** A token is minimally a token type.  Subclasses can add the text matched
 *  for the token and line info.
 */

using namespace MParser;

DEFINE_CLASS_INFO(Token)

    // the illegal token object
Token_ptr Token::badToken_ = 
    new Token(Token::INVALID_TYPE, "<no text>");

Token::Token()
   : type_(INVALID_TYPE)

{
}

Token::Token(int t)
   : type_(t)

{
}

Token::Token (
   int t,
   const MLANG_String& 
) : type_(t)

{
}

int Token::getColumn() const

{
   return 0;
}

int Token::getLine() const

{
   return 0;
}

MLANG_String Token::getFilename()

{
   return "";
}

void Token::setFilename(const MLANG_String&)

{
}

MLANG_String Token::getText() const

{
   return "<no text>";
}

void Token::setText(const MLANG_String& )

{
}

void Token::setColumn(int )

{
}

void Token::setLine(int )

{
}

int Token::getType() const

{
    return type_;
}

void Token::setType(int t)

{
   type_ = t;
}

MLANG_String Token::toString() const

{
   MLANG_String to = "[\"";
   to += getText();
   to += "\",<";
   to +=MLANG_String::valueOf(type_);
   to += ">]";
   return to;
}

Token::~Token()

{
}
