#ifndef __MPARSER_TOKENSTREAM_H__
#define __MPARSER_TOKENSTREAM_H__
#include "MLANG/Object.h"
#include "MLANG/SmartPtr.h"
#include "MParser/Token.h"

class MParser_TokenStream;
typedef class MParser_TokenStream *MParser_TokenStream_ptr;

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/TokenStream.java#1 $
 */

class MParser_TokenStream : public MLANG_Object

{
protected:
   MParser_TokenStream ();
public:
   virtual ~MParser_TokenStream();   
public:
    virtual MParser_Token_var nextToken() = 0;
//       throws TokenStreamException;

public:

   static bool is_nil (MParser_TokenStream_ptr stream)
   { return stream == 0; }

   static MParser_TokenStream_ptr _nil()
   { return 0; }

   static MParser_TokenStream_ptr _duplicate(MParser_TokenStream_ptr stream)
   { return MLANG_acquire(stream); }

};

typedef MLANG_SmartPtr<MParser_TokenStream> MParser_TokenStream_var;

#endif /* __MPARSER_TOKENSTREAM_H__ */
