#include "mbase/config.h"
#include "mbase/debug.h"
#include "mbase/byutils.h"

#undef byleng

int mbyleng (
   const char* s,
   int maxlen
)

{
   register const char* p;
   for (p = &s[maxlen]; p>s && p[-1]==' '; p--);
   return p - s;
}

void mldchar (
   const char* from,
   int len,
   char* to
)

{
    len = mbyleng(from, len);
    bycopy(from, to, len);
    to[len] = '\0';
}

#undef bycmpr

#ifndef mbycmpr
int mbycmpr (
  const char* p,
  const char* q,
  int len
)

{
   return memcmp(p, q, len);
}
#endif /* mbycmpr */

#undef bycopy

#ifndef mbycopy
void mbycopy (
  const char* src,
  char* dest,
  int len
)

{
   memcpy(dest, src, len);
}
#endif /* !mbycopy */

#undef byfill

#ifndef mbyfill
void mbyfill (
   char* to,
   int len,
   int c
)

{
   memset(to, c, len);
}
#endif /* mbyfill */

void mstchar (
   const char* from,
   char* to,
   int len
)

{
   if (from!=0)
    {
      while (len-->0)
       {
         *to++ = (*from!='\0') ? *from++ : ' ';
       }
    }
   else
    {
      mbyfill(to, len, ' ');
    }
}

#undef stcopy

#ifndef mstcopy
char* mstcopy (
   const char* from,
   char* to
)

{
   return strcpy(to, from);
}
#endif /* mstcopy */

#undef stleng

#ifndef mstleng
int mstleng (
  const char* s
)

{
   return strlen(s);
}
#endif /* mstleng */

#undef stcmpr

#ifndef mstcmpr
int mstcmpr (
   const char* p,
   const char* q
)

{
   return strcmp(p, q);
}
#endif /* mstcmpr */

#undef stcat

#ifndef mstcat
char* mstcat (
   const char* from,
   char* to
)

{
   return strcat(to, from);
}
#endif /* mstcat */

void mrdownshift (
   char* s
)

{
   for ( ;*s!='\0'; s++)
     if (isupper(*s))
        *s = tolower(*s);
}

void mrupshift (
   char* s
)

{
   for ( ;*s!='\0'; s++)
     if (islower(*s))
        *s = toupper(*s);
}

int mcharcmp (
   const char* s1,
   int l1,
   const char* s2,
   int l2
)

{
   int result;
   int len;
   int swap;
   register const char* p;

   /* Encuentra cual es la cadena mas corta.
    */
   swap = (l1<l2) ? 1 : 0;
   /* Realiza una comparacion incluyendo hasta la cadena mas corta.
    */
   DPRINTF(("charcmp(%s,%d,%s,%d)=", s1, l1, s2, l2));
   result = mbycmpr(s1, s2, (swap) ? l1 : l2);
   if (l1==l2 || result!=0)
    {
      DPRINTF(("%d\n", result));
      return result;
    }

   len = (swap) ? (l2 - l1) : (l1 - l2);
   for (p = (swap) ? (s2 + l1) : (s1 + l2);
        *p==' ';
        p++)
    {
      if (--len==0)
       {
         DPRINTF(("0\n"));
         return 0;
       }
    }
   result = *p!='\0' ? (*p - ' ') : 0;
   DPRINTF(("%d\n", result));
   return swap ? (- result) : result;
}

#if defined(_MSC_VER)
int strcasecmp (
	const char *s1,
	const char *s2
)

{
	while (*s1!='\0' && *s2!='\0' && toupper(*s1)==toupper(*s2))
	{
		s1++; s2++;
	}
	return toupper(*s1) - toupper(*s2);
}

int strncasecmp (
	const char *s1,
	const char *s2,
	int n
)

{
	int i;
	for (i=0; i<n && *s1!='\0' && *s2!='\0' && toupper(*s1)==toupper(*s2); i++)
	{
		s1++; s2++;
	}
	return toupper(*s1) - toupper(*s2);
}
#endif /* _MSC_VER */
