#ifndef __MBASE_BYLENG_H__
#define __MBASE_BYLENG_H__
#include <memory.h>
#include <string.h>
#include "mbase/config.h"

EXTERN_C MExport 
int mbyleng (
   const char* s,
   int maxlen
);

EXTERN_C MExport 
void mldchar (
   const char* from,
   int len,
   char* to
);

EXTERN_C MExport 
void mstchar (
   const char* from,
   char* to,
   int len
);

EXTERN_C MExport 
int mcharcmp (
   const char* s1,
   int l1,
   const char* s2,
   int l2
);

EXTERN_C MExport 
void mrdownshift (
  char* s
);

EXTERN_C MExport 
void mrupshift (
  char* s
);

#define mbycopy(from, to, len) memcpy(to, from, len)
#define mbycmpr(from, to, len) memcmp(from, to, len)
#define mbyfill(s,len,c) memset(s,c,len)

#define mstcopy(from, to) strcpy(to, from)
#define mstcat(from, to) strcat(to, from)
#define mstleng(s) strlen(s)
#define mstcmpr(s1, s2) strcmp(s1, s2)

#if defined(_MSC_VER)
EXTERN_C MExport
int strcasecmp (const char *s1, const char *s2);

EXTERN_C MExport
int strncasecmp (
	const char *s1,
	const char *s2,
	int n
);
#endif /* _MSC_VER */

#if !defined(NO_INFORMIX_MAP)
#define byleng mbyleng
#define ldchar mldchar
#define stchar mstchar
#define charcmp mcharcmp
#define rdownshift mrdownshift
#define rupshift mrupshift
#define bycopy(from, to, len) memcpy(to, from, len)
#define bycmpr(from, to, len) memcmp(to, from, len)
#define byfill(s,len,c) memset(s,c,len)
#define stcopy(from, to) strcpy(to, from)
#define stcat(from, to) strcat(to, from)
#define stleng(s) strlen(s)
#define stcmpr(s1, s2) strcmp(s1, s2)
#endif /* NO_INFORMIX_MAP */

#endif /* __MBASE_BYLENG_H__ */
