#if !defined(__MBASE_CONFIG_H__)
#define	__MBASE_CONFIG_H__
#define	__LIBDEF_H__
#ifdef __cplusplus
#if defined(WIN32) && defined(_STLP_NEW_PLATFORM_SDK)
#include <basetsd.h>
#endif /* WIN32 && _STLP_NEW_PLATFORM_SDK */
#include "ace/config-all.h"
#endif
#include <ctype.h>
#include <stdarg.h>
#include <assert.h>
#include <stdio.h>
#ifdef __linux__
#include <values.h>
#endif /* __linux__ */

/* En el entorno Visual Studio define pero sin el prefijo
 */
#ifdef _MSC_VER
#define popen _popen
#define pclose _pclose
#endif /* _MSC_VER */

#ifdef WIN32
#include <windows.h>
#if defined (__MINGW32__)
#include <getopt.h>
#endif /* __MINGW32__ */
#endif /* WIN32 */
#include <stdlib.h>
#include <stddef.h>

#ifndef _MAX_PATH
#define	_MAX_PATH 64
#endif

#ifndef NULL
#define	NULL (0)
#endif

#ifndef FALSE
#define	FALSE	0
#endif
#ifndef TRUE
#define	TRUE	1
#endif

#if defined(__linux__) || defined(_M_UNIX)
#define	SYS5
#endif

#if __cplusplus && !defined(ANSI)
#define ANSI
#endif

#if defined(__GNUC__) && !defined(ANSI)
#define ANSI
#endif

#ifndef EXTERN_C
#if __cplusplus
#define	EXTERN_C extern "C"
#else
#define	EXTERN_C
#endif
#endif

#define	dim(s) (sizeof(s)/sizeof((s)[0]))
#define cnew(s)	((s *) malloc(sizeof(s)))
#define cnewa(n,s) ((s *) malloc((n)*sizeof(s)))

#if defined(AIX) || defined(UnixWare) || defined(HPUX)
#include <sys/param.h>
#else /* !AIX */
#ifndef lobyte
#define	lobyte(X)	(((unsigned char *)&X)[0])
#define	hibyte(X)	(((unsigned char *)&X)[1])
#define	loword(X)	(((unsigned short *)&X)[0])
#define	hiword(X)	(((unsigned short *)&X)[1])
#endif /* lobyte */
#endif /* !AIX */

#ifndef WIN32
#define	far
#define	FAR
#define	NEAR
#define	PASCAL
#define	CDECL
#define	__export
#define	__stdcall
#define	__cdecl
#define	__huge
#endif /* !WIN32 */

typedef void *Pointer;

#ifndef MACRO_BEGIN

#define MACRO_BEGIN     do {

#ifndef lint
#define MACRO_END       } while (0)
#else   /* lint */
extern int _NEVER_;
#define MACRO_END       } while (_NEVER_)
#endif  /* lint */

#endif /* !MACRO_BEGIN */

/* Esto por que no deja compilar el Foundation Class 
 */
#if 0
#include <varargs.h>
#endif

#include <errno.h>
#include <signal.h>

#if defined(_M_UNIX) || defined(UnixWare) || defined(OpenUNIX) || defined(HPUX)
typedef void (*msighandler_t)(int);
#elif defined(OSF1)
typedef void (*msighandler_t)(int);
#elif defined(__linux__)
typedef __sighandler_t msighandler_t;
#elif defined(WIN32)
typedef void (__cdecl *msighandler_t)(int);
/*typedef __p_sig_fn_t msighandler_t;*/
#endif /* !WIN32 */

#include <limits.h>
#if !defined(WIN32) || !defined(_MSC_VER)
#include <unistd.h>
#endif /* !WIN32 || !_MSC_VER */
#include <sys/types.h>
#include <sys/stat.h>
#ifndef WIN32
#include <sys/times.h>
#include <sys/select.h>
#endif /* WIN32 */
#if !defined(WIN32) || !defined(_MSC_VER)
#include <sys/time.h>
#endif /* !WIN32 || !_MSC_VER */
#if !defined(OSF1) && !(defined(WIN32) || !defined(_MSC_VER))
#include <sys/unistd.h>
#endif /* !defined(OSF1) */
#include <string.h>
#if defined(_M_UNIX) || defined(UnixWare) || defined(HPUX)
#include <strings.h>
#endif /* _M_UNIX || UnixWare */

#if defined(WIN32)
#define MExport __declspec (dllexport)
#define MImport __declspec (dllimport)
#else /* !WIN32 */
#define MExport
#define MImport
#endif /* !WIN32 */


#if defined(WIN32)
typedef HANDLE dllhandle_t;

#define RTLD_LAZY	1
#define	RTLD_NOW	2

EXTERN_C MExport 
dllhandle_t dlopen (
   const char* fname,
   int flag
);

EXTERN_C MExport 
const char* dlerror ();

EXTERN_C MExport 
void* dlsym (
   dllhandle_t,
   const char*
);

EXTERN_C MExport 
void dlclose (dllhandle_t);
#define DLL_SUFFIX ".dll"
#else /* WIN32 */
#include <dlfcn.h>
typedef void* dllhandle_t;
#ifdef HPUX
#define DLL_SUFFIX ".sl"
#else /* !HPUX */
#define DLL_SUFFIX ".so"
#endif /* !HPUX */
#endif /* WIN32 */

#ifdef WIN32
#define msleep(s) Sleep((s) * 1000)
#else /* !WIN32 */
#define msleep sleep
#endif /* !WIN32 */

#if defined(__linux__) && !defined(offsetof)
#define	offsetof(s,f) ((long) &(((s *) 0) -> f))
#endif

#ifdef WIN32
#   define ETIME                   ERROR_SEM_TIMEOUT
#   define EWOULDBLOCK             WSAEWOULDBLOCK
#   define EINPROGRESS             WSAEINPROGRESS
#   define EALREADY                WSAEALREADY
#   define ENOTSOCK                WSAENOTSOCK
#   define EDESTADDRREQ            WSAEDESTADDRREQ
#   define EMSGSIZE                WSAEMSGSIZE
#   define EPROTOTYPE              WSAEPROTOTYPE
#   define ENOPROTOOPT             WSAENOPROTOOPT
#   define EPROTONOSUPPORT         WSAEPROTONOSUPPORT
#   define ESOCKTNOSUPPORT         WSAESOCKTNOSUPPORT
#   define EOPNOTSUPP              WSAEOPNOTSUPP
#   define EPFNOSUPPORT            WSAEPFNOSUPPORT
#   define EAFNOSUPPORT            WSAEAFNOSUPPORT
#   define EADDRINUSE              WSAEADDRINUSE
#   define EADDRNOTAVAIL           WSAEADDRNOTAVAIL
#   define ENETDOWN                WSAENETDOWN
#   define ENETUNREACH             WSAENETUNREACH
#   define ENETRESET               WSAENETRESET
#   define ECONNABORTED            WSAECONNABORTED
#   define ECONNRESET              WSAECONNRESET
#   define ENOBUFS                 WSAENOBUFS
#   define EISCONN                 WSAEISCONN
#   define ENOTCONN                WSAENOTCONN
#   define ESHUTDOWN               WSAESHUTDOWN
#   define ETOOMANYREFS            WSAETOOMANYREFS
#   define ETIMEDOUT               WSAETIMEDOUT
#   define ECONNREFUSED            WSAECONNREFUSED
#   define ELOOP                   WSAELOOP
#   define EHOSTDOWN               WSAEHOSTDOWN
#   define EHOSTUNREACH            WSAEHOSTUNREACH
#   define EPROCLIM                WSAEPROCLIM
#   define EUSERS                  WSAEUSERS
#   define EDQUOT                  WSAEDQUOT
#   define ESTALE                  WSAESTALE
#   define EREMOTE                 WSAEREMOTE
// Grrr! These two are already defined by the horrible 'standard'
// library.
// #define ENAMETOOLONG            WSAENAMETOOLONG
// #define ENOTEMPTY               WSAENOTEMPTY
#endif /* !WIN32 */

#if !defined(WIN32) || defined(__GNUC__)
#include <fcntl.h>
#else /* WIN32 */
#ifdef _MSC_VER
#include <fcntl.h>
#endif /* _MSC_VER */
#include <io.h>
#endif /* WIN32 */
#endif /* __MBASE_CONFIG_H__ */
