#include <stdio.h>
#include <malloc.h>
#include <stdarg.h>
#include "mbase/debug.h"

int Debug=0;

void debug_printf (
   const char* fmt,
   ...
)

{
   va_list argv;
   char *getenv();
   volatile static int initialized = 0;
   static FILE *fp = NULL;
   static char *fname;

   if (!initialized)
    {
      if ((fname=getenv("DEBUG")) != 0)
       {
         if (fp == NULL)
          {
            if (strcmp(fname,"-")==0)
               fp=stdout;
            else
               fp = fopen (fname, "a");
          }
       }
      initialized = 1;
    }

   if (fp != NULL)
    {
      va_start(argv, fmt);
      vfprintf (fp, fmt, argv); 
      va_end(argv);
      fflush (fp);
    }
}

#if 0
void debug (
   int lvl,
   const char* fmt,
   ...
)

{
    va_list argv;

    va_start(argv, fmt);
    if (Debug >= lvl) vfprintf(stderr,fmt,argv);
    va_end(argv);
}
#endif
