#ifndef __MBASE_DEBUG_H__
#define __MBASE_DEBUG_H__
#include "mbase/config.h"

#if defined(_DEBUG) && defined(WIN32) && !defined(DEBUG)
#define DEBUG
#endif /* _DEBUG && WIN32 && !DEBUG */

EXTERN_C MExport
void debug_printf(const char* fmt,...);

extern int Debug;

#if defined(DEBUG)
#define DPRINTF(s) debug_printf s
#else /* !DEBUG */
#define DPRINTF(s)
#endif /* !DEBUG */

#define EPRINTF(s) debug_printf s

EXTERN_C MExport
void debug (
   int lvl,
   const char* fmt,
   ...
);

#endif /* __MBASE_DEBUG_H__ */
