#include "mbase/config.h"
#include "mbase/debug.h"

#ifdef WIN32

static char errmsg[128];

void dlclose (
  dllhandle_t dll
)

{
   FreeLibrary((HINSTANCE)dll);
}

const char* dlerror ()

{
   FormatMessage (FORMAT_MESSAGE_FROM_SYSTEM,
                          NULL,
                          GetLastError (),
                          0,
                          errmsg,
                          sizeof errmsg / sizeof errmsg[0],
                          NULL);
   return errmsg;
}

dllhandle_t dlopen (
   const char* fname,
   int mode
)

{
   dllhandle_t dll;
   mode = mode;
   DPRINTF(("dlopen: fname=%s\n", fname));
   dll = LoadLibraryA(fname);
   DPRINTF(("dlopen: return %lx\n", dll));
   return dll;
}

void*
dlsym (
   dllhandle_t dll,
   const char* s
)

{
   void* a;
   DPRINTF(("dlsym: dll=%lx name=%s\n", dll, s));
   a = (void*) GetProcAddress (dll, s);
   DPRINTF(("dlsym: return %lx\n", a));
   return a;
}

#endif /* WIN32 */
