#include "mbase/byutils.h"
#include "mbase/float.h"

static unsigned char fltnull[]={-1,-1,-1,-1,-1,-1,-1,-1};

double mldfloat (
   const unsigned char* from
)

{
   float f;
   register unsigned char* to = (unsigned char*) &f;
   register int i;

   for (i=sizeof(float); i>0; i--)
     *to++ = *from++;
   
   return f;
}

double mldfltnull (
   const unsigned char* from,
   short* ind
)

{
   if (bycmpr(from, fltnull, sizeof(float))==0)
    {
      *ind = 1;
      return +0.0;
    }
   else
    {
      *ind = 0;
      return mldfloat(from);
    }
}

void mstfloat (
   double dbl,
   unsigned char* to
)

{
   float f = (float)dbl;
   register const unsigned char* from = (const unsigned char*) &f;
   register int i;

   for (i=sizeof(float); i>0; i--)
     *to++ = *from++;
}

double mlddbl (
  const unsigned char* from
)

{
   double dbl;
   register unsigned char* to;
   register int i;

   to = (unsigned char*) &dbl;
   for (i=sizeof(double); i>0; i--)
     *to++ = *from++;

   return dbl;
}

double mlddblnull (
   const unsigned char* from,
   short* ind
)

{
   if (bycmpr(from, fltnull, sizeof(double))==0)
    {
      *ind = 1;
      return +0.0;
    }
   else
    {
      *ind = 0;
      return lddbl(from);
    }
}

void mstdbl (
   double dbl,
   unsigned char* to
)

{
   register const unsigned char* from = (const unsigned char*) &dbl;
   register int i;

   for (i=sizeof(double); i>0; i--)
     *to++ = *from++;
}

void mstfltnull (
   double dbl,
   unsigned char* to,
   short ind
)

{
  if (ind!=0)
   {
     byfill(to, sizeof(float), -1);
   }
  else
   {
     stfloat(dbl, to);
   }
}


void mstdblnull (
   double dbl,
   unsigned char* to,
   short ind
)

{
  if (ind!=0)
   {
     byfill(to, sizeof(double), -1);
   }
  else
   {
     mstdbl(dbl, to);
   }
}
