#include "mbase/smallint.h"
#include "mbase/integer.h"

int mrstol (
   const char* buf,
   integer* l
)

{
   char neg;
   register const char* p;
   register long n;

   for (p = buf; *p==' '; p++);

   if (*p=='\0')
    {
      *l = 0x80000000;
      return 0;
    }

   neg = (*p=='-') ? 1 : 0;
   if (*p=='-' || *p=='+')
      p++;

   if (*p<'0' || *p>'9')
      return 0xfffffb43;

   for (n = 0; *p>='0' && *p<='9'; p++)
    {
      if (n<0xccccccc || (n==0xccccccc && *p<='7'))
       {
         n = 10 * n + (*p - '0');
       }
      else
       {
         return 0xfffffb41;
       }
    }

   if (*p!='\0' && *p!=' ' && *p!='\n')
      return 0xfffffb43;

   if (neg)
      n = - n;

   *l = n;
   return 0;
}

integer mldlong (
   const unsigned char to[]
)

{
#if 0
   return (ldshort(&to[0])<<16)+ldshort(&to[2]);
#else
   return (to[0]<<24)+(to[1]<<16)+(to[2]<<8)+to[3];
#endif
}

void mstlong (
   integer l,
   unsigned char *to
)

{
   to[0] = (l>>24)&0xff;
   to[1] = (l>>16)&0xff;
   to[2] = (l>>8)&0xff;
   to[3] = (l&0xff);
}
