#include "mbase/pwd.h"

#ifdef WIN32

struct passwd_node
{
   struct passwd pwd;
   struct passwd_node *next;
};

static struct passwd_node *list = 0;

static struct passwd* finduid (
   muid_t uid
)

{
   struct passwd_node *next;

   for (next=list; next!=0; next=next->next)
     if (next->pwd.pw_uid==uid)
        return &next->pwd;

   return 0;
}

/* Deberia tener un mapping de usuario a uid
 */

muid_t getuid()

{
   static muid_t my_uid = -1;

   if (my_uid==-1)
      my_uid ++;

   /*  Si no habiamos creado nuestro uid, creemos una nueva entrada
    */
   if (finduid (my_uid)==0)
    {
      struct passwd_node *node = cnew(struct passwd_node);
      node->pwd.pw_uid = my_uid;
      node->pwd.pw_name = strdup(getenv("USERNAME"));
      node->pwd.pw_passwd = 0;
      node->next = list;
      list = node;
    }
   return my_uid;
}

static struct passwd_node *node_iter;

struct passwd *getpwent()

{
   node_iter = list;

   if (node_iter==0)
      return 0;
   else
      return &node_iter->pwd;
}

struct passwd *getpwuid(muid_t uid)

{
   return finduid (uid);
}

/* No implementada por el momento
 */

struct passwd *getpwnam (const char* name)

{
   return 0;
}

void setpwent()

{
}

void endpwent()

{
   node_iter = 0;
}

#endif /* WIN32 */

