#include <stdlib.h>
#include "mbase/byutils.h"
#include "mbase/rmoney.h"

char mondecm;
char monsep;
char intlcnvrt = 0;
char monfront[8];
char monback[8];
static unsigned char is_moninit = 0;

void mrmoninit ()

{
   const char* p;

   if (!is_moninit && (p=getenv("DBMONEY"))!=0)

    {
      int i; /* esi */

      for (i = 0; i<sizeof(monfront)-1 && *p!='\0'; i++)
        {
          if (*p=='.' || *p==',')
           {
             mondecm = *p++;
             break;
           }
          if (*p<'0' || *p>'9')
           {
             monfront[i] = *p++;
           }
          else
           {
             monfront[i] = '*';
             ++p;
           }
        }

      if (i==(sizeof(monfront)-1))
         mondecm = *p++;
      monfront[i] = '\0';

      for (i = 0; i < sizeof(monback)-1; i++)
       {
          if (*p<'0' || *p>'9' || (monback[i] = *p++)=='\0')
             break;
       }
      monback[i] = '\0';
    }

   is_moninit = 1;
   if (mondecm!='.'
   ||  monfront[0]!='$'
   ||  strlen(&monfront[0])!=1
   ||  monback[0]!=0)
      intlcnvrt = 1;

   if (mondecm==',')
      monsep = '.';
   else
      monsep = ',';
}

void mrdecstr (
   char* s,
   int len
)

{
   mrmoninit();
   if (mondecm==',')
    {
      while (--len>=0)
       {
         if (*s=='.')
          {
            *s = ',';
            break;
          }
         s++;
       }
    }
}

void mrstrdec (
   char* s,
   int len
)

{
   mrmoninit();
   if (mondecm==',')
    {
      while (--len>=0)
       {
         if (*s==',')
          {
            *s = '.';
            break;
          }
         ++s;
        }
    }
}

void mrmondec (
   const char* from,
   int len,        
   char* to       
)

{
   const char* p = from;
   const char* q;

   mrmoninit();
   for (p = from; *p==' '; p++);
   for (q = &monfront[0]; *p==*q; q++, p++);
   while (p<&from[len] && *p!=monback[0])
    {
      if (*p==mondecm)
         *to = '.';
      else
        *to = *p;
      to++;
      p++;
    }
   *to = '\0';
}

void mrdecmon (
   const char* from,
   char* to,
   int len
)

{
   const char* p;
   char* q;
   const char* end;

   p = from;
   q = to;
   end = &p[byleng(p, len)];
   mrmoninit();
   strcpy(q, &monfront[0]);
   while (*q!='\0') q++;
   while (p<end)
    {
      *q = *p++;
      if (*q=='.')
         *q = mondecm;
      q++;
    }
   *q = '\0';
   strcpy(q, &monback[0]);
}

int mrfrontlen ()

{
   mrmoninit();
   return strlen(&monfront[0]);
}

int mrbacklen ()

{
   mrmoninit();
   return strlen(&monback[0]);
}
