#ifndef __MBASE_SQLDA_H__
#define __MBASE_SQLDA_H__
#include "mbase/config.h"

EXTERN_C struct msqlvar_struct;
#ifdef __cplusplus
struct MExport msqlvar_struct
#else /* !__cplusplus */
struct msqlvar_struct
#endif /* !__cplusplus */
    {
    short sqltype;		/* variable type		*/
    short sqllen;		/* length in bytes		*/
    char *sqldata;		/* pointer to data		*/
    short *sqlind;		/* pointer to indicator		*/
    char  *sqlname;		/* variable name		*/
    char  *sqlformat;		/* reserved for future use 	*/
    short sqlitype;		/* ind variable type		*/
    short sqlilen;		/* ind length in bytes		*/
    char *sqlidata;		/* ind data pointer		*/

#if defined(__cplusplus) && __cplusplus
public:
    msqlvar_struct();
    msqlvar_struct(const msqlvar_struct&);
public:
    void set_null();
    int is_null();
public:
    void map();
    int size();
    int align(int pos);
    int free(char *pos);
    int init(char *pos);
    int bind(char *pos);
public:
    struct msqlvar_struct& operator=(const struct msqlvar_struct&);
#endif /* __cplusplus && __cplusplus */
    };

EXTERN_C struct msqlda;
#if defined(__cplusplus)
struct MExport msqlda
#else /* !__cplusplus */
struct msqlda
#endif /* __cplusplus */
    {
    short sqld;
    struct msqlvar_struct *sqlvar;
#if defined(__cplusplus) && __cplusplus
public:
    msqlda(int n=0);
    ~msqlda();
public:
    int size();
    int align();
    int is_null();
    void set_null();
public:
    void map();
    int free(char *row);
    int init(char *row);
    int bind(char *row);
public:
    struct msqlvar_struct& operator[](int);
#endif /* __cplusplus && __cplusplus */
    };

EXTERN_C MExport  int rdescisnull (
   struct msqlda *sqlda_ptr
);

/************************************************************************/
/* Inicializa los valores del registro en msqlda a null.   		*/
/************************************************************************/

EXTERN_C MExport void rdescsetnull (
   struct msqlda *sqlda_ptr
);

/************************************************************************/
/* Libera un descriptor que habia sido asignado del heap.		*/
/************************************************************************/

EXTERN_C MExport int freedesc (
   struct msqlda *sqlda_ptr
);

/************************************************************************/
/* Libera un descriptor que habia sido asignado del heap.		*/
/************************************************************************/

EXTERN_C int MExport freerowdesc (
   struct msqlda *sqlda_ptr,
   char *rowdata
);

/************************************************************************/
/* Asigna espacio de la memoria libre para el manejo de los descriptores*/
/************************************************************************/

EXTERN_C MExport struct msqlda *allocdesc (
   int n
);

/************************************************************************/
/* Encuentra el numero de caracteres requeridos por un descriptor	*/
/************************************************************************/

EXTERN_C MExport int descsize (
   struct msqlda *sqlda_ptr
);

/************************************************************************/
/* Construye una copia del descriptor.					*/
/************************************************************************/

EXTERN_C MExport struct msqlda *dupdesc (
   struct msqlda *sqlda_ptr
);

/************************************************************************/
/* Realiza el binding de una estructura sqlda a una zona de memoria.	*/
/************************************************************************/

EXTERN_C MExport int initdesc (
   struct msqlda *sqlda_ptr,
   char *pos
);

/************************************************************************/
/* Realiza el binding de una estructura sqlda a una zona de memoria.	*/
/************************************************************************/

EXTERN_C MExport int binddesc (
   struct msqlda *sqlda_ptr,
   char *pos
);

EXTERN_C MExport struct msqlvar_struct *findsqlname (
   struct msqlda *sqlda_ptr,
   char *colname
);

EXTERN_C MExport void initsqldael (
   struct msqlda *sqlda_ptr,
   int sqld,
   struct msqlvar_struct *sqldvar
);

EXTERN_C MExport void initsqlvar (
   struct msqlvar_struct *sqldvar,
   char sqlname[],
   int sqltype,
   int sqllen,
   void *sqldata
);

EXTERN_C MExport struct msqlvar_struct *findsqlstack (
   int nsqlda,
   struct msqlda *sqlda_stack[],
   char colname[]
);

EXTERN_C MExport void mapdesc (
   struct msqlda *sqlda_ptr
);

EXTERN_C MExport void dumpcvar (
   char cname[],
   int ctype,
   int clength,
   void *cvar
);

EXTERN_C MExport void dumpsqlvar (
   struct msqlvar_struct *sqldvar
);

EXTERN_C MExport void dumpsqlda (
   struct msqlda *sqlda_ptr
);

#ifdef DEBUG
#define DUMPSQLVAR(sqlvar) dumpsqlvar(sqlvar)
#define DUMPSQLDA(desc) dumpsqlda(desc)
#else /* !DEBUG */
#define DUMPSQLVAR(sqlvar)
#define DUMPSQLDA(desc)
#endif /* !DEBUG */

#if !defined(NO_INFORMIX_MAP)
#define sqlda msqlda
#define sqlvar_struct msqlvar_struct
#endif /* NO_INFORMIX_MAP */

#endif /* __MBASE_SQLDA__ */
