#include "mbase/vstring.h"

void mvstring_realloc (
   mvstring vs,
   int len
)

{
   if (vs->maxlen==0 && len>0)
    {
      vs->data = malloc(len + 1);
      vs->maxlen = len;
    }
   else if (vs->maxlen < len)
    {
       vs->data = realloc(vs->data, len + 1);
       vs->maxlen = len;
    }
   vs->len = len;
}

mvstring 
mvstring_alloc (
   mvstring vs
)

{
    vs->maxlen = 0;
    vs->len = 0;
    vs->data = 0;
    return vs;
}

void mvstring_setnull (
   mvstring vs
)

{
  if (vs->data!=0)
   {
     vs->data[0] = '\0';
   }
  vs->len = 0;
}

int mvstring_memcpy (
   mvstring vs,
   const char *from,
   int len
)

{
   if (len<0)
    {
      len = 0;
    }
   mvstring_realloc (vs, len);
   memcpy (vs->data, from, len);
   if (vs->data!=0)
    {
      vs->data[len] = '\0';
    }
   return 0;
}

mvstring mvstring_assign (
   mvstring to,
   const mvstring from
)

{
    mvstring_memcpy (to, from->data, from->len);
    return to;
}

int mvstring_copy (
   mvstring vs,
   const char *s
)

{
   return mvstring_memcpy(vs, s, s?strlen(s):0);
}

void mvstring_free (
   mvstring vs
)

{
   if (vs->data)
    {
      free(vs->data);
      vs->data = 0;
    }
   vs->len = 0;
   vs->maxlen = 0;
}
